#include <math.h>

#include "life.h"
#include "lsUsrFitness.h"

int	LsUsrFitness(double **y, int num_row, int num_col, int ls_ret, double *fitness)
{
	int	i;

	*fitness = 0;
	if(ls_ret == -1){
		*fitness = -10000;
		goto out;
	}

	for(i = 0; i < num_row; i++){
		register double real_y1;
		register double real_y2;
		register double x;
		
		x = y[i][0];
		real_y1 = (3 * exp(x) + exp(-3 * x))/4;
		real_y2 = 3*(exp(x) - exp(-3 * x))/4;

		*fitness += pow((real_y1 - y[i][1])/(real_y1 == 0 ? 1.0 : real_y1), 2);
		*fitness += pow((real_y2 - y[i][2])/(real_y2 == 0 ? 1.0 : real_y2), 2);
	}

	*fitness *= -1;
out:
	return 0;
}	

void usr_fvec(double fvec[], double y[], double Gene, Parameter *p)
{
	double *Keq	= p->val[1];

	fvec[  1] = Keq[1] * y[2];
	fvec[  2] = Keq[2] * y[1] + Keq[3] * y[2];
}

void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], double Gene, Parameter *p)
{
}
