/*
 * TITLE:Anaerobic Fermentation Pathway in Saccharomyces cerevisiae
 * INFO:
 * CONVERSION TYPE
 *     GENE-PROTEIN:NONE
 *     METABOLIC:GMA
 */
#include "stdio.h"
#include<math.h>
#include "life.h"
#include "lsUsrFitness.h"

int     LsUsrFitness(double **y, int num_row, int num_col, int ls_ret, double *fitness)
{
        int     i, j;
        double x[5]={3.4521e-02,1.0141e+00,9.1823e+00,9.5514e-03,1.1278e+00};

        if(ls_ret == -1){
                *fitness = -10000000000;
                goto out;
        }
        *fitness = 0;

        for(i = 0; i < num_row; i++){
                for(j = 0; j < num_col; j++){
                        *fitness += -(y[i][j]-x[j])*(y[i][j]-x[j])/x[j];
                }
        }

  out:
        return 0;
}

void usr_fvec(double fvec[], double y[], double Gene, Parameter *p)
{
	double *constantPlayer= p->val[1];
	double *kxg= p->val[2];
	double *f= p->val[3];

	fvec[  1] = kxg[1]*pow(constantPlayer[1], f[1])*pow(y[2], f[2]) - kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4])*pow(y[5], f[5]);
	fvec[  2] = kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4])*pow(y[5], f[5]) - kxg[3]*pow(constantPlayer[5], f[6])*pow(y[2], f[7]) - kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9])*pow(y[5], f[10]);
	fvec[  3] = kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9])*pow(y[5], f[10]) - kxg[5]*pow(constantPlayer[8], f[11])*pow(y[3], f[12])*pow(y[4], f[13])*pow(y[5], f[14]) - 0.5*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(y[5], f[17])*pow(constantPlayer[9], f[18]);
	fvec[  4] = kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(y[5], f[17])*pow(constantPlayer[9], f[18]) - kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[3], f[21])*pow(y[5], f[22]);
	fvec[  5] = kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(y[5], f[17])*pow(constantPlayer[9], f[18]) + kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[3], f[21])*pow(y[5], f[22]) - kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4])*pow(y[5], f[5]) - kxg[3]*pow(constantPlayer[5], f[6])*pow(y[2], f[7]) - kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9])*pow(y[5], f[10]) - kxg[8]*pow(constantPlayer[13], f[23])*pow(y[5], f[24]);
}

void usr_fjac(double fjac[][MAX_VAR_NUM], double y[], double Gene, Parameter *p)
{
	double *constantPlayer= p->val[1];
	double *kxg= p->val[2];
	double *f= p->val[3];

	fjac[  1][  1] = -f[4]*pow(y[1], f[4] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[5], f[5]);
	fjac[  1][  2] = f[2]*pow(y[2], f[2] - 1)*kxg[1]*pow(constantPlayer[1], f[1]);
	fjac[  1][  5] = -f[5]*pow(y[5], f[5] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4]);
	fjac[  2][  1] = f[4]*pow(y[1], f[4] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[5], f[5]);
	fjac[  2][  2] = -f[7]*pow(y[2], f[7] - 1)*kxg[3]*pow(constantPlayer[5], f[6]) - f[9]*pow(y[2], f[9] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[5], f[10]);
	fjac[  2][  5] = f[5]*pow(y[5], f[5] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4]) - f[10]*pow(y[5], f[10] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9]);
	fjac[  3][  2] = f[9]*pow(y[2], f[9] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[5], f[10]);
	fjac[  3][  3] = -f[12]*pow(y[3], f[12] - 1)*kxg[5]*pow(constantPlayer[8], f[11])*pow(y[4], f[13])*pow(y[5], f[14]) - f[16]*pow(y[3], f[16] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[5], f[17])*pow(constantPlayer[9], f[18])*0.5;
	fjac[  3][  4] = -f[13]*pow(y[4], f[13] - 1)*kxg[5]*pow(constantPlayer[8], f[11])*pow(y[3], f[12])*pow(y[5], f[14]);
	fjac[  3][  5] = f[10]*pow(y[5], f[10] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9]) - f[14]*pow(y[5], f[14] - 1)*kxg[5]*pow(constantPlayer[8], f[11])*pow(y[3], f[12])*pow(y[4], f[13]) - f[17]*pow(y[5], f[17] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(constantPlayer[9], f[18])*0.5;
	fjac[  4][  3] = f[16]*pow(y[3], f[16] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[5], f[17])*pow(constantPlayer[9], f[18]) - f[21]*pow(y[3], f[21] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[5], f[22]);
	fjac[  4][  4] = -f[20]*pow(y[4], f[20] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[3], f[21])*pow(y[5], f[22]);
	fjac[  4][  5] = f[17]*pow(y[5], f[17] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(constantPlayer[9], f[18]) - f[22]*pow(y[5], f[22] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[3], f[21]);
	fjac[  5][  1] = -f[4]*pow(y[1], f[4] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[5], f[5]);
	fjac[  5][  2] = -f[7]*pow(y[2], f[7] - 1)*kxg[3]*pow(constantPlayer[5], f[6]) - f[9]*pow(y[2], f[9] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[5], f[10]);
	fjac[  5][  3] = f[16]*pow(y[3], f[16] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[5], f[17])*pow(constantPlayer[9], f[18]) + f[21]*pow(y[3], f[21] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[5], f[22]);
	fjac[  5][  4] = f[20]*pow(y[4], f[20] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[3], f[21])*pow(y[5], f[22]);
	fjac[  5][  5] = f[17]*pow(y[5], f[17] - 1)*kxg[6]*pow(constantPlayer[10], f[15])*pow(y[3], f[16])*pow(constantPlayer[9], f[18]) + f[22]*pow(y[5], f[22] - 1)*kxg[7]*pow(constantPlayer[12], f[19])*pow(y[4], f[20])*pow(y[3], f[21]) - f[5]*pow(y[5], f[5] - 1)*kxg[2]*pow(constantPlayer[3], f[3])*pow(y[1], f[4]) - f[10]*pow(y[5], f[10] - 1)*kxg[4]*pow(constantPlayer[6], f[8])*pow(y[2], f[9]) - f[24]*pow(y[5], f[24] - 1)*kxg[8]*pow(constantPlayer[13], f[23]);
}




