/*-----------------------------------------------------------
 *
 * Differetiation
 *
 */
#include "pdiff.h"

/* եƽдؿΥץȥ */
static Node_T *add_emptyChild(Node_T *my_node);
static Node_T *insert_childNode (Node_T *pre_node, Token_T *token);
static Node_T *insert_parentNode (Node_T *pre_node, Token_T *token);
static Node_T * del_node(Node_T *node);
static Node_T *seek_same(Node_T *current, int rank);
static Node_T *seek_bracket(Node_T *current);
static Node_T *create_node(void);
static int set_oprator (Node_T *my_node, Token_T *token);
static int set_operand (Node_T *my_node, Token_T *token);
static int get_token (char **lint, Token_T *token);
static int check_token (Token_T *current, Token_T *pre);
static void add_bracket(char *line);
static void del_bracket(char *line);
static int diff_add(Node_T *my_node, Diff_T *diffData, char *answer);
static int diff_subtract(Node_T *my_node, Diff_T *diffData, char *answer);
static int diff_multiply(Node_T *my_node, Diff_T *diffData, char *answer);
static int diff_divide(Node_T *my_node, Diff_T *diffData, char *answer, int f_isCType);
static int diff_power(Node_T *my_node, Diff_T *diffData, char *answer, int f_isCType);
static int multiply(char *strL, char *strR, int f_L, int f_R, char *answer);
static void print_node(Node_T *node, char *title);


/*** Make_node() **************************************
 *
 * ƥȤɤ߹ǿTree¤Ÿ롣
 * 
 *	expr:ϥƥ
 *	root:ŸꥹȤΥ롼
 *
 *	ϥƥȤŸ뱦ռȤʤäƤ뤳Ȥ󡣶ϴޤޤƤ⤤
 *	黻ҡѿ̰ʳޤǤϤʤʤ
 *	 get_token()ǥƥȤ'('')'ڥ졼ڥ(var/char)ʬ򤷡
 *	check_token()ǳ̤ΥХ󥹤åʤʤ롣
 *	 ȡμȽˤäƼ黻ñ̤ǥΡɤŸƤ
 *	ռƤΡɤŸ顢Set_expr()ˤꡢƥΡɤŸ
 *	ƵŪ˺ƹ롣
 *
 */
int 
Make_node (Node_T **root, char *expr)
{
	char *tline;
	Token_T token, pre_token;
	Node_T *current;
	
	memset(&token, 0, sizeof(token));
	memset(&pre_token, 0, sizeof(pre_token));

	if ((current = create_node()) == NULL) {
		log_sys("#  Cannot create node at Make_node.\n");
		goto ERR;
	}
	*root = current;
	
	tline = expr;
	for (;;) {
		if (get_token(&tline, &token)) goto ERR;
		if (check_token(&token, &pre_token)) goto ERR;
		pre_token=token;
		if (token.op == '\0') {	/* ռλ */
			if ((current->parent == NULL) && (current->op == '\0')) {
				/* դ˱黻Ҥ1Ĥ̵Τν */
				current->charR = strdup("0");
			}
			return 0;
		} else if (token.op == '(' ) {	/* '(' äե饰ΩƤ롣*/
			if (current->f_bracket || current->op != '\0') {
				current = add_emptyChild(current);
				if (current == NULL) goto ERR;
			}
			current->f_bracket = true;
		} else if (token.op == ')') {	/* ')' äե饰ΩäƤ롣*/
			current = seek_bracket(current);
			current->f_bracket = false;
			if (current->op == '\0') {
				if (current->charL == NULL) {
					/* ʳ̤ˤ̵̤ʥΡɤʤΤǺ */
					current = del_node(current);
					if (current != NULL) {
						if (current->parent == NULL) {
							*root = current;
						}
					} else {
						goto ERR;
					}
				} else {
					/*
					 *	ڥɤΤߤϤ褦ʲʳ̡
					 *	parent  charL Ƥ charR ˰ܤΡɤ
					 *	parent ʤв⤷ʤ
					 */
					if (current->parent) {
						current->parent->charR = current->charL;
						current->parent->rank_charR = current->rank_charL;
						current = current->parent;
						free( (void *) current->childR);
						current->childR = NULL;
					}
				}
			} else {	/* ̾Ĥ̤Ǥ */
				/* ΥΡ(黻)Ф()ĤƤݤΥե饰ΩƤ */
				current->f_chunk = true;
			}
		} else if (token.rank > R_NULL) {	/* ڥ졼ä*/
			if (current->op=='\0') {	/* ڥ졼ƤʤХå*/
				if (set_oprator(current, &token)) goto ERR;
			} else {	/* ڥ졼åȤƤС*/
				if (current->charR==NULL && current->childR==NULL) {
					/* RʤΤϥ顼*/
					log_sys("#  charR is expected before making new node.\n");
					goto ERR;
				} else {	
					if ((!current->f_chunk) && (token.rank > current->rank)) {
						/* ͥ٤⤱лR롣*/
						current = insert_childNode(current, &token);
						if (current == NULL) goto ERR;
					} else {	/* Ʊ㤱Ʊʲޤ(,rootõ */
						if (current->parent == NULL || current->f_bracket) {
								/* current is current */
						} else {
							current = seek_same(current->parent, token.rank);
						}
						if (current->op == '\0') {
							/* ڥ졼ʤХå */
							current->op = token.op;
							current->rank = token.rank;
						} else {
							/* ڥ졼åȺѤߤǤ */
							if (current->f_chunk || current->rank >= token.rank) {
								/* Ρɤ()ǰϤޤƤ뤫		*
								 *  ƱʾΥ󥯤ǤпƤ	*/
								DBGW(20, ("Make_node BF ins_p '%c':%p\n",
													   	current->op, current));
								current = insert_parentNode(current, &token);
								DBGW(20, ("Make_node AF ins_p '%c':%p L-P:%p\n",
										current->op, current, current->childL->parent));
								if (current == NULL) goto ERR;
								if (current->parent == NULL) {	/* 줬root */
										*root = current;
								}
							} else {
								/* Ҥ */
								DBGW(20, ("Make_node BF ins_c '%c':%p\n",
													   	current->op, current));
								current = insert_childNode(current, &token);
								DBGW(20, ("Make_node AF ins_c '%c':%p L-P:%p\n",
										current->op, current, current->childL->parent));
								if (current == NULL) goto ERR;
							}
						}
					}
				}
			}
		} else {	// ڥɤǤ
			if (set_operand (current, &token)) goto ERR;
		}
	}

ERR:
	log_sys("#  in '%s'\n", expr);
	log_sys("#  just before '%s'\n", tline);
	if (token.op == 'a' || token.op == 'v') {
		log_sys("#  token.expr = '%s'\n", token.expr);
	} else {
		log_sys("#  token.op = '%c'\n", token.op);
	}
	log_sys("## Error in Make_node.\n");
	return -1;
}

/*** insert_parentNode() **********************************************
 *
 * оݥΡɤξ˿ƥΡɤ
 *
 *	о()ΡɤϿΡɤλLȤʤ롣
 *	ΡɤΡɤѤΤϥΡɴ֤δط'('
 */
static Node_T * insert_parentNode (Node_T *pre_node, Token_T *token)
{
	Node_T * new_node;

#if DBG
	print_node(pre_node, "pre_node at insert_parent IN");
#endif
	if ((new_node = create_node()) == NULL) {
		log_sys("#  Cannot create node.\n");
		goto ERR;
	}
	new_node->parent = pre_node->parent;
	new_node->op = token->op;
	new_node->rank = token->rank;
	new_node->childL = pre_node;
	/* '('ΰѤ */
	new_node->f_bracket = pre_node->f_bracket;
	pre_node->f_bracket = false;
	if (pre_node->parent != NULL) {
		/* ΡɤοƥΡɤäν */
		if (pre_node->parent->childL == pre_node) {
			pre_node->parent->childL = new_node;
		} else if (pre_node->parent->childR == pre_node) {
			pre_node->parent->childR = new_node;
		} else {
			log_sys("#  Cannot find parent.\n");
			goto ERR;
		}
	}
	pre_node->parent = new_node;
	DBGW(20, ("ins_parent pre='%c':%p, new:%p\n", pre_node->op, pre_node, new_node));
#if DBG
	print_node(new_node, "new_node at insert_parent OUT");
#endif
		
	return new_node;

ERR:
	log_sys("## Error in insert_parent.\n");
	return NULL;
}

/*** insert_childNode() **********************************************
 *
 * оݥΡɤβ˻ҥΡɤ
 *
 *	Ρɤо()ΡɤλRȤʤ롣
 *	ΡɤϵΡɤR-L-ȤưѤ
 */
static Node_T * insert_childNode (Node_T *pre_node, Token_T *token)
{
	Node_T * new_node;
	
#if DBG
	print_node(pre_node, "pre_node at insert_child IN");
#endif
	if ((new_node = create_node()) == NULL) {
		log_sys("#  Cannot create node.\n");
		goto ERR;
	}
	new_node->parent = pre_node;
	new_node->op = token->op;
	new_node->rank = token->rank;
	/* ΡɤR-ΰϤ */
	new_node->charL = pre_node->charR;
	new_node->childL = pre_node->childR;
	new_node->rank_charL = pre_node->rank_charR;
	if (pre_node->childR) pre_node->childR->parent = new_node;
	/* ΡɤΡɤλRȤ */
	pre_node->childR = new_node;
	pre_node->charR = NULL;
		
	DBGW(20, ("ins_child pre='%c':%p, new:%p\n", pre_node->op, pre_node, new_node));
#if DBG
	print_node(new_node, "new_node at insert_child OUT");
#endif
	
	return new_node;

ERR:
	log_sys("## Error in insert_childNode.\n");
	return NULL;
}

/*** add_emptyChild() **********************************************
 *
 * ʥΡɤopʤǺ롣
 * (f_bracketΩäƤoropåȤƤ'('褿硣)
 */
static Node_T * add_emptyChild (Node_T *pre_node)
{
	Node_T * new_node;

#if DBG
	print_node(pre_node, "pre_node at add_emptyChild IN");
#endif
	if ((new_node = create_node()) == NULL) {
		log_sys("#  Cannot create node.\n");
		goto ERR;
	}
	if (pre_node->op=='\0') {	/* ڥ졼ʤLR롣*/
		if (pre_node->childL != NULL) {
			log_sys("#  Have no operator but it have left-node.\n");
			goto ERR;
		}
		pre_node->childL = new_node;
	} else {
		if (pre_node->childR != NULL) {
			log_sys("#  Have operator but it have right-node.\n");
			goto ERR;
		}
		pre_node->childR = new_node;
	}
	new_node->parent = pre_node;

	DBGW(20, ("ins_empty pre='%c':%p, new:%p\n", pre_node->op, pre_node, new_node));
#if DBG
	print_node(new_node, "new_node at add_emptyChild OUT");
#endif

	return new_node;

ERR:
	log_sys("## Error in add_emptyChild.\n");
	return NULL;
}

/*** del_node() **********************************************
 *
 * оݥΡɤ
 *
 *	 ̵̤ʳ̤ˤҥΡɤLeft˿ӤΤǺ¸ߤΤ
 *	LǤ뤫餢Фnew_currentȤ(rootǤʤ)³롣
 */
static Node_T *del_node(Node_T *node)
{
	Node_T *new_current = NULL;
	
#if DBG
	print_node(node, "del_node IN :del_node");
#endif
	if (node->childL != NULL) {
		/* оݥΡɤ˻LФcurrent_nodeȤ */
		new_current = node->childL;
		new_current->parent = node->parent;
	} else {
		log_sys("#  Cann't find new current-node at del_node.\n");
	}
	if (node->parent) {
		/* оݥΡɤrootǤʤnew_current򿷤ʻҤȤ³ */
		if (node->parent->childL == node) {
			node->parent->childL = new_current;
		} else if (node->parent->childR == node) {
			node->parent->childR = new_current;
		}
	}	/* rootξϾ̤ǽ */
	if (node->charL || node->charR || node->expr || node->diff || node->childR) {
		log_sys("## Never come here!! in del_node\n");
	}

	free((void *) node);
	
	DBGW(20, ("del_node :%p, new:%p\n", node->op, node, new_current));
#if DBG
	if (new_current) {
		print_node(node, "del_node OUT :new_current");
	} else {
		printf("del_node OUT :new_current is NULL.\n");
	}
#endif
	
	return new_current;
}

/*** print_node() **********************************************
 *
 * оݥΡɤƤǥХåѤ˽Ϥ롣
 *
 */
static void print_node(Node_T *node, char *title)
{
	void print_own(Node_T *node);

	/* Title & own info. */
	DBGW(20, ("$$$ %s\n", title));
	print_own(node);

#if 1
	/* parent info. */
	DBGW(20, ("$$$        --- PARENT ---\n"));
	if (node->parent != NULL) {
		print_own(node->parent);
	} else {
		DBGW(20, ("$$$ have no parent.\n"));
	}

	/* Left info. */
	DBGW(20, ("$$$        --- LEFT ---\n"));
	if (node->childL != NULL) {
		print_own(node->childL);
	} else {
		DBGW(20, ("$$$ have no left.\n"));
	}

	/* Right info. */
	DBGW(20, ("$$$        --- RIGHT ---\n"));
	if (node->childR != NULL) {
		print_own(node->childR);
	} else {
		DBGW(20, ("$$$ have no right.\n"));
	}
	DBGW(20, ("\n"));
#endif
}

/*** print_own() **********************************************
 *
 * оݥΡɤƤǥХåѤ˽Ϥ롣
 *
 */
void print_own(Node_T *node)
{
	/* own info. */
	DBGW(20, ("$$$ address:%p\n", node));
	DBGW(20, ("$$$ op     :'%c'\n", node->op));
	DBGW(20, ("$$$ rank   :%d\n", node->rank));
	DBGW(20, ("$$$ f_bra  :%d\n", node->f_bracket));
	DBGW(20, ("$$$ f_chunk:%d\n", node->f_chunk));
	DBGW(20, ("$$$ expr   :'%s', rank:%d\n", node->expr, node->rank_expr));
	DBGW(20, ("$$$ diff   :'%s', rank:%d\n", node->diff, node->rank_diff));
	DBGW(20, ("$$$ charL  :'%s', rank:%d\n", node->charL, node->rank_charL));
	DBGW(20, ("$$$ charR  :'%s', rank:%d\n", node->charR, node->rank_charR));
}

/** seek_same() ******************************
 * 
 * rankߤƱ̤rankοƥΡɤܤ֤
 * ˥ڥ졼̵⤷f_bracketΩäƤ
 * ΡɤФΥΡɤ֤
 * rootޤǹԤäƤ⸫Ĥʤroot֤
 * 
 */
static Node_T *seek_same(Node_T *current, int rank)
{

	if (current->f_bracket || current->rank <= rank ||
				   	current->parent == NULL || current->op == '\0') {
		return current;
	} else {
		return seek_same(current->parent, rank);
	}

}

/** seek_bracket() ******************************
 * 
 * f_bracketե饰ΩäƤΡɤõ
 * rootޤǹԤäƤ⸫ĤʤNULL֤
 * 
 */
static Node_T *seek_bracket(Node_T *current)
{

	if (current->f_bracket) {
		return current;
	} else if (current->parent == NULL) {
		return NULL;
	} else {
		return seek_bracket(current->parent);
	}

}

/** Seek_root() ******************************
 * 
 * root õ
 * 
 */
Node_T *Seek_root(Node_T *my_node)
{

	if (my_node->parent == NULL) {
		return my_node;
	} else {
		return Seek_root(my_node->parent);
	}

}
			
/** create_node() ******************************
 * 
 * callocnodeΰݤΥݥ󥿤֤
 * 
 */
static Node_T *create_node(void)
{

	return (Node_T *) calloc(1, sizeof(Node_T));

}

/*** Del_tree() ****************************************************
 *
 * ƵŪˤΥΡTreefree롣
 *
 */
void
Del_tree (Node_T *my_node)
{
	if (my_node->childL) Del_tree(my_node->childL);
	if (my_node->childR) Del_tree(my_node->childR);

	DBGW(20, ("$$ DEL-Node address:%p, op:'%c'\n", my_node, my_node->op));

	if (my_node->charL) free((void *) my_node->charL);
	if (my_node->charR) free((void *) my_node->charR);
	if (my_node->expr) free((void *) my_node->expr);
	if (my_node->diff) free((void *) my_node->diff);
	if (my_node->childL) free((void *) my_node->childL);
	if (my_node->childR) free((void *) my_node->childR);
}

/*** set_operand() ********************************
 *
 * ڥɤ򥻥åȤ롣
 */
static int set_operand (Node_T *my_node, Token_T *token)
{
	if (my_node->op=='\0') {	/* ڥ졼åȤƤʤLchar˥å */
		if (my_node->charL!=NULL) {
			log_sys("#  charL must be NULL : setting operand & op=NULL.\n");
			goto ERR;
		}
		if (my_node->charL != NULL) free((void *) my_node->charL);
		my_node->charL = token->expr;
		if (token->op == 'v') {
			my_node->rank_charL = R_5VAL;
		} else if (token->op == 'a') {
			my_node->rank_charL = R_4CHAR;
		}
	} else {  // ڥ졼åȤƤRchar˥å
		if (my_node->charR!=NULL) {
			log_sys("#  charR must be NULL : setting operand & have op.\n");
			goto ERR;
		}
		if (my_node->charR != NULL) free((void *) my_node->charR);
		my_node->charR = token->expr;
		if (token->op == 'v') {
			my_node->rank_charR = R_5VAL;
		} else if (token->op == 'a') {
			my_node->rank_charR = R_4CHAR;
		}
	}

	return 0;

ERR:
	log_sys("## Error in set_operand.\n");
	return -1;
}

/*** set_operator() ************************************
 *
 * ڥ졼򥻥åȤ롣
 */
static int set_oprator (Node_T *my_node, Token_T *token)
{
	if ((my_node->childL==NULL) && (my_node->charL==NULL)) {
		/* ñ༰ˤʤΤ'-'ΤȤ */
		if (token->op == '-') {
				my_node->op = token->op;
			my_node->rank = token->rank;
		} else {
			log_sys("#  op='%c' is not allowed here.\n", token->op);
			goto ERR;
		}
	} else {
		my_node->op = token->op;
		my_node->rank = token->rank;
	}

	return 0;

ERR:
	log_sys("## Error in set_oprator.\n");
	return -1;
}

/** get_token ***************************************
 * 
 * ʸ󤫤黻ҤӥڥɤڤФtoken֤
 * char token.op	: 黻Ҥӳ̤֤ڥɤξ'a'(ͤ'v')֤
 * int token.rank	: 黻Ҥ̤֤ͥ黻ҰʳξR_NULL֤
 * char *token.expr: ڥɤ֤freeϸƤӽФ¦ǹԤȡ
 * 
 *	rank: R_1PLUS:'+','-' R_2MULT:'*','/' R_3POW:'^'
 */
static int get_token (char **line, Token_T *token)
{
	char tline[BUFFSIZE];
	char *cp, *cpt;
	int f_inBracket=false;

	token->op = '\0';
	token->rank = R_NULL;
	token->expr = NULL;

	cp = *line;

	for (;;) {
		if (*cp == ' ' || *cp == '\t' || *cp == '\n') {
			cp++;
		} else {
			break;
		}
	}
	
	if (*cp == '\0') {
		return 0;
	} else if (*cp == '(' || *cp == ')' ) {
		token->op = *cp++;
	} else if (*cp == '+' || *cp == '-' ) {
		token->op = *cp++;
		token->rank = R_1PLUS;
	} else if (*cp == '*' || *cp == '/' ) {
		token->op = *cp++;
		token->rank = R_2MULT;
	} else if (*cp == '^' ) {
		token->op = *cp++;
		token->rank = R_3POW;
	} else if (isdigit(*cp) || *cp == '.' ) {	/*  */
		token->op = 'v';
		double val;
		val = strtod(cp, line);
		if (val != 0.0) {
			sprintf(tline, "%g", val);
			token->expr = strdup(tline);
			return 0;
		} else {
			log_sys("#  Invalid value expression.\n");
			return -1;
		}
	} else {
		token->op = 'a';
		cpt = tline;
		for (;;) {
			if (*cp == ' ' || *cp == '\t' || *cp == '\r' || *cp == '\n') {
				cp++;
				continue;
			} else if (*cp == '[') {
				f_inBracket = true;
			} else if (*cp == ']') {
				f_inBracket = false;
			} else if (!f_inBracket && (*cp == '(' || *cp == ')' || *cp == '+'
				|| *cp == '-' || *cp == '*' || *cp == '/' || *cp == '^' || *cp == '\0')) {
				*cpt = '\0';
				token->expr = strdup(tline);
				break;
			}
			*cpt++ = *cp++;
		}
	}
	*line = cp;
	return 0;
}

/** check_token ***************************************
 * 
 * token¤Ӥå롣
 * 
 */
static int check_token (Token_T *current, Token_T *pre)
{
	if (pre->op == '\0') {	/* ǽ */
		if (current->op == ')' || current->rank > R_1PLUS) {
			log_sys("#  '%c' doesnot come first.\n", current->op);
			goto ERR;
		}
	} else if (pre->op == '(') {
		if (current->op == ')' || current->rank > R_1PLUS) {
			log_sys("#  previous: '%c', current: '%c'\n", pre->op, current->op);
			goto ERR;
		}
	} else if (pre->op == ')') {
		if (current->op == '(') {
			log_sys("#  previous: '%c', current: '%c'\n", pre->op, current->op);
			goto ERR;
		} else if (current->op == 'a' || current->op == 'v') {
			log_sys("#  previous: '%c', current: '%s'\n", pre->op, current->expr);
			goto ERR;
		}
	} else if (pre->op == 'a' || pre->op == 'v') {
		if (current->op == '(') {
			log_sys("#  previous: '%s', current: '%c'\n", pre->expr, current->op);
			goto ERR;
		} else if (current->op == 'a' || current->op == 'v') {
			log_sys("#  previous: '%s', current: '%s'\n", pre->expr, current->expr);
			goto ERR;
		}
	} else {	/* operator */
		if (current->op == ')' || current->rank > R_NULL) {
			log_sys("#  previous: '%c', current: '%c'\n", pre->op, current->op);
			goto ERR;
		}
	}
	
	if (current->op == '(') current->bra++;
	if (current->op == ')') current->cket++;
	if ((current->bra - current->cket) < 0) {
		log_sys("#  Bad brackets balance. open:%d, close:%d\n", current->bra, current->cket);
		goto ERR;
	}

	if (current->op == '\0') {	/* Ǹ */
		if (pre->op == '(' || pre->rank > R_NULL) {
			log_sys("#  '%c' doesnot come last.\n", pre->op);
			goto ERR;
		}
		if (current->bra != current->cket) {
			log_sys("#  Bad brackets balance. open:%d, close:%d\n", current->bra, current->cket);
			goto ERR;
		}
	}
	
	return 0;

ERR:
	log_sys("#  Forbidden token row.\n");
	return -1;
}

/*** Set_expr() ****************************************************
 *
 * ƵŪˤΥΡɰʲμƹ롣
 *
 */
int
Set_expr (Node_T *my_node, int f_isCType)
{
	char my_expr[BUFFSIZE], exprL[BUFFSIZE], exprR[BUFFSIZE];
	int f_single=false, rank_exprL=R_NULL, rank_exprR=R_NULL, my_rank, f_isGeneral=true;
	double val = 0.0;

	memset(my_expr, 0, sizeof(my_expr));
	memset(exprL, 0, sizeof(exprL));
	memset(exprR, 0, sizeof(exprR));

#if DBG
	print_node(my_node, "set_exper IN");
#endif
	if (my_node->childL) {	/* L */
		DBGW(20, ("Set_expr :GO Left  %p to %p\n", my_node, my_node->childL));
		if (Set_expr(my_node->childL, f_isCType)) goto ERR;
		strcpy(exprL, my_node->childL->expr);
		rank_exprL = my_node->childL->rank_expr;
		if (my_node->charL) {	/* ξ˥åȤƤ饨顼 */
			log_sys("#  Duplicate expressions.\n");
			log_sys("#  charL :%s.\n", my_node->charL);
			log_sys("#  exprL:%s.\n", exprL);
			goto ERR;
		}
	} else {	/* L̵ */
		if (my_node->charL) {
			strcpy(exprL, my_node->charL);
			rank_exprL = my_node->rank_charL;
		} else {
			if (my_node->op == '-') {
				f_single = true;	/* '-'λñ黻 */
			} else {	/* ¾ξåȤƤʤХ顼 */
				log_sys("#  No left-side expression.\n");
				goto ERR;
			}
		}
	}

	if (my_node->childR) {	/* R */
		DBGW(20, ("Set_expr :GO Right %p to %p\n", my_node, my_node->childR));
		if (Set_expr(my_node->childR, f_isCType)) goto ERR;
		strcpy(exprR, my_node->childR->expr);
		rank_exprR = my_node->childR->rank_expr;
		if (my_node->charR) {	/* ξ˥åȤƤ饨顼 */
			log_sys("#  Duplicate expressions.\n");
			log_sys("#  charR :%s.\n", my_node->charR);
			log_sys("#  exprR:%s.\n", exprR);
			goto ERR;
		}
	} else {	/* R̵ */
		if (my_node->charR) {
			strcpy(exprR, my_node->charR);
			rank_exprR = my_node->rank_charR;
		} else {	/* ¾ξåȤƤʤХ顼 */
			log_sys("#  No right-side expression.\n");
			goto ERR;
		}
	}

	DBGW(20, ("exL='%s', exR='%s',    fL=%d, fR=%d\n", exprL, exprR, rank_exprL, rank_exprR));
#if DBG
	print_node(my_node, "set_exper MID");
#endif

	if (f_single) {
		sprintf(my_expr, "-%s", exprR);
		my_node->rank_expr = R_1PLUS;
	} else if (my_node->op == '\0') { /* դ˱黻Ҥ1Ĥ̵ */
		sprintf(my_expr, "%s", exprL);
	} else {
		if ((rank_exprL == R_5VAL) && (rank_exprR == R_5VAL)) {
			/* ξڥɤͤǤз׻֤ͤ */
			del_bracket(exprL);
			del_bracket(exprR);
			if (my_node->op == '+') {
				val = atof(exprL) + atof(exprR);
			} else if (my_node->op == '-') {
				val = atof(exprL) - atof(exprR);
			} else if (my_node->op == '*') {
				val = atof(exprL) * atof(exprR);
			} else if (my_node->op == '/') {
				val = atof(exprL) / atof(exprR);
			} else if (my_node->op == '^') {
				val = pow(atof(exprL), atof(exprR));
			}
			sprintf(my_expr, "%g", val);
			DBGW(20,("my_expr='%s', val=%g\n", my_expr, val));
			my_node->rank_expr = R_5VAL;
		} else if (my_node->rank == R_1PLUS) {	/* operator : '+' or '-' */
			sprintf(my_expr, "%s %c %s", exprL, my_node->op, exprR);
			my_node->rank_expr = R_1PLUS;
		} else if (my_node->rank == R_2MULT) {	/* operator : '*' or '/' */
			if (rank_exprL == R_5VAL && my_node->op == '*') {
				/* ݻǺڥɤͤǤ */
				f_isGeneral = false;
				del_bracket(exprL);
				val = atof(exprL);
				if (val == 1.0) {
					sprintf(my_expr, "%s", exprR);
					my_node->rank_expr = rank_exprR;
				} else if (val == -1.0) {
					sprintf(my_expr, "-%s", exprR);
					my_node->rank_expr = R_1PLUS;
				} else {
					f_isGeneral = true;
				}
			} else if (rank_exprR == R_5VAL) {
				/* ݻǤ껻ǤⱦڥɤͤǤ */
				f_isGeneral = false;
				del_bracket(exprL);
				val = atof(exprL);
				if (val == 1.0) {
					sprintf(my_expr, "%s", exprL);
					my_node->rank_expr = rank_exprL;
				} else if (val == -1.0) {
					sprintf(my_expr, "-%s", exprL);
					my_node->rank_expr = R_1PLUS;
				} else {
					f_isGeneral = true;
				}
			}
			if (f_isGeneral) {
				sprintf(my_expr, "%s%c%s", exprL, my_node->op, exprR);
				my_node->rank_expr = R_2MULT;
			}
		} else {	/* operator : '^' */
			if (rank_exprL == R_5VAL) {
				/* ٤ǺڥɤͤǤ */
				f_isGeneral = false;
				del_bracket(exprL);
				val = atof(exprL);
				if (val == 1.0) {
					sprintf(my_expr, "1");
					my_node->rank_expr = R_5VAL;
				} else {
					f_isGeneral = true;
				}
			} else if (rank_exprR == R_5VAL) {
				/* ٤ǱڥɤͤǤ */
				f_isGeneral = false;
				del_bracket(exprR);
				val = atof(exprR);
				if (val == 1.0) {
					sprintf(my_expr, "%s", exprL);
					my_node->rank_expr = rank_exprL;
				} else {
					f_isGeneral = true;
				}
			}
			if (f_isGeneral) {
				sprintf(my_expr, "%s%c%s", exprL, my_node->op, exprR);
				if (f_isCType) {
					sprintf(my_expr, "pow(%s, %s)", exprL, exprR);
				} else {
					if (*exprR == '-') {
						sprintf(my_expr, "%s%c(%s)", exprL, my_node->op, exprR);
					} else {
						sprintf(my_expr, "%s%c%s", exprL, my_node->op, exprR);
					}
				}
				my_node->rank_expr = R_3POW;
			}
		}
	}
			
	my_rank = my_node->rank_expr;

	/*	ΤΤR_1PLUS                       */
	if (*my_expr == '-') my_rank = R_1PLUS;


	/* ()ä뤫ݤȽ */
	if (my_node->parent != NULL) {	/* rootʤɬפϤʤ */
		if ((my_rank < my_node->parent->rank) ||
			((my_rank == my_node->parent->rank) && my_node->f_chunk) ||
			((my_rank == R_1PLUS) && (my_node->parent->childR == my_node)
											 && (my_node->parent->op == '-'))) {
			/* ƥΡɤ󥯤㤤								 *
			 * ⤷ϡƥΡɤȥ󥯤Ʊ()ǳƤ		 *
			 * ⤷ϡƥΡ()λRǼȤorǤ			 *
			 * ȤΤ()ǳ										 */
			add_bracket(my_expr);
		}
	}
	
	//if (*my_expr == '-') add_bracket(my_expr); /* add 2003.03.11 */

	if (my_node->expr != NULL) free((void *) my_node->expr);
	my_node->expr = strdup(my_expr);

	DBGW(20, ("node=%p, op='%c', L='%s', R='%s', ex='%s', f_ex=%d\n", my_node,
		my_node->op, my_node->charL, my_node->charR, my_node->expr, my_node->rank_expr));
	DBGW(20, ("exL='%s', exR='%s',    fL=%d, fR=%d\n", exprL, exprR, rank_exprL, rank_exprR));
#if DBG
	print_node(my_node, "set_exper OUT");
#endif

	return 0;

ERR:
	log_sys("#  operation :'%c'.\n", my_node->op);
	log_sys("## Error in Set_expr.\n");
	return -1;
}

/*** Make_diff() ****************************************************
 *
 * ƵŪˤΥΡɰʲʬԤ
 *
 */
int
Make_diff(Node_T *my_node, char *target, int f_isCType)
{
	Diff_T diffData;
	char my_diff[BUFFSIZE];
	int my_rank = R_NULL;

	memset(&diffData, 0, sizeof(diffData));
	memset(my_diff, 0, sizeof(my_diff));

#if DBG
	print_node(my_node, "Make_diff IN");
#endif
	/* make left */
	if (my_node->childL) {	/* L */
		if (Make_diff(my_node->childL, target, f_isCType)) goto ERR;
		strcpy(diffData.diffL, my_node->childL->diff);
		strcpy(diffData.exprL, my_node->childL->expr);
		diffData.rank_diffL = my_node->childL->rank_diff;
		diffData.rank_exprL = my_node->childL->rank_expr;
	} else {	/* L̵ */
		if (my_node->charL) {
			if (strcmp(target, my_node->charL) == 0) {
				strcpy(diffData.diffL, "1");
				diffData.rank_diffL = R_5VAL;
			} else {
				strcpy(diffData.diffL, "");
				diffData.rank_diffL = R_NULL;
			}
			strcpy(diffData.exprL, my_node->charL);
			diffData.rank_exprL = my_node->rank_charL;
		}
	}

	/* make right */
	if (my_node->childR) {	/* R */
		if (Make_diff(my_node->childR, target, f_isCType)) goto ERR;
		strcpy(diffData.diffR, my_node->childR->diff);
		strcpy(diffData.exprR, my_node->childR->expr);
		diffData.rank_diffR = my_node->childR->rank_diff;
		diffData.rank_exprR = my_node->childR->rank_expr;
	} else {	/* R̵ */
		if (my_node->charR) {
			if (strcmp(target, my_node->charR) == 0) {
				strcpy(diffData.diffR, "1");
				diffData.rank_diffR = R_5VAL;
			} else {
				strcpy(diffData.diffR, "");
				diffData.rank_diffR = R_NULL;
			}
			strcpy(diffData.exprR, my_node->charR);
			diffData.rank_exprR = my_node->rank_charR;
		}
	}

	DBGW(20, ("op='%c', eL='%s', eR='%s', dL='%s', dR='%s'\n", my_node->op,
			diffData.exprL, diffData.exprR, diffData.diffL, diffData.diffR)); 
	DBGW(20, ("feL=%d, feR=%d, fdL=%d, fdR=%d\n",
			diffData.rank_exprL, diffData.rank_exprR, diffData.rank_diffL, diffData.rank_diffR)); 
	
	if ((my_node->op == '+') || (my_node->op == '\0')) {
		if (diff_add(my_node, &diffData, my_diff)) goto ERR;
	} else if (my_node->op == '-') {
		if (diff_subtract(my_node, &diffData, my_diff)) goto ERR;
	} else if (my_node->op == '*') {
		if (diff_multiply(my_node, &diffData, my_diff)) goto ERR;
	} else if (my_node->op == '/') {
		if (diff_divide(my_node, &diffData, my_diff, f_isCType)) goto ERR;
	} else if (my_node->op == '^') {
		if (diff_power(my_node, &diffData, my_diff, f_isCType)) goto ERR;
	}

	DBGW(20, ("node=%p, st=%d, my_diff='%s'\n", my_node, my_node->rank_diff, my_diff));

#if 1
	my_rank = my_node->rank_diff;

	/*	ΤΤR_1PLUS       || my_rank == R_NULL  */
	if (*my_diff == '-') my_rank = R_1PLUS;

	/* ()ä뤫ݤȽ */
	if (my_node->parent != NULL && my_rank != R_NULL) {	/* rootʤɬפϤʤ */
		if ((my_rank < my_node->parent->rank) ||
			((my_rank == R_1PLUS) && (my_node->parent->childR == my_node)
											 && (my_node->parent->op == '-'))) {
			/* ƥΡɤ󥯤㤤 							*
			 * ⤷ϡƥΡ()λRǼȤorǤ		*
			 * ȤΤ()ǳ									*/
			add_bracket(my_diff);
		}
	}
#endif

#if 0
			/* ⤷ϡƥΡɤȥ󥯤Ʊ()ǳƤ 			*
			 *((my_rank == my_node->parent->rank) && my_node->f_chunk) ||	*/
	if (my_node->parent != NULL && my_rank != R_NULL) {
		if ((my_rank < my_node->parent->rank) || (*my_diff == '-') ||
			((my_rank < R_2MULT) && (my_node->parent->childR == my_node) && (my_node->parent->op == '-'))) {
			add_bracket(my_diff);
		}
	}
#endif

	if (my_node->diff != NULL) free((void *) my_node->diff);
	my_node->diff = strdup(my_diff);
#if DBG
	print_node(my_node, "Make_diff OUT");
#endif

	return 0;

ERR:
	log_sys("#  operation :'%c'.\n", my_node->op);
	log_sys("## Error in Make_diff.\n");
	return -1;
}

/*** diff_add() ****************************************************
 *
 * '+'ΡɤʬԤ
 *
 */
static int diff_add(Node_T *my_node, Diff_T *diffData, char *answer)
{
	double val;

	if ((diffData->rank_diffL == R_NULL) && (diffData->rank_diffR == R_NULL)) {
		*answer = '\0';
		my_node->rank_diff = R_NULL;
	} else if ((diffData->rank_diffL == R_5VAL) && (diffData->rank_diffR == R_5VAL)) {
		del_bracket(diffData->diffL);
		del_bracket(diffData->diffR);
		val = atof(diffData->diffL) + atof(diffData->diffR);
		if (val == 0.0) {
			*answer = '\0';
			my_node->rank_diff = R_NULL;
		} else {
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		}
	} else if ((diffData->rank_diffL > R_NULL) && (diffData->rank_diffR == R_NULL)) {
		if (diffData->rank_diffL == R_5VAL) {
			del_bracket(diffData->diffL);
			val = atof(diffData->diffL);
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		} else {
			sprintf(answer, "%s", diffData->diffL);
			my_node->rank_diff = diffData->rank_diffL;
		}
	} else if ((diffData->rank_diffL == R_NULL) && (diffData->rank_diffR > R_NULL)) {
		if (diffData->rank_diffR == R_5VAL) {
			del_bracket(diffData->diffR);
			val = atof(diffData->diffR);
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		} else {
			sprintf(answer, "%s", diffData->diffR);
			my_node->rank_diff = diffData->rank_diffR;
		}
	} else {
		sprintf(answer, "%s + %s", diffData->diffL, diffData->diffR);
		my_node->rank_diff = R_1PLUS;
	}
	return 0;
}

/*** diff_subtract() ****************************************************
 *
 * '-'ΡɤʬԤ
 *
 */
static int diff_subtract(Node_T *my_node, Diff_T *diffData, char *answer)
{
	double val;

	if ((diffData->rank_diffL == R_NULL) && (diffData->rank_diffR == R_NULL)) {
		*answer = '\0';
		my_node->rank_diff = R_NULL;
	} else if ((diffData->rank_diffL == R_5VAL) && (diffData->rank_diffR == R_5VAL)) {
		del_bracket(diffData->diffL);
		del_bracket(diffData->diffR);
		val = atof(diffData->diffL) - atof(diffData->diffR);
		if (val == 0.0) {
			*answer = '\0';
			my_node->rank_diff = R_NULL;
		} else {
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		}
	} else if ((diffData->rank_diffL > R_NULL) && (diffData->rank_diffR == R_NULL)) {
		if (diffData->rank_diffL == R_5VAL) {
			del_bracket(diffData->diffL);
			val = atof(diffData->diffL);
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		} else {
			sprintf(answer, "%s", diffData->diffL);
			my_node->rank_diff = diffData->rank_diffL;
		}
	} else if ((diffData->rank_diffL == R_NULL) && (diffData->rank_diffR > R_NULL)) {
		if (diffData->rank_diffR == R_5VAL) {
			del_bracket(diffData->diffR);
			val = atof(diffData->diffR)*(-1.0);
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		} else {
			sprintf(answer, "-%s", diffData->diffR);
			my_node->rank_diff = diffData->rank_diffR;
		}
	} else {
		sprintf(answer, "%s - %s", diffData->diffL, diffData->diffR);
		my_node->rank_diff = R_1PLUS;
	}
	return 0;
}

/*** diff_multiply() ****************************************************
 *
 * '*'ΡɤʬԤ
 *
 */
static int diff_multiply(Node_T *my_node, Diff_T *diffData, char *answer)
{
	int rank1, rank2;
	char str1[BUFFSIZE], str2[BUFFSIZE];
	
	/* L'*R */
	rank1 = multiply(diffData->diffL, diffData->exprR,
				   	diffData->rank_diffL, diffData->rank_exprR, str1);
	/* R'*L */
	rank2 = multiply(diffData->diffR, diffData->exprL,
				   	diffData->rank_diffR, diffData->rank_exprL, str2);

	DBGW(20, ("str1='%s', str2='%s', f1=%d, f2=%d\n", str1, str2, rank1, rank2));

	if ((rank1 == R_NULL) && (rank2 == R_NULL)) {
		*answer = '\0';
		my_node->rank_diff = R_NULL;
	} else if (rank1 == R_NULL) {
		sprintf(answer, "%s", str2);
		my_node->rank_diff = rank2;
	} else if (rank2 == R_NULL) {
		sprintf(answer, "%s", str1);
		my_node->rank_diff = rank1;
	} else if ((rank1 == R_5VAL) && (rank2 == R_5VAL)) { /* ꤨʤ */
		log_sys("## Never come here!! str1='%s', str2='%s' in mult.\n", str1, str2);
		return -1;
	} else {
		sprintf(answer, "%s + %s", str1, str2);
		my_node->rank_diff = R_1PLUS;
	}
	return 0;
}

/*** multiply() ****************************************************
 *
 * 2ѿγݤ
 *
 */
static int multiply(char *strL, char *strR, int rankL, int rankR, char *answer)
{
	int my_rank;
	double val;
	
	if (rankL == R_NULL || rankR == R_NULL) {
		*answer = '\0';
		my_rank = R_NULL;
	} else {
		if ((rankL == R_5VAL) && (rankR == R_5VAL)) {
			del_bracket(strL);
			del_bracket(strR);
			sprintf(answer, "%g", atof(strL)*atof(strR));
			my_rank = R_5VAL;
		} else if (rankL == R_5VAL) {
			del_bracket(strL);
			val = atof(strL);
			if (val == 1.0) {
				strcpy(answer, strR);
			} else if (val == -1.0) {
				sprintf(answer, "-%s", strR);
			} else {
				sprintf(answer, "%s*%s", strL, strR);
			}
			if (val < 0.0) {
				my_rank = R_1PLUS;
			} else {
				my_rank = R_2MULT;
			}
		} else if (rankR == R_5VAL) {
			del_bracket(strR);
			val = atof(strR);
			if (val == 1.0) {
				strcpy(answer, strL);
			} else if (val == -1.0) {
				sprintf(answer, "-%s", strL);
			} else {
				if (val < 0.0) {
					sprintf(answer, "%s*(%s)", strL, strR);
				} else {
					sprintf(answer, "%s*%s", strL, strR);
				}
			}
			if (val < 0.0) {
				my_rank = R_1PLUS;
			} else {
				my_rank = R_2MULT;
			}
		} else {
			sprintf(answer, "%s*%s", strL, strR);
			my_rank = R_2MULT;
		}
	}

	return my_rank;
}

/*** diff_divide() ****************************************************
 *
 * '/'ΡɤʬԤ
 *
 */
static int diff_divide(Node_T *my_node, Diff_T *diffData, char *answer, int f_isCType)
{
	int rank1, rank2;
	char str1[BUFFSIZE], str2[BUFFSIZE], str_tmp[BUFFSIZE];
	double val;
	
	/* L'*R */
	rank1 = multiply(diffData->diffL, diffData->exprR,
				   	diffData->rank_diffL, diffData->rank_exprR, str1);
	/* R'*L */
	rank2 = multiply(diffData->diffR, diffData->exprL,
				   	diffData->rank_diffR, diffData->rank_exprL, str2);

	DBGW(20, ("str1='%s', str2='%s', f1=%d, f2=%d\n", str1, str2, rank1, rank2));

	if (f_isCType) {
		sprintf(str_tmp, "pow(%s, 2)", diffData->exprR);
	} else {
		sprintf(str_tmp, "%s^2", diffData->exprR);
	}

	if ((rank1 == R_NULL) && (rank2 == R_NULL)) {
		*answer = '\0';
		my_node->rank_diff = R_NULL;
	} else if (rank1 == R_NULL) {
		if (str2[0] == '-' ) {
			sprintf(answer, "%s/%s", str2+1, str_tmp);
			my_node->rank_diff = R_2MULT;
		} else {
			sprintf(answer, "-%s/%s", str2, str_tmp);
			my_node->rank_diff = R_1PLUS;
		}
	} else if (rank2 == R_NULL) {
		if (diffData->rank_diffL == R_5VAL && diffData->rank_exprR == R_5VAL) {
			val = atof(diffData->diffL)/atof(diffData->exprR);
			sprintf(answer, "%g", val);
			my_node->rank_diff = R_5VAL;
		} else {
			sprintf(answer, "%s/%s", diffData->diffL, diffData->exprR);
			my_node->rank_diff = R_2MULT;
		}
	} else if ((rank1 == R_5VAL) && (rank2 == R_5VAL)) { /* ꤨʤ */
		log_sys("## Never come here!! str1='%s', str2='%s' in divide.\n", str1, str2);
		return -1;
	} else {
		if (str2[0] == '-' ) {
			sprintf(answer, "(%s + %s)/%s", str1, str2+1, str_tmp);
		} else {
			sprintf(answer, "(%s - %s)/%s", str1, str2, str_tmp);
		}
		my_node->rank_diff = R_2MULT;
	}
	return 0;
}

/*** diff_power() ****************************************************
 *
 * '^'ΡɤʬԤ
 *
 */
static int diff_power(Node_T *my_node, Diff_T *diffData, char *answer, int f_isCType)
{
	int rank1, rank2;
	char str1[BUFFSIZE], str2[BUFFSIZE];
	char str_work[BUFFSIZE],str_work2[BUFFSIZE];
	double val;
	
	/* L'*R */
	rank1 = multiply(diffData->diffL, diffData->exprR,
				   	diffData->rank_diffL, diffData->rank_exprR, str1);
	/* R'*log(L) */
	strcpy(str_work2, diffData->exprL);
	del_bracket(str_work2);
	sprintf(str_work, "log(%s)", str_work2);
	rank2 = multiply(diffData->diffR, str_work,
				   	diffData->rank_diffR, R_4CHAR, str2);

	DBGW(20, ("str1='%s', str2='%s', f1=%d, f2=%d\n", str1, str2, rank1, rank2));

	if ((rank1 == R_NULL) && (rank2 == R_NULL)) {
		*answer = '\0';
		my_node->rank_diff = R_NULL;
	} else if (rank1 == R_NULL) {
		if (f_isCType) {
			sprintf(answer, "%s*pow(%s, %s)", str2, diffData->exprL, diffData->exprR);
		} else {
			sprintf(answer, "%s*%s^%s", str2, diffData->exprL, diffData->exprR);
		}
		my_node->rank_diff = R_2MULT;
	} else if (rank2 == R_NULL) {
		if (diffData->rank_exprR == R_5VAL) {
			del_bracket(diffData->exprR);
			val = atof(diffData->exprR) - 1;
			if (val == 1.0) {
				if (rank1 == R_5VAL && diffData->rank_exprL == R_5VAL) {
					del_bracket(diffData->exprL);
					val = atof(str1)*atof(diffData->exprL);
					sprintf(answer, "%g", val);
					my_node->rank_diff = R_5VAL;
				} else {
					sprintf(answer, "%s*%s", str1, diffData->exprL);
					my_node->rank_diff = R_2MULT;
				}
			} else if (val == 0.0) {
				sprintf(answer, "%s", str1);
				my_node->rank_diff = rank1;
			} else {
				if (f_isCType) {
					sprintf(answer, "%s*pow(%s, %g)", str1, diffData->exprL, val);
				} else {
					sprintf(answer, "%s*%s^%g", str1, diffData->exprL, val);
				}
				my_node->rank_diff = R_2MULT;
			}
		} else {
			if (f_isCType) {
				sprintf(answer, "%s*pow(%s, %s - 1)", str1, diffData->exprL, diffData->exprR);
			} else {
				sprintf(answer, "%s*%s^(%s - 1)", str1, diffData->exprL, diffData->exprR);
			}
			my_node->rank_diff = R_2MULT;
		}
	} else if ((rank1 == R_5VAL) && (rank2 == R_5VAL)) { /* ꤨʤ */
		log_sys("## Never come here!! str1='%s', str2='%s' in pow.\n", str1, str2);
		return -1;
	} else {
		if (diffData->rank_exprR == R_5VAL) {
			del_bracket(diffData->exprR);
			val = atof(diffData->exprR) - 1;
			if (val == 1.0) {
				sprintf(str_work, "%s*%s", str1, diffData->exprL);
			} else {
				if (f_isCType) {
					sprintf(str_work, "%s*pow(%s, %g)", str1, diffData->exprL, val);
				} else {
					sprintf(str_work, "%s*%s^%g", str1, diffData->exprL, val);
				}
			}
		} else {
			if (f_isCType) {
				sprintf(str_work, "%s*pow(%s, %s - 1)", str1, diffData->exprL, diffData->exprR);
			} else {
				sprintf(str_work, "%s*%s^(%s - 1)", str1, diffData->exprL, diffData->exprR);
			}
		}
		DBGW(20, ("work='%s'\n", str_work));
		if (f_isCType) {
			sprintf(answer, "%s*pow(%s, %s)", str2, diffData->exprL, diffData->exprR);
		} else {
			sprintf(answer, "%s*%s^%s", str2, diffData->exprL, diffData->exprR);
		}
		sprintf(answer, "%s + %s", answer, str_work);
		my_node->rank_diff = R_1PLUS;
	}
	return 0;
}

/** add_bracket() ******************************
 * 
 * ʸ()ǰϤ֤
 *
 */
static void add_bracket(char *line)
{
	char tline[BUFFSIZE];

	strcpy(tline, line);
	sprintf(line, "(%s)", tline);

	return;
}

/** del_bracket() ******************************
 * 
 * ξü()ǰϤޤ줿ʸξ硢¦()Ϥ֤
 *
 */
static void del_bracket(char *line)
{
	char tline[BUFFSIZE];
	int i, n=0;

	DBGW(50, ("in str = '%s'\n", line));
	if (*line != '(') {
		return; 
	}
	n = strlen(line);
	if (*(line + n-1) != ')') {
		return; 
	}
	strcpy(tline, line);
	for (i=1; i<n-1; i++) {
			*(line + i - 1) = *(tline + i);
	}
	*(line + n-2) = '\0';
	DBGW(50, ("out str = '%s'\n", line));

	return;
}

/** Trim_tail() ******************************
 * 
 * ζ꥿󥳡ɤϤ
 *
 */
int
Trim_tail(char *line)
{
	int n;

	for (n = strlen(line) - 1; n >= 0; n--) {
		if (line[n] != ' ' &&line[n] != '\t' &&line[n] != '\r' &&line[n] != '\n') break;
	}
	line[n+1] = '\0';

	return n;
}


#ifdef TEST
/********************************************************************************
 * testDiff -- ᥤ
 */
#define MAX_VAR_NUM 1024

typedef struct _expression {
	char	*expr;
	Node_T	*root;
} Expression;

static int read_expr (char *fname, Expression **expr, int *n_expr, int f_isCType);
static int write_expr (char *fname, Expression **expr, int n_expr, int f_isCType);


int main (int argc, char *argv[]) {
	int i, f_isCType=false;
	char fname_i[FILENAME_MAX];
	char fname_o[FILENAME_MAX];
	Expression **expr = NULL;
	int n_expr = 0;

	DBGW(10, ("main() start.\n"));

	expr = (Expression **)calloc (MAX_VAR_NUM, sizeof(Expression *));

#ifdef DBG
	// open debug-log file.
	if (log_dbginit (argc, argv)) {
		printf ("Cannot open dbgLog file!!");
		goto err;
	}
#endif

	// open sys-log file.

	if (log_sysinit (argc, argv)) {
		printf ("Cannot open sysLog file!!");
		goto err;
	}

	// ץβ
	memset (fname_i, 0, sizeof (fname_i));
	memset (fname_o, 0, sizeof (fname_o));
	for (i=0; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				strncpy (fname_i, &argv[i][2], sizeof (fname_i));
				break;
			case 'O':
				strncpy (fname_o, &argv[i][2], sizeof (fname_o));
				break;
			case 'C':
				f_isCType=true;
				break;
			case 'd':
				break;
			default:
				log_sys ("#  Invalid argument !!\n");
				goto err;
			}
		}
	}
	if (fname_i[0] == '\0' || fname_o[0] == '\0') {
		log_sys ("#  Too few arguments !!\n");
		goto err;
	}

	// ե򳫤Ÿ
	if (read_expr (fname_i, expr, &n_expr, f_isCType) < 0) {
		log_sys ("#  cannot open $s.\n", fname_i);
		goto err;
	}

	// ꥹȤŸ
	for (i=0; i<n_expr; i++) {
		if (Make_node (&expr[i]->root, expr[i]->expr) < 0) {
			log_sys ("i=%d\n\n", i);
		}
		if (Set_expr(expr[i]->root, f_isCType)) {
			printf("Can't set expression!!\n");
		}
	}

	// ե˽񤭽Ф
	if (write_expr (fname_o, expr, n_expr, f_isCType) < 0) {
		log_sys ("### Error!! : TEST DIFF\n");
		goto err;
	}

	DBGW(10, ("main() end.\n"));

	return 0;

  err:
	return -1;

}

/*** read_expr() *****************************************
 *
 */
static int read_expr (char *fname, Expression **expr, int *n_expr, int f_isCType) {
	FILE *fp;
    char line[BUFFSIZE];

	DBGW(10, ("read_expr() start.\n"));

	if ((fp = fopen (fname, "r")) == NULL){
		log_sys ("#  Cannot open %s\n", fname);
		goto err;
	}


	*n_expr = 0;
	while (fgets (line, BUFFSIZE, fp)) {
		expr[*n_expr] = (Expression *)calloc (1, sizeof(Expression));
		Trim_tail(line);
		expr[*n_expr]->expr = strdup (line);
		(*n_expr)++;

		if (*n_expr >= MAX_VAR_NUM) {
			log_sys ("#  Too many expressions.\n");
			goto err;
		}
	}


	fclose (fp); fp = NULL;


	DBGW (10, ("read_expr() end.\n"));

	return 0;

err:
	if (fp != NULL) fclose(fp);
	return -1;

}

/*** write_expr() **************************************
 *
 */
static int write_expr (char *fname, Expression **expr, int n_expr, int f_isCType) {
	int i;
	FILE *fp;
	char target[BUFFSIZE];

	printf("Please input variable.\n");
	scanf("%s", target);

	DBGW (10, ("write_expr() start.\n"));

	if ((fp = fopen (fname, "w")) == NULL){
		log_sys ("#  Cannot open %s\n", fname);
		goto err;
	}

	fprintf(fp, "target  : %s\n\n", target);

	for (i=0; i<n_expr; i++) {
		fprintf(fp, "in  : %s\n", expr[i]->expr);
		if (Make_diff(expr[i]->root, target, f_isCType)) {
			printf("Can't diff!!\n");
		}
		fprintf(fp, "out : %s\n", expr[i]->root->expr);
		fprintf(fp, "diff: %s\n\n", expr[i]->root->diff);
	}

	fclose (fp); fp = NULL;

	DBGW (10, ("write_expr() end.\n"));

	return 0;

  err:
	if (fp != NULL) fclose(fp);
	return -1;

}

#endif
