#ifndef _PDIFF_H_
#define _PDIFF_H_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "logUtil.h"


#define BUFFSIZE 65536

/*------- R_*** ------------------------------------*
 * operation ӼΥդ                   *
 * Ρɤopξ 1-3                           *
 *                                                  *
 * ξϤǤκ                   *
 * 㤨 1  R_5VAL(x-1)/a  R_2MULT           *
 *                                                  *
 * '-'դա-1 R_5VAL Ǥ뤬    *
 * exprdiff ˤϤ()ղä뤫ݤ    *
 * ȽΤ˲ R_1PLUS Ȥư            */
#define R_NULL	0	/* nothing */
#define R_1PLUS	1	/* '+' or '-' */
#define R_2MULT	2	/* '*' or '/' */
#define R_3POW	3	/* '^' */
#define R_4CHAR	4	/* char */
#define R_5VAL	5	/* value */

/* Ρ(2黻) */
typedef struct _node {
	char			op;			/* 黻ҡ'+', '-', '*', '/', '^'  */
	int				rank;		/* 黻ҤΥ +,-R_1PLUS*,/R_2MULT^R_3POW */
	int				f_bracket;	/* '('Υե饰 */
	int				f_chunk;	/* ΥΡɤα黻()Υե饰 */
	struct _node	*parent;
	struct _node	*childL;
	char			*charL;
	int				rank_charL;	/* R_NULL / R_4CHAR / R_5VAL */
	struct _node	*childR;
	char			*charR;
	int				rank_charR;	/* R_NULL / R_4CHAR / R_5VAL */
	char			*expr;
	int				rank_expr;	/* R_NULL/R_1PLUS/R_2MULT/R_3POW/R_4CHAR/R_5VAL */
	char			*diff;
	int				rank_diff;	/* R_NULL/R_1PLUS/R_2MULT/R_3POW/R_4CHAR/R_5VAL */
} Node_T;

/* ʲι¤ΤϽǡǼ */
/* ɼ */
typedef struct _token {
	char	op;
	int		rank;
	char	*expr;
	int		bra;
	int		cket;
} Token_T;

/* ʬѥǡ */
typedef struct _diff {
	int		rank_exprL;
	int		rank_exprR;
	int		rank_diffL;
	int		rank_diffR;
	char	exprL[BUFFSIZE];
	char	exprR[BUFFSIZE];
	char	diffL[BUFFSIZE];
	char	diffR[BUFFSIZE];
} Diff_T;

#endif	/* _PDIFF_H_ */
