#include <stdio.h>
#include <stdlib.h>

#include "life.h"
#include "randb.h"
#include "logUtil.h"
#include "ga2ls.h"

int ReadRegionFromLS(GaParam_T *ga_param)
{
	int		i;
	int		rv = EXIT_ERROR;
#ifdef DBG
	DBGW(10, ("ReadRegionFromLS enter.\n"));
#endif /* DBG */
	
	if(P_GaNum > NUM_VARIABLE_MAX){
		log_sys(" ## Error: Number of variables must be smaller than equal %d\n", NUM_VARIABLE_MAX);
		goto out;
	}
	
	for(i = 0; i < P_GaNum; i++){
		ga_param->variableRegion.minArray[i] = P_Ga[i].min_value;
		ga_param->variableRegion.maxArray[i] = P_Ga[i].max_value;
	}

	ga_param->variableRegion.arraySize = P_GaNum;
	ga_param->gaEncodeParam.numVariable = P_GaNum;

	rv = EXIT_NORMAL;
out:
#ifdef DBG
	DBGW(10, ("ReadRegionFromLS exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}


int GaGene2LSParam(const double *ga_out)
{
	int		i;
#ifdef DBG
	DBGW(10, ("GaGene2LSParam enter.\n"));
#endif /* DBG */

	for(i = 0; i < P_GaNum; i++){
		ParamT.val[P_Ga[i].p_no][P_Ga[i].index] = ga_out[i];
	}
#ifdef DBG
	DBGW(10, ("GaGene2LSParam exit(0)\n"));
#endif /* DBG */

	return EXIT_NORMAL;
}


		
