/*
 *"R & B": Real-coded GAs & Bit-string GAs
 *
 * parameter module 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "logUtil.h"
#include "randb.h"
#include "utl_text.h"
#include "utl_arg.h"

/*
 * Prottype declarationis of a static function
 */

/*-----
 * set_encode_paramؿ
 * 	Ϳ줿ʸ󤫤顤GaEncodeParam_TΥѥ᡼򥻥å
 */
static int set_encode_param(GaEncodeParam_T *encode_param);

/*-----
 * set_gatype_paramؿ
 * 	Ϳ줿ʸ󤫤顤GaTypeParam_TΥѥ᡼򥻥å
 */
static int set_gatype_param(GaTypeParam_T *ga_type_param, GaEncodeParam_T *ga_encode_param);

/*-----
 * set_digenesis_paramؿ
 * 	Ϳ줿ʸ󤫤顤DigenesisParam_TΥѥ᡼򥻥å
 */
static int set_digenesis_param(DigenesisParam_T *digenesis_param, const GaEncodeParam_T *ga_encode_param, const GaTypeParam_T *ga_type_param);

/*-----
 * set_crossover_paramؿ
 * 	Ϳ줿ʸ󤫤顤CrossoverParam_TΥѥ᡼򥻥å
 */
static int set_crossover_param(CrossoverParam_T *crossover_param, const GaEncodeParam_T *ga_encode_param);

/*-----
 * set_mutaion_paramؿ
 * 	Ϳ줿ʸ󤫤顤MutationParam_TΥѥ᡼򥻥å
 */
static int set_mutation_param(MutationParam_T *mutation_param, GaEncodeParam_T *ga_encode_param);



/***********************
 * Public functions    *
 ***********************/

/*-----
 * InitializeParamؿ
 * 	ѥ᡼¤GaParam_T
 *	ͤ0ˡݥ󥿤NULL˽
 * ͡EXIT_NORMAL
 *   GaParam_T(O)
 */
int InitializeParam(GaParam_T *ga_param)
{
#ifdef DBG
	DBGW(10, ("InitializeParam enter.\n"));
#endif /* DBG */

	memset(ga_param, 0, sizeof(GaParam_T));
	ga_param->bestGene.gaGene.fitness = -DBL_MAX;

#ifdef DBG
	DBGW(10, ("InitializeParam exit(0)\n"));
#endif /* DBG */

	return EXIT_NORMAL;
}

/*-----
 * SetCommandLineInfoؿ
 * 	ޥɥ饤ξ򥻥å
 * 	͡EXIT_NORMAL
 * 	  ǼComLine_T*(O), argc(I), argv(I)
 */
int SetCommandLineInfo(ComLine_T *com_line, int argc, char **argv)
{
#ifdef DBG
	DBGW(10, ("SetCommandLineInfo enter.\n"));
#endif /* DBG */

	com_line->argc = argc;
	com_line->argv = argv;
#ifdef DBG
	DBGW(10, ("SetCommandLineInfo exit(0)\n"));
#endif /* DBG */

	return EXIT_NORMAL;
}

/*-----
 * AdminCommandLineؿ
 *	ޥɥ饤
 *	GaIoParam_TιιԤ
 * ͡EXIT_NORMAL, EXIT_ERROR
 * 	 GaIoParam_T(O), int(I), char**(I)
 */
int AdminCommandLine(GaIoParam_T *io_param, int argc, char **argv)
{
/* ץѥե饰 */
#define	FLAG_r (1 << 0)
#define FLAG_p (1 << 1)
#define FLAG_f (1 << 2)
	
	int		ch;
	int		rv = EXIT_ERROR;
	unsigned int 	foptions = 0;
	char	*cargv[NUM_OPTION_MAX];
	
#ifdef DBG
	DBGW(10, ("AdminCommandLine enter.\n"));
#endif /* DBG */

	if(CopyArgv(argc, argv, cargv) == EXIT_ERROR){
		goto out;
	}
	
	if(opterr != 0) opterr = 0;
	while ((ch = getopt(argc, cargv, "r:p:f:h")) != EOF){
		switch (ch){
			case 'r': /* ѿΰե */
				if (foptions & FLAG_r) {
					log_sys(" ## Error: Duplicated option: \'%c\'\n", ch);
					goto out;
				}
				strcpy(io_param->regionFileName, optarg);
				foptions |= FLAG_r;
				break;
			case 'p':
				if (foptions & FLAG_p) {
					log_sys(" ## Error: Duplicated option: \'%c\'\n", ch);
					goto out;
				}
				strcpy(io_param->paramFileName, optarg);
				foptions |= FLAG_p;
				break;
			case 'f':
				if (foptions & FLAG_f) {
					log_sys(" ## Error: Duplicated option: \'%c\'\n", ch);
					goto out;
				}
				strcpy(io_param->outputFileName, optarg);
				if ((io_param->outputFile
					=fopen(optarg, "w")) == NULL) {
					log_sys(" ## Error: The output file cannot open: \'%s\'\n", optarg);
					goto out;
				}
				foptions |= FLAG_f;
				break;
			default:
				break;
		}
	}
	
	if (!(foptions & FLAG_r) && !(foptions & FLAG_p)) {
		log_sys(" ## Error: Parameter file and region file both cannot be omitted.\n");
		goto out;
	}

	rv = EXIT_NORMAL;

out:
	optind = 1;
	FreeCargv(argc, cargv);
	
#ifdef DBG
	DBGW(10, ("AdminCommandLine exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}
				

/*-----
 * SetRegionFromFileؿ
 *	ѿΰեɤߡͤ򥻥åȤ
 *	ޤΥ쥳ɤοҤĹȤƥåȤ
 * ͡EXIT_NORMAL, EXIT_ERROR
 */
int SetRegionFromFile(GaParam_T *ga_param)
{
/* ΰɤ߹ߥե饰 */
#define FLAG_min (1 << 0)
#define FLAG_max (1 << 1)
	
	char 	buf[BUFSIZ];	/* ե뤫Ԥɤ߹Хåե */
	char 	*read_top;	/* ɤߤͤƬ */	
	int		num_var = 0;	/* ΰɤ߹ѿο */	
	FILE	*input_file;	/* ѿΰե */
	int		rv_mystr;		/* MyStrtok */
	int		rv = EXIT_ERROR;

#ifdef DBG
	DBGW(10, ("SetRegionFromFile enter.\n"));
#endif /* DBG */
	
	if((input_file = fopen(ga_param->ioParam.regionFileName, "r")) == NULL) {
		fprintf(stderr, "%s\n", ga_param->ioParam.regionFileName);
		log_sys(" ## Error: Cannot open variables region file:%s\n",
				ga_param->ioParam.regionFileName);
		goto out;
	}
	while(fgets(buf, sizeof(buf), input_file) != NULL){
		if (IsCommentLine(buf) == COMMENT_LINE){
			continue;
		}
		rv_mystr = MyStrtok(buf, ',', &read_top);
		switch (rv_mystr) {
		case 0:
			log_sys(" ## Error: Variable[%d]'s minimum value not defined.\n", num_var);
			goto out;
		case FIND_NO_DELIM:
			log_sys(" ## Error: Invalid line\n");
			goto out;
		default:
			sscanf(read_top, "%lf", &(ga_param->variableRegion.minArray[num_var]));
			break;
		}
		if(MyStrtok(NULL, '\n', &read_top) == 0) {
			log_sys(" ## Error: Variable[%d]'s maximum value not defined.\n", num_var);
			goto out;
		} else {
			sscanf(read_top, "%lf", &(ga_param->variableRegion.maxArray[num_var]));
		}
		if(ga_param->variableRegion.minArray[num_var] >=
			ga_param->variableRegion.maxArray[num_var]){
			log_sys(" ## Error: Variable[%d]'s maximum value must be larger than minimum value.\n", num_var);
			goto out;
		}
		num_var++;
		
		if(num_var > NUM_VARIABLE_MAX){
			log_sys(" ## Error: Number of variables must be smaller than equal %d.\n", NUM_VARIABLE_MAX);
			goto out;
		}
	}

	if(num_var == 0) {
		log_sys(" ## Error: No entry in region file.\n");
		goto out;
	}
		
	ga_param->gaEncodeParam.numVariable = num_var;
	ga_param->variableRegion.arraySize = num_var;
	
	rv = EXIT_NORMAL;

out:
	if(input_file != NULL) fclose(input_file);

#ifdef DBG
	DBGW(10, ("SetRegionFromFile exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}


/*-----
 * SetParamsFromFileؿ
 *	ե뤫ѥ᡼ɤ߹ߡ
 *	GaParam_T˥åȤ
 *	ComLine_Tǻꤵ줿ѥ᡼եɤߡ
 *	GaTypeParam_T, DigenesisParam_T, CrossoverParam_T, 
 *	MutaionParam_T
 *	͡EXIT_NORMAL, EXIT_ERROR
 *	GaParam_T(I/O)
 */
int SetParamsFromFile(GaParam_T *ga_param)
{
/* ɴѥե饰 */
#define FLAG_ENCODE		(1 << 0)
#define FLAG_GATYPE 	(1 << 1)
#define FLAG_DIGENESIS	(1 << 2)
#define FLAG_CROSSOVER	(1 << 3)
#define	FLAG_MUTATION	(1 << 4)
	
	char	buf[BUFSIZ];	/* Ԥɤ߹िΥХåե */
	FILE	*input_file;	/* ѥ᡼ե */
	char	*read_top;	/* ɤ߹ʸƬ */
	int		flag = 0;
	int		rv = EXIT_ERROR;

#ifdef DBG
	DBGW(10, ("SetParamsFromFile enter.\n"));
#endif /* DBG */
	
	if ((input_file = fopen(ga_param->ioParam.paramFileName, "r")) == NULL) {
		log_sys(" ## Error: Cannot open parmeter file:%s\n",
				ga_param->ioParam.paramFileName);
		goto out;
	}

	while(fgets(buf, sizeof(buf), input_file) != NULL) {
		if(IsCommentLine(buf) == COMMENT_LINE) {
			continue;
		}
		MyStrtok(buf, ';', &read_top);
		if(!strcmp("ENCODE", read_top)) {
			if (flag & FLAG_ENCODE) {
				log_sys(" ## Error: Duplicate keyword:%s\n", read_top);
				goto out;
			}
			if (set_encode_param(&(ga_param->gaEncodeParam)) == EXIT_ERROR){
				goto out;
			}
			flag |= FLAG_ENCODE;
		} else if(!strcmp("GATYPE", read_top)) {
			if (flag & FLAG_GATYPE) {
				log_sys(" ## Error: Duplicate keyword:%s\n", read_top);
				goto out;
			}
			if(!(flag & FLAG_ENCODE)) {
				log_sys(" ## Error: Describe \"ENCODE\" at top rank.\n");
				goto out;
			}
			if (set_gatype_param(&(ga_param->gaTypeParam),
									&(ga_param->gaEncodeParam))
				== EXIT_ERROR){
				goto out;
			}
			flag |= FLAG_GATYPE;
		} else if(!strcmp("DIGENESIS", read_top)) {
			if (flag & FLAG_DIGENESIS) {
				log_sys(" ## Error: Duplicate keyword:%s\n", read_top);
				goto out;
			}
			if (!(flag & FLAG_GATYPE) || !(flag & FLAG_ENCODE)){
				log_sys(" ## Error: Describe \"ENCODE\" at top rank, and \"GATYPE\" at second rank.\n");
				goto out;
			}
			if ( set_digenesis_param(&(ga_param->digenesisParam),
					&(ga_param->gaEncodeParam),
					&(ga_param->gaTypeParam)) == EXIT_ERROR){
				goto out;
			}
			flag |= FLAG_DIGENESIS;
		} else if(!strcmp("CROSSOVER", read_top)) {
			if (flag & FLAG_CROSSOVER) {
				log_sys(" ## Error: Duplicate keyword:%s\n", read_top);
				goto out;
			}
			if (!(flag & FLAG_GATYPE) || !(flag & FLAG_ENCODE)){
				log_sys(" ## Error: Describe \"ENCODE\" at top rank, and \"GATYPE\" at second rank.\n");
				goto out;
			}
			if ( set_crossover_param(&(ga_param->crossoverParam),
					&(ga_param->gaEncodeParam)) == EXIT_ERROR){
				goto out;
			}
			flag |= FLAG_CROSSOVER;
		} else if(!strcmp("MUTATION", read_top)) {
			if (flag & FLAG_MUTATION) {
				log_sys(" ## Error: Duplicate keyword:%s\n", read_top);
				goto out;
			}
			if (!(flag & FLAG_GATYPE) || !(flag & FLAG_ENCODE)){
				log_sys(" ## Error: Describe \"ENCODE\" at top rank, and \"GATYPE\" at second rank.\n");
				goto out;
			}
			if ( set_mutation_param(&(ga_param->mutationParam),
					&(ga_param->gaEncodeParam)) == EXIT_ERROR){
				goto out;
			}
			flag |= FLAG_MUTATION;
		} else {
			log_sys(" ## Error: Unknown keyword:%s\n", read_top);
			goto out;
		}
	}

	if(ga_param->gaTypeParam.islandPopulation 
				- ga_param->crossoverParam.numParent + 1
				< ga_param->digenesisParam.tournamentSize){
		log_sys(" ## Error. Tournament size is too large. Set value <= %d.\n",
						ga_param->gaTypeParam.islandPopulation 
								- ga_param->crossoverParam.numParent + 1);
		goto out;
	}

	if(!(flag & FLAG_GATYPE)){
		goto err;
	}
	if(!(flag & FLAG_DIGENESIS)){
		goto err;
	}
	if(!(flag & FLAG_CROSSOVER)){
		goto err;
	}
	if(!(flag & FLAG_MUTATION)){
		goto err;
	}

	rv = EXIT_NORMAL;

err:	
	if(rv == EXIT_ERROR){
		log_sys(" ## Error. All keywords(GATYPE, DIGENESIS, CROSSOVER, MUTATION) cannot be omitted.\n");
	}
	
out:
	if(input_file != NULL) fclose(input_file);

#ifdef DBG
	DBGW(10, ("SetParamsFromFile exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

	
/*-----
 * SetDelta
 */
int SetDelta(GaParam_T *ga_param)
{
	int	i;
	double num_seg;
	double width;

#ifdef DBG
	DBGW(10, ("SetDelta enter.\n"));
#endif /* DBG */

	num_seg = pow(2, ga_param->gaEncodeParam.quantumNumber);

	for(i = 0; i < ga_param->gaEncodeParam.numVariable; i++){
		width = ga_param->variableRegion.maxArray[i]
				- ga_param->variableRegion.minArray[i];
		ga_param->variableRegion.delta[i] = width / (num_seg - 1);
	}

#ifdef DBG
	DBGW(10, ("SetDelta exit(0)\n"));
#endif /* DBG */

	return EXIT_NORMAL;
}
		
	
/***********************
 * Static functions    *
 ***********************/

/*-----
 * set_encode_param
 * 	Ϳ줿ʸ󤫤顤GaEncodeParam_TΥѥ᡼򥻥å
 */
static int set_encode_param(GaEncodeParam_T *encode_param)
{
	int	temp_encode = 0;
	int	param_count;
	int	count_char;		/* MyStrtok */
	int	rv = EXIT_ERROR;
	char *read_top;

#ifdef DBG
	DBGW(10, ("set_encode_param enter.\n"));
#endif /* DBG */
	
	for(param_count = 0; 
		(count_char = MyStrtok(NULL, ';', &read_top)) != FIND_NO_DELIM; 
			param_count++) {
		switch(param_count) {
		case 0: /* ENCODE TYPE */
			if(count_char == 0){
				log_sys(" ## Error: No selected choice: ENCODE\n");
				goto out;
			}
			if(!strcmp("REAL", read_top)){
				encode_param->encodeType = REAL;
				encode_param->quantumNumber = 1;
				temp_encode = REAL;
			} else if(!strcmp("BINARY", read_top)){
				encode_param->encodeType = BINARY;
				temp_encode = BINARY;
			} else if(!strcmp("GRAY", read_top)){
				encode_param->encodeType = GRAY;
				temp_encode = GRAY;
			} else {
				log_sys(" ## Error: Unknown encode type:%s\n", read_top);
				goto out;
			}
			break;
		case 1:
			switch(temp_encode){
			case REAL:
				log_sys(" ## Warning: Redundant parameters for RGA.\n");
				goto end;
			case BINARY:
			case GRAY:
				if(count_char == 0){
					encode_param->quantumNumber = 10;
				}
				sscanf(read_top, "%d", &(encode_param->quantumNumber));
				if(encode_param->quantumNumber <= 0){
					log_sys(" ## Error: Quantum number must be a positive interger.\n");
					goto out;
				}
			default: break;
			}
			break;
		case 2:
			log_sys(" ## Warning: Redundant parameters for BGA.\n");
			goto end;
		default: break;
		}
	}

	if(temp_encode != REAL){
		if(param_count < 2) {
			log_sys(" ## Error: Shortage of parameters for BGA.\n");
			goto out;
		}
		if(encode_param->numVariable * encode_param->quantumNumber
						> BGA_GENE_MAX){
			log_sys(" ## Error: BGA's gene length(numVariable * quantumNumber must be smaller than equal %d.\n", BGA_GENE_MAX);
			goto out;
		}
	}

end:
	encode_param->geneLength = 
			encode_param->quantumNumber * encode_param->numVariable;
	rv = EXIT_NORMAL;

out:
#ifdef DBG
	DBGW(10, ("set_encode_param exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

		

/*-----
 * set_gatype_paramؿ
 * 	Ϳ줿ʸ󤫤顤GaTypeParam_TΥѥ᡼򥻥å
 */
static int set_gatype_param(GaTypeParam_T *ga_type_param, GaEncodeParam_T *ga_encode_param)
{
	int temp_ga_type = 0;
	int temp_switch = 0;
	int	param_count;
	int	count_char;		/* MyStrtok */
	int	rv = EXIT_ERROR;	
	char 	*read_top;	

#ifdef DBG
	DBGW(10, ("set_gatype_param enter.\n"));
#endif /* DBG */
	
	for(param_count = 0; 
		(count_char = MyStrtok(NULL, ';', &read_top)) != FIND_NO_DELIM; 
			param_count++) {
		switch(param_count) {
		case 0: /* GA TYPE */
		 	if(count_char == 0) {
				log_sys(" ## Error: No selected choice: GATYPE\n");
				goto out;
			}
			if(!strcmp("DGA", read_top)) {
				ga_type_param->gaType = DGA;
				temp_ga_type = DGA;
			} else if(!strcmp("DIGA", read_top)) {
				ga_type_param->gaType = DIGA;
				temp_ga_type = DIGA;
			} else {
				log_sys(" ## Error: Unknown ga type:%s\n", read_top);
				goto out;
			}
			break;
			
		case 1: /* max generation */
			if(count_char == 0) {
				ga_type_param->maxGeneration = 100;
			} else {
				sscanf(read_top, "%d", &(ga_type_param->maxGeneration));
				if (ga_type_param->maxGeneration <= 0) {
					log_sys(" ## Error: Max generation must be a positive interger.\n");
					goto out;
				}
			}
			break;
			
		case 2: /* fin value */
			if(count_char == 0) {
				ga_type_param->finValue = -1e-10;
			} else {
				sscanf(read_top, "%lf", &(ga_type_param->finValue));
			}
			break;
			
		case 3: /* Number of islands */
			if(count_char == 0) {
				ga_type_param->numIsland = 3;
			} else {
				sscanf(read_top, "%d", &(ga_type_param->numIsland));
				if (ga_type_param->numIsland <= 0) {
					log_sys(" ## Error: Number of island must be a positive interger.\n");
					goto out;
				}
			}
			break;
		case 4: /* Population of a island */
			if(count_char == 0) {
				ga_type_param->islandPopulation = 30;
			} else {
				sscanf(read_top, "%d", &(ga_type_param->islandPopulation));
				if (ga_type_param->islandPopulation <= ga_encode_param->numVariable + 1) {
					log_sys(" ## Error: Island population must be larger than number of variables + 2: %d.\n", ga_encode_param->numVariable + 2);
					goto out;
				}
				if(ga_type_param->islandPopulation > ISLAND_POP_MAX){
					log_sys(" ## Error: Island population must be smaller than equal %d.\n", ISLAND_POP_MAX);
					goto out;
				}
			}
			/* οθοп׻ */
			ga_type_param->totalPopulation =
				ga_type_param->numIsland *
				ga_type_param->islandPopulation;
			break;
		case 5: /* Immigration switch(DGA) or integrate generation(DIGA) */
			switch (temp_ga_type) {
			case DGA:
				if(count_char == 0) {
					ga_type_param->immigrationSwitch = RANDOM_SWAP;
					temp_switch = RANDOM_SWAP;
				} else {
					if(!strcmp("ON", read_top) || !strcmp("RandomSwap", read_top)) {
						temp_switch = RANDOM_SWAP;
						ga_type_param->immigrationSwitch = RANDOM_SWAP;
						if(ga_type_param->numIsland == 1){
							log_sys("Error: There is a island. Cannot emigrate.\n");
							goto out;
						}
					} else if(!strcmp("RandomRing", read_top)){
						temp_switch = RANDOM_RING;
						ga_type_param->immigrationSwitch = RANDOM_RING;
						if(ga_type_param->numIsland == 1){
							log_sys("Error: There is a island. Set immigration switch OFF.\n");
							goto out;
						}
					} else if(!strcmp("OFF", read_top)) {
						temp_switch = IMMIGRATION_OFF;
						ga_type_param->immigrationSwitch = IMMIGRATION_OFF;
					} else {
							log_sys("Error: There is a island. Set immigration switch OFF.\n");
						goto out;
					}
				}
				break;
			case DIGA:
				if(count_char == 0) {
					ga_type_param->integrateGeneration = 5;
				} else {
					sscanf(read_top, "%d", &(ga_type_param->integrateGeneration));
					if(ga_type_param->integrateGeneration <= 0) {
						log_sys(" ## Error: Integrate generation must be a positive interger.\n");
						goto out;
					}
				}
				break;
			default: break;
			}
			break;
			
		case 6: /* Immigtration interval(DGA) or Redundunt(DIGA) */
			switch (temp_ga_type) {
			case DGA:
				if(ga_type_param->immigrationSwitch == 
					IMMIGRATION_OFF) {
				   	log_sys(" ## Warning: Redundant prameters for DGA(immigration off).\n");
					goto end;
				}
				if(count_char == 0) {
					ga_type_param->immigrationInterval = 3;
				} else {
					sscanf(read_top, "%d", &(ga_type_param->immigrationInterval));
					if(ga_type_param->immigrationInterval <= 0) {
						log_sys(" ## Error: Immigration interval must be a positive integer.\n");
						goto out;
					}
				}
				break;
			case DIGA:
				log_sys(" ## Warning: Redundant parameters for DIGA\n");
				goto end;
			}
			break;

		case 7: /* Immigration rate */
			if(count_char == 0) {
				ga_type_param->immigrationRate = 0.1;
			} else {
				sscanf(read_top, "%lf", &(ga_type_param->immigrationRate));
				if (ga_type_param->immigrationRate < 0 ||
					ga_type_param->immigrationRate > 1){
					log_sys(" ## Error: Immigration rate must be in region [0,1]\n");
					goto out;
				}
			}
			ga_type_param->numImmigrants =
					(int) (ga_type_param->islandPopulation * 
						   ga_type_param->immigrationRate);
			break;
		default: /* Redundunt prameters(DGA) */
			log_sys(" ## Warning: Redundant parameters for DGA(immigration on).\n");
			goto end;
		}
	}

	switch (temp_ga_type) {
	case DGA:
		if(temp_switch != IMMIGRATION_OFF) {
			if(param_count < 7) {
				log_sys(" ## Error: Shortage of parameters for DGA(immigration on)\n");
				goto out;
			}
		} else {
			if(param_count < 5) {
				log_sys(" ## Error: Shortage of parameters for DGA(immigration off)\n");
				goto out;
			}
		}
		break;
	case DIGA:
		if (param_count < 5) {
			log_sys(" ## Error: Shortage of parameters for DIGA\n");
			goto out;
		}
		break;
	default:
		break;
	}

end:		
	rv = EXIT_NORMAL;

out:
#ifdef DBG
	DBGW(10, ("set_gatype_param exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}	

/*-----
 * set_digenesis_paramؿ
 * 	Ϳ줿ʸ󤫤顤DigenesisParam_TΥѥ᡼򥻥å
 */
static int set_digenesis_param(DigenesisParam_T *digenesis_param, const GaEncodeParam_T *ga_encode_param, const GaTypeParam_T *ga_type_param)
{
	int	temp_digenesis = 0;
	int	temp_selection = 0;
	int param_count;
	int	count_char;		/* MyStrtok */
	int	rv = EXIT_ERROR;	
	char 	*read_top;	

#ifdef DBG
	DBGW(10, ("set_digenesis_param enter.\n"));
#endif /* DBG */
	
	for(param_count = 0; 
		(count_char = MyStrtok(NULL, ';', &read_top)) != FIND_NO_DELIM; 
			param_count++) {
		switch(param_count) {
		case 0: /* DIGENESIS TYPE */
		 	if(count_char == 0) {
				log_sys(" ## Error: No selected choice: DIGENESIS\n");
				goto out;
			}
			if(!strcmp("NORMAL", read_top)) {
				digenesis_param->digenesisType = NORMAL_DIGENESIS;
				temp_digenesis = NORMAL_DIGENESIS;
			} else if(!strcmp("MGG", read_top)) {
				digenesis_param->digenesisType = MGG;
				temp_digenesis = MGG;
			} else {
				log_sys(" ## Error: Unknown digenesis type:%s\n", read_top);
				goto out;
			}
			break;
			
		case 1: /* Number of elites(Normal) or Number of Chiledren(MGG) */
			switch(temp_digenesis) {
			case NORMAL_DIGENESIS:
				if(count_char == 0) {
					digenesis_param->numElite = 
						ga_encode_param->numVariable;
				} else {
					sscanf(read_top, "%d", 
						&(digenesis_param->numElite));
					if (digenesis_param->numElite < 0) {
						log_sys(" ## Error: Number of elites must be a positive interger or 0.\n");
						goto out;
					}
					if (digenesis_param->numElite >=
						ga_type_param->islandPopulation) {
						log_sys(" ## Error: Number of elites must be smaller than island population.\n");
						goto out;
					}
					if (digenesis_param->numElite >=
							(ga_type_param->islandPopulation - 
							 ga_type_param->numImmigrants)){
						log_sys(" ## Error: Number of elites must be smaller than (Island population - Number of immigrants).\n");
						goto out;
					}
				}
				break;
			case MGG:
				if(count_char == 0) {
					digenesis_param->numMGGChildren = 
						ga_type_param->islandPopulation;
					if(digenesis_param->numMGGChildren > (NUM_MGG_MAX)){
						digenesis_param->numMGGChildren = NUM_MGG_MAX;
					}
				} else {
					sscanf(read_top, "%d", 
						&(digenesis_param->numMGGChildren));
					if(digenesis_param->numMGGChildren <= 0) {
						log_sys(" ## Error: Number of MGG's children must be a positive interger.\n");
						goto out;
					}
					if(digenesis_param->numMGGChildren > NUM_MGG_MAX) {
						log_sys(" ## Error: Number of MGG's children must be smaller than equal %d.\n", NUM_MGG_MAX);
					}
				}
				digenesis_param->selectionType = RANDOM;
				break;
			default: break;
			}
			break;

		case 2: /* Selection method(NORMAL) of Redundant(MGG) */
			switch(temp_digenesis) {
			case NORMAL_DIGENESIS:
				if(count_char == 0) {
					digenesis_param->selectionType = TOURNAMENT;
					temp_selection = TOURNAMENT;
				} else {
					if(!strcmp("Roulette", read_top)) {
						digenesis_param->selectionType = ROULETTE;
						temp_selection = ROULETTE;
					} else if(!strcmp("Tournament", read_top)) {
						digenesis_param->selectionType = TOURNAMENT;
						temp_selection = TOURNAMENT;
					} else if(!strcmp("Random", read_top)) {
						digenesis_param->selectionType = RANDOM;
						temp_selection = RANDOM;
					} else {
						log_sys(" ## Error: Unknown selection type: %s\n", read_top);
						goto out;
					}
				}
				break;
			case MGG:
				log_sys(" ## Warning: Redundand parameters for MGG.\n");
				goto end;
			default: break;
			}
			break;
			
		case 3: /* Tounament Size(TOUNAMENT) or Redundant(NOT TOUNAMET) */
			switch (temp_selection) {
			case TOURNAMENT:
				if(count_char == 0) {
					digenesis_param->tournamentSize = 2;
				} else {
					sscanf(read_top, "%d", 
						&(digenesis_param->tournamentSize));
					if(digenesis_param->tournamentSize <= 0) {
						log_sys(" ## Error: Tounament Size must be a positive interger.\n");
						goto out;
					}
				}
				break;
			case ROULETTE:
				log_sys(" ## Warning: Redundant parameters for a roulette selection.\n");
				goto end;
			case RANDOM:
				log_sys(" ## Warning: Redundant parameters for a random selection.\n");
				goto end;
			default: break;
			}
			break;

		default: /* Redundant(Tounament) */
			log_sys(" ## Warning: Redundant parameters for a tounement selection.\n");
			goto end;
		}
	}

	/* ѥ᡼­å */
	switch (temp_digenesis) {
	case NORMAL_DIGENESIS:
		switch (temp_selection) {
		case TOURNAMENT:
			if(param_count < 4) {
				log_sys(" ## Error: Shortage of parameters for a normal digenesis(Tounament).\n");
				goto out;
			}
			break;
		case ROULETTE:
		case RANDOM:
			break; /* temp_selectionˤͤäƤOKʤΤ */
		default: 
			if(param_count == 2) {
				log_sys(" ## Error. Shortage of parameters for a normal digenesis.\n");
				goto out;
			}
			break;
		}
		break;
	case MGG:
		if(param_count < 2) {
			log_sys(" ## Error: Shortage of parameters for MGG.\n");
			goto out;
		}
		break;
	default:
		break;
	}

end:		
	rv = EXIT_NORMAL;

out:
#ifdef DBG
	DBGW(10, ("set_digenesis_param exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

	
/*-----
 * set_crossover_paramؿ
 * 	Ϳ줿ʸ󤫤顤CrossoverParam_TΥѥ᡼򥻥å
 */
static int set_crossover_param(CrossoverParam_T *crossover_param, const GaEncodeParam_T *ga_encode_param)
{
	int	temp_crossover = 0;
	int param_count;
	int	count_char;		/* MyStrtok */
	int	rv = EXIT_ERROR; 
	char 	*read_top;	

#ifdef DBG
	DBGW(10, ("set_crossover_param enter.\n"));
#endif /* DBG */
	
	for(param_count = 0; 
		(count_char = MyStrtok(NULL, ';', &read_top)) != FIND_NO_DELIM; 
			param_count++) {
		switch(param_count) {
		case 0: /* CROSSOVER TYPE */
		 	if(count_char == 0) {
				log_sys(" ## Error: No selected choice: Crossover type\n");
				goto out;
			}
			if(!strcmp("BLX", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: BLX is a crossover for RGA.\n");
					goto out;
				}
				crossover_param->crossoverType = BLX;
				temp_crossover = BLX;
			} else if(!strcmp("UNDX", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: UNDX is a crossover for RGA.\n");
					goto out;
				}
				crossover_param->crossoverType = UNDX;
				temp_crossover = UNDX;
			} else if(!strcmp("UNDXm", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: UNDXm is a crossover for RGA.\n");
					goto out;
				}
				crossover_param->crossoverType = UNDXM;
				temp_crossover = UNDXM;
			} else if(!strcmp("SPX", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: SPX is a crossover for RGA.\n");
					goto out;
				}
				crossover_param->crossoverType = SPX;
				temp_crossover = SPX;
			} else if(!strcmp("NPOINTS", read_top)) { 
				if(ga_encode_param->encodeType == REAL){
					log_sys(" ## Error: NPOINTS is a crossover for BGA.\n");
					goto out;
				}
				crossover_param->crossoverType = NPOINTS;
				temp_crossover = NPOINTS;
			} else if(!strcmp("NONE", read_top)) {
				crossover_param->crossoverType = NO_CROSSOVER;
				temp_crossover = NO_CROSSOVER;
			} else {
				log_sys(" ## Error: Unknown crossover type:%s\n", read_top);
				goto out;
			}
			break;

		case 1: /* BLX, UNDX, UNDXm, SPX */
			if(temp_crossover == NO_CROSSOVER) {
				log_sys(" ## Warning: Redundant parameters for no crossover.\n");
				goto end;
			}
			if(count_char == 0) {
				switch (temp_crossover) {
				case BLX:
					crossover_param->alpha = 0.5;
					break;
				case UNDX:
				case UNDXM:
					crossover_param->alpha = 1.0;
					break;
				case SPX:
					/* sqrt(dimension of search domain + 2) */
					crossover_param->alpha =
						sqrt(ga_encode_param->numVariable + 2);
					break;
				case NPOINTS:
					crossover_param->m = 1;
					break;
				default: break;
				}
			} else {
				if(ga_encode_param->encodeType == REAL){
					sscanf(read_top, "%lf", &(crossover_param->alpha));
					if(crossover_param->alpha <= 0.0) {
						switch (temp_crossover){
						case BLX:
							log_sys(" ## Error: BLX's parameter alpha must be positive.\n");
								goto out;
						case UNDX:
						case UNDXM:
							log_sys(" ## Error: UNDX(UNDXm)'s parameter alpha must be positive.\n");
							goto out;
						case SPX:
							log_sys(" ## Error: SPX's epsilon must be positive.\n");
							goto out;
						default: break;
						}
					}
				} else {
					sscanf(read_top, "%d", &(crossover_param->m));
					if(crossover_param->m <= 0){
						log_sys(" ## Error: N points crossover's \'n\' must be a positive interger.\n");
						goto out;
					}
					if(crossover_param->m >= ga_encode_param->geneLength){
						log_sys(" ## Error: N points crossover's \'n\' must be smaller than gene length %d.\n", ga_encode_param->geneLength);
						goto out;
					}
				}
			}
			break;

		case 2: /* UNDX, UNDXm or Redundant(BLX, SPX) */
			if(count_char == 0){
				switch(temp_crossover) {
				case UNDX:
				case UNDXM:
					crossover_param->beta = 0.35;
					break;
				case BLX:
					log_sys(" ## Warning: Redundant parameters for BLX\n");
					goto end;
				case SPX:
					log_sys(" ## Warning: Redundant parameters for SPX\n");
					goto end;
				case NPOINTS:
					log_sys(" ## Warning: Redundant parameters for N points crossover.\n");
					goto end;
				default: break;
				}
			} else {
				switch(temp_crossover){
				case UNDX:
				case UNDXM:
					sscanf(read_top, "%lf", &(crossover_param->beta));
					if(crossover_param->beta <= 0) {
						log_sys(" ## Error: UNDX(UNDXm)'s beta must be positive.\n");
						goto out;
					}
					break;
				case BLX:
					log_sys(" ## Warning: Redundant parameters for BLX\n");
					goto end;
				case SPX:
					log_sys(" ## Warning: Redundant parameters for SPX\n");
					goto end;
				case NPOINTS:
					log_sys(" ## Warning: Redundant parameters for N points crossover.\n");
					goto end;
				default: break;
				}
			}
			break;
		case 3: /* UNDXm or Redundant(UNDX) */
			switch(temp_crossover) {
			case UNDX:
				log_sys(" ## Warning: Redandunt parameters for UNDX.\n");
				goto end;
			case UNDXM:
				if(count_char == 0) {
					crossover_param->m = 
						ga_encode_param->numVariable - 2;
					if(crossover_param->m <= 0){
						crossover_param->m = 1;
					}
				} else {
					sscanf(read_top, "%d", &(crossover_param->m));
					if(crossover_param->m <= 0){
						log_sys(" ## Error: UNDXm's m must be a positive integer.\n");
						goto out;
					}
					if(crossover_param->m >
						ga_encode_param->numVariable){
						log_sys(" ## Error: UNDXm's m must be smaller than equal number of variables.\n");
						goto out;
					}
				}
				break;
			default: break;
			}
			break;

		default: /* Redundant */
			log_sys(" ## Warning: Redundant parameters for UNDXm.\n");
			goto end;
		}
	}
					
	/* ѥ᡼­å */
	switch (temp_crossover) {
	case BLX:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for BLX.\n");
			goto out;
		}
		break;
	case UNDX:
		if(param_count < 3){
			log_sys(" ## Error: Shortage of parameters for UNDX.\n");
			goto out;
		}
		break;
	case UNDXM:
		if(param_count < 4){
			log_sys(" ## Error: Shortage of parameters for UNDXm.\n");
			goto out;
		}
		break;
	case SPX:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for SPX.\n");
			goto out;
		}
		break;
	case NPOINTS:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for N points crossover.\n");
			goto out;
		}
		break;
	default:
		break;
	}

end:	
	/* ˡ˱ơƤο򥻥å */
	switch (temp_crossover) {
	case BLX:
		crossover_param->numParent = 2;
		break;
	case UNDX:
		crossover_param->m = 1;
		crossover_param->numParent = 3;
		break;
	case UNDXM:
		crossover_param->numParent = crossover_param->m + 2;
		break;
	case SPX:
		crossover_param->numParent = 
			ga_encode_param->numVariable + 1;
		break;
	case NPOINTS:
		crossover_param->numParent = 2;
	default: break;
	}
		
	rv = EXIT_NORMAL;

out:
#ifdef DBG
	DBGW(10, ("set_crossover_param exit(%d)\n", rv));
#endif /* DBG */
	return rv;
}


/*-----
 * set_mutaion_paramؿ
 * 	Ϳ줿ʸ󤫤顤MutationParam_TΥѥ᡼򥻥å
 */
static int set_mutation_param(MutationParam_T *mutation_param, GaEncodeParam_T *ga_encode_param)
{
	int	temp_mutation = 0;
	int param_count;
	int	count_char;		/* MyStrtok */
	int rv = EXIT_ERROR;
	char 	*read_top;	

#ifdef DBG
	DBGW(10, ("set_mutation_param enter.\n"));
#endif /* DBG */
	
	for(param_count = 0; 
		(count_char = MyStrtok(NULL, ';', &read_top)) != FIND_NO_DELIM; 
			param_count++) {
		switch(param_count) {
		case 0: /* MUTATION TYPE */
		 	if(count_char == 0) {
				log_sys(" ## Error: No selected choice: Mutation type\n");
				goto out;
			}
			if(!strcmp("RegionUni", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: RegionUni is a mutation for RGA.\n");
					goto out;
				}
				mutation_param->mutationType = REGION_UNI;
				temp_mutation = REGION_UNI;
			} else if(!strcmp("FixedUni", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: FixedUni is a mutation for RGA.\n");
					goto out;
				}
				mutation_param->mutationType = FIXED_UNI;
				temp_mutation = FIXED_UNI;
			} else if(!strcmp("FixedNormal", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: FixedNormal is a mutation for RGA.\n");
					goto out;
				}
				mutation_param->mutationType = FIXED_NORMAL;
				temp_mutation = FIXED_NORMAL;
			} else if(!strcmp("VariableUni", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: VariableUni is a mutation for RGA.\n");
					goto out;
				}
				mutation_param->mutationType = VARIABLE_UNI;
				temp_mutation = VARIABLE_UNI;
			} else if(!strcmp("VariableNormal", read_top)) {
				if(ga_encode_param->encodeType != REAL){
					log_sys(" ## Error: VariableNormal is a mutation for RGA.\n");
					goto out;
				}
				mutation_param->mutationType = VARIABLE_NORMAL;
				temp_mutation = VARIABLE_NORMAL;
			} else if(!strcmp("BitReverse", read_top)){
				if(ga_encode_param->encodeType == REAL){
					log_sys(" ## Error: BitReverse is a mutation for BGA.\n");
					goto out;
				}
				mutation_param->mutationType = BIT_REVERSE;
				temp_mutation = BIT_REVERSE;
			} else if(!strcmp("NONE", read_top)) {
				mutation_param->mutationType = NO_MUTATION;
				temp_mutation = NO_MUTATION;
			} else {
				log_sys(" ## Error: Unknown mutation type:%s\n", read_top);
				goto out;
			}
			break;

		case 1: /* Mutation rate or Redundant(NONE) */
			if(temp_mutation == NO_MUTATION) {
				log_sys(" ## Warning: Redundant parameters for no mutation.\n");
				goto end;
			}
			if(count_char == 0) {
				mutation_param->mutationRate = 
					1.0 / (double)ga_encode_param->geneLength;
			} else {
				sscanf(read_top, "%lf", &(mutation_param->mutationRate));
				if(mutation_param->mutationRate < 0.0 ||
					mutation_param->mutationRate > 1.0) {
					log_sys(" ## Error: Mutation rate must be in region [0, 1]\n");
					goto out;
				}
			}
			break;
		case 2: /* Fixed width(SD for FixedNormal) or Redundant(Variable) */
			switch (temp_mutation) {
			case REGION_UNI:
				log_sys(" ## Warning: Redundant parameters for RegionUni.\n");
				goto end;
			case FIXED_UNI:
				if(count_char == 0) {
					mutation_param->fixedWidth = 20;
				} else {
					sscanf(read_top, "%lf", &(mutation_param->fixedWidth));
					if(mutation_param->fixedWidth <= 0) {
						log_sys(" ## Error: Fixed width must be positive.\n");
						goto out;
					}
				}
				break;
			case FIXED_NORMAL:
				if(count_char == 0) {
					mutation_param->fixedWidth = 2;
				} else {
					sscanf(read_top, "%lf", &(mutation_param->fixedWidth));
					if(mutation_param->fixedWidth <= 0) {
						log_sys(" ## Error: Standard deviation must be positive.\n");
						goto out;
					}
				}
				break;
			case VARIABLE_UNI:
			case VARIABLE_NORMAL:
				log_sys(" ## Warning: Redundant parameters for VariableUni(Normal).\n");
				goto end;
			case BIT_REVERSE:
				log_sys(" ## Warning: Redundant parameters for BitReverse.\n");
				goto end;
			default: break;
			}
			break;
		default:
			log_sys(" ## Warning: Redundant parameters for FixedUni(Normal).\n");
			goto end;
		}
	}
			

	/* ѥ᡼­å */
	switch (temp_mutation) {
	case REGION_UNI:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for RregionUni.\n");
			goto out;
		}
		break;
	case FIXED_UNI:
	case FIXED_NORMAL:
		if(param_count < 3){
			log_sys(" ## Error: Shortage of parameters for FixedUni(FixedNormal).\n");
			goto out;
		}
		break;
	case VARIABLE_UNI:
	case VARIABLE_NORMAL:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for VariableUni(VariableNormal).\n");
			goto out;
		}
		break;
	case BIT_REVERSE:
		if(param_count < 2){
			log_sys(" ## Error: Shortage of parameters for BitReverse.\n");
			goto out;
		}
		break;
	default:
		break;
	}

end:		
	rv = EXIT_NORMAL;

out:

#ifdef DBG
	DBGW(10, ("set_mutation_param exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

#ifdef PARA_DBG
static void dumpGaParam(GaParam_T *ga_param)
{
	printf("GA Type = %d\n", ga_param->gaTypeParam.gaType);
	printf("max generation = %d\n", ga_param->gaTypeParam.maxGeneration);
	printf("fin value = %f\n", ga_param->gaTypeParam.finValue);
	printf("num variable = %d\n", ga_param->gaTypeParam.numVariable);
	printf("total population = %d\n", ga_param->gaTypeParam.totalPopulation);
	printf("num island = %d\n", ga_param->gaTypeParam.numIsland);
	printf("island population = %d\n", ga_param->gaTypeParam.islandPopulation);
	printf("immigration switch = %d\n", ga_param->gaTypeParam.immigrationSwitch);
	printf("immigration interval = %d\n", ga_param->gaTypeParam.immigrationInterval);
	printf("immigration rate = %f\n", ga_param->gaTypeParam.immigrationRate);
	printf("integrate generation = %d\n", ga_param->gaTypeParam.integrateGeneration);
	
	printf("digenesis type = %d\n", ga_param->digenesisParam.digenesisType);
	printf("num elite = %d\n", ga_param->digenesisParam.numElite);
	printf("selection type = %d\n", ga_param->digenesisParam.selectionType);
	printf("tounament size = %d\n", ga_param->digenesisParam.tounamentSize);
	printf("MGG children = %d\n", ga_param->digenesisParam.numMGGChildren);
	
	printf("crossover type = %d\n", ga_param->crossoverParam.crossoverType);
	printf("alpha = %f\n", ga_param->crossoverParam.alpha);
	printf("beta = %f\n", ga_param->crossoverParam.beta);
	printf("m = %d\n", ga_param->crossoverParam.m);

	printf("mutation type = %d\n", ga_param->mutationParam.mutationType);
	printf("mutaion rate =%f\n", ga_param->mutationParam.mutationRate);
	printf("fixed width =%f\n", ga_param->mutationParam.fixedWidth);

	printf("region file = %s\n", ga_param->ioParam.regionFileName);
	printf("parameter file = %s\n", ga_param->ioParam.paramFileName);
	printf("output file = %s\n", ga_param->ioParam.outputFileName);
	printf("output file_p = %p\n", ga_param->ioParam.outputFile);

	printf("min array = %p\n", ga_param->variableRegion.minArray);
	printf("max array = %p\n", ga_param->variableRegion.maxArray);
	
	printf("argc = %d\n", ga_param->comLine.argc);
	for(int i = 0; i < ga_param->comLine.argc; i++){
		printf("%s\n", ga_param->comLine.argv[i]);
	}
}
				
static void dumpRegion(GaParam_T *ga_param)
{
	int	i;

	for (i = 0; i < ga_param->gaTypeParam.numVariable; i++) {
		printf("Domain Variable[%d] :[%f, %f]\n", i, 
			ga_param->variableRegion.minArray[i],
			ga_param->variableRegion.maxArray[i]);
	}
}
#endif /* PARA_DBG */
