/*
 * Utility of algebra
 *
 * utl_alge.h
 */
#ifndef _UTL_ALGE_H_
#define _UTL_ALGE_H_

/*
 * Prottype declarations of a function
 */

/*-----
 * VectorInnerProduct
 */
double VectorInnerProduct(double *in_vec1, double *in_vec2, int dim_vec);

/*-----
 * VectorNorm
 */
double VectorNorm(double *in_vec, int dim_vec);




/*-----
 * CalculateCenterOfGravity
 */
extern int CalculateCenterOfGravity(double **in_vecs, int num_vec, int dim_vec, double *out_vec);

/*-----
 * TransposedMatrix
 */
extern int TransposedMatrix(double **in_mat, int num_row, int num_col, double **out_mat);

/*-----
 * ProductMatrix
 */
extern int ProductMatrix(double **in_mat1, int num_row1, int num_col1, double **in_mat2, int num_row2, int num_col2, double **out_mat);

/*-----
 * ReductMatrix
 */
extern int ReductMatrix(double **in_mat, int num_row, int num_col, double **out_mat);

/*-----
 * GrammSchmidtOrthogonalize
 */
extern int GrammSchmidtOrthogonalize(double **in_vecs, int num_vec, int dim_vec, double **out_vecs);

#endif /* _UTL_ALGE_H_ */
