/*
 * Utility of memory allocation
 *
 * utl_alloc.h
 */
#ifndef _UTL_ALLOC_H_
#define _UTL_ALLOC_H_

#include "randb.h"

/*
 * Prottype declarations of a function
 */

/*-----
 * IntVectorAllocؿ
 * 	ǻꤵ줿礭int
 * 	ΰݤƬΥݥ󥿤֤
 */
extern int *IntVectorAlloc(int vector_size);

/*-----
 * FreeGaGeneVectorؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeIntVector(int *int_vector);

/*-----
 * IntMatrixAllocؿ
 * 	ǻꤵ줿礭intι
 * 	ΰݤƬΥݥ󥿤֤
 */
extern int **IntMatrixAlloc(int num_row, int num_col);

/*-----
 * FreeIntMatrixؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeIntMatrix(int **int_mat);


/*-----
 * DoubleVectorAllocؿ
 * 	ǻꤵ줿礭GaGene_T
 * 	ΰݤƬΥݥ󥿤֤
 */
extern double *DoubleVectorAlloc(int vector_size);

/*-----
 * FreeDoubleVectorؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeDoubleVector(double *island);

/*-----
 * DoubleMatrixAllocؿ
 * 	ǻꤵ줿礭GaGene_Tι
 * 	ΰݤƬΥݥ󥿤֤
 */
extern double **DoubleMatrixAlloc(int num_row, int num_col);

/*-----
 * FreeDoubleMatrixؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeDoubleMatrix(double **double_mat);



/*-----
 * GaGeneVectorAllocؿ
 * 	ǻꤵ줿礭GaGene_T
 * 	ΰݤƬΥݥ󥿤֤
 */
extern GaGene_T *GaGeneVectorAlloc(int vector_size);

/*-----
 * FreeGaGeneVectorؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeGaGeneVector(GaGene_T *island);

/*-----
 * GaGeneMatrixAllocؿ
 * 	ǻꤵ줿礭GaGene_Tι
 * 	ΰݤƬΥݥ󥿤֤
 */
extern GaGene_T **GaGeneMatrixAlloc(int num_row, int num_col);

/*-----
 * FreeGaGeneMatrixؿ
 * 	ǻꤵ줿ΰ
 */
extern void FreeGaGeneMatrix(GaGene_T **islands);

/*-----
 * GaIslandVectorAlloc
 */
extern GaIsland_T *GaIslandVectorAlloc(int vector_size);

/*-----
 * FreeGaIslandVector
 */
extern void FreeGaIslandVector(GaIsland_T *islands);
#endif /* _UTL_ALLOC_H_ */

