/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ȿ
 *
 ***********************************************************************/

#ifndef _JREACTION_T_
#define _JREACTION_T_

#include "jutil_common.h"
#include "JListOfReactants.h"
#include "JListOfProducts.h"
#include "JListOfModifiers.h"
#include "JModifierComplex.h"

/* reactionType */
#define REACTION_REACTIONTYPE_NONE					0
#define REACTION_REACTIONTYPE_BINDING					1
#define REACTION_REACTIONTYPE_BINDING_WITH_STOICHIOMETRIC_CHANGES	2
#define REACTION_REACTIONTYPE_HOMO_ASSOCIATION_OR_MODIFICATION		3
#define REACTION_REACTIONTYPE_HOMO_ASSOCIATION_OR_MODIFICATION_WITH_STOICHIOMETRIC_CHANGES	4
#define REACTION_REACTIONTYPE_ELIMINATION				5
#define REACTION_REACTIONTYPE_ELIMINATION_WITH_STOICHIOMETRIC_CHANGES	6
#define REACTION_REACTIONTYPE_REVERSIBLE_CONVERSION			7
#define REACTION_REACTIONTYPE_IRREVERSIBLE_CONVERSION			8
#define REACTION_REACTIONTYPE_REVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT	9
#define REACTION_REACTIONTYPE_IRREVERSIBLE_CONVERSION_REGARDING_MULTICOMPONENT	10
#define REACTION_REACTIONTYPE_TRANSPORT					11
#define REACTION_REACTIONTYPE_OPTION_TRANSPORT				12
#define REACTION_REACTIONTYPE_TRANSCRIPTION				13
#define REACTION_REACTIONTYPE_TRANSLATION				14
#define REACTION_REACTIONTYPE_DEGRADATION				15

/* isConvertible -> JModelPack (true/false) */

typedef struct {
	int			reactionID;
	int			groupID;
	int			reactionType;
	int			isConvertible;
	char			modifierReactionEquation[EQUATION_LENGTH];
	int			listOfReactants_n;
	JListOfReactants_t	*listOfReactants;
	int			listOfProducts_n;
	JListOfProducts_t	*listOfProducts;
	int			listOfModifiers_n;
	JListOfModifiers_t	*listOfModifiers;
	int			modifierComplex_n;
	JModifierComplex_t	*modifierComplex;
} JReaction_t;

#endif /* _JREACTION_T_ */
