/**************************************************************
 *	TMCƖxVXei߂QPj
 *
 *		XXXXXXXXXXXXXXXX
 *
 *	Copyright (C) 2000 %%MAKER%%
 **************************************************************/
#ifndef lint
static char SccsId[] = "%Z%META21 %M% %I% %D% %U%";
#endif

#ifndef DEBUG
#define DEBUG
#endif
#include "ju_conv.h"
#include "c_dbg.h"

/*****************************************************************************
 * ֐
 *	JU_dump_struct: C structure+MM_DATA -> File
 * @\
 *	C̍\̂̃_vo
 * 
 *	FILE		*fp		I : t@C|C^
 *	MM_DATA_t	*mmd		I : NX/\̃f[^
 *	char		*rec		I : \̂ւ̃|C^
 * ֐l
 *	 0:	
 *	-1:	ُ
 * 
 *	
 *****************************************************************************/
int
JU_dump_struct(FILE *fp, MM_DATA_t *mmd, void *recv)
{
	char	*rec = (char*)recv;
	int i, j, k;
	M_DATA_t *md = mmd->mdata;
	char str[256];
	char sig[256];
	long long val;
	MM_DATA_t *a_mmd;
	M_DATA_t *a_md;
	long long a_num;
	char *a_rec;
	
	fprintf(fp, "--CLASS<%s>--\n", mmd->clsname);
	for (i=0; i<mmd->fld_n; i++) {
		fprintf(fp, "%s(%d) : \n", md[i].name, md[i].offset);
		switch (md[i].type) {
		case M_STR:
			strncpy(str, rec+md[i].offset, 255);
			str[255]=0;
			if (md[i].len < 255) {
				str[md[i].len]=0;
			}
			fprintf(fp, "\"%s\"\n", str);
			break;
		case M_BYTE:
		case M_SHRT:
		case M_INT:
		case M_LONG:
		case M_BOOL:
			if (JU_getnum(rec, md[i].offset, md[i].len, &val)) {
				fprintf(fp, "getnum err\n");
				break;
			}
			if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
				goto err;
			}
			fprintf(fp, "%lld(%s)\n", val, sig);
			break;
		case M_BOOLARRY:
		case M_BARRY:
		case M_SARRY:
		case M_IARRY:
		case M_LARRY:
			if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
				goto err;
			}
			fprintf(fp, "ArrayNum=%d\n", md[i].arry_n);
			for (j=0; j<md[i].arry_n; j++) {
				if (JU_getnum(rec, md[i].offset+md[i].len*j, md[i].len, &val)) {
					fprintf(fp, "getnum err\n");
					break;
				}
				fprintf(fp, "\nelem[%d]=%lld(%s)\n", j, val, sig);
			}
			break;
		case M_ARRY:
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				fprintf(fp, "Unknown array class %s\n", md[i].arryclsname);
				goto err;
			}
			if (JU_fldname2md(mmd, md[i].arrynumname, &a_md)) {
				fprintf(fp, "Unknown array count field %s\n", md[i].arrynumname);
				goto err;
			}
			if (JU_getnum(rec, a_md->offset, a_md->len, &a_num)) {
				fprintf(fp, "Get a_num err\n");
				goto err;
			}
			fprintf(fp, "record_num=%lld\n", a_num);
			for (j=0; j<a_num; j++) {
				fprintf(fp, "--Elem[%d]--\n", j);
				a_rec = *((char**)(rec+md[i].offset));
				if (JU_dump_struct(fp, a_mmd, a_rec+(a_mmd->struct_size*j))) {
					goto err;
				}
			}
			break;
		case M_SUBSTRCT:
			if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
				fprintf(fp, "Unknown substruct class %s\n", md[i].arryclsname);
				fprintf(fp, "Unknown substruct class %s\n", md[i].arryclsname);
				goto err;
			}
			fprintf(fp, "--Substruct[%s]--\n", md[i].arryclsname);
			a_rec = rec+md[i].offset;
			if (JU_dump_struct(fp, a_mmd, a_rec)) {
				goto err;
			}
			break;
		default:
			fprintf(fp, "Unknown Type(%d)\n", md[i].type);
			break;
		}
		fprintf(fp, "\n");
	}
	fprintf(fp, "--------------\n");
	return 0;
err:
	return -1;
}

/*****************************************************************************
 * ֐
 *      JU_dbg_printstruct: C structure+MM_DATA -> printout
 * @\
 *      C̍\̂̃_vo
 * 
 *      MM_DATA_t       *mmd            I : NX/\̃f[^
 *      char            *rec            I : \̂ւ̃|C^
 * ֐l
 *       0:     
 *      -1:     ُ
 * 
 *      
 *****************************************************************************/
int
JU_dbg_printstruct(MM_DATA_t *mmd, void *recv)
{
	char	*rec = (char*)recv;
        int i, j, k;
        M_DATA_t *md = mmd->mdata;
        char str[256];
        char sig[256];
        long long val;
        MM_DATA_t *a_mmd;
        M_DATA_t *a_md;
        long long a_num;
        char *a_rec;
        
        DBG(50, ("--CLASS<%s>--\n", mmd->clsname));
        for (i=0; i<mmd->fld_n; i++) {
		DBG(50, ("%s(%d) : \n", md[i].name, md[i].offset));
                switch (md[i].type) {
                case M_STR:
                        strncpy(str, rec+md[i].offset, 255);
                        str[255]=0;
			if (md[i].len < 255) {
				str[md[i].len]=0;
			}
                        DBG(50, ("\"%s\"\n", str));
                        break;
                case M_BYTE:
                case M_SHRT:
                case M_INT:
                case M_LONG:
                case M_BOOL:
                        if (JU_getnum(rec, md[i].offset, md[i].len, &val)) {
                                LOG_ERR(("getnum err\n"));
                                break;
                        }
                        if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
                                goto err;
                        }
                        DBG(50, ("%lld(%s)\n", val, sig));
                        break;
                case M_BOOLARRY:
                case M_BARRY:
                case M_SARRY:
                case M_IARRY:
                case M_LARRY:
                        if (JU_mid2sig(md[i].type, md[i].arryclsname, sig, sizeof(sig))) {
                                goto err;
                        }
                        DBG(50, ("ArrayNum=%d\n", md[i].arry_n));
                        for (j=0; j<md[i].arry_n; j++) {
                                if (JU_getnum(rec, md[i].offset+md[i].len*j, md[i].len, &val)) {
                                        LOG_ERR(("getnum err\n"));
                                        break;
                                }
                                DBG(50, ("\nelem[%d]=%lld(%s)\n", j, val, sig));
                        }
                        break;
                case M_ARRY:
                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown array class %s\n", md[i].arryclsname));
                                goto err;
                        }
                        if (JU_fldname2md(mmd, md[i].arrynumname, &a_md)) {
                                LOG_ERR(("Unknown array count field %s\n", md[i].arrynumname));
                                goto err;
                        }
                        if (JU_getnum(rec, a_md->offset, a_md->len, &a_num)) {
                                LOG_ERR(("Get a_num err\n"));
                                goto err;
                        }
                        DBG(50, ("record_num=%lld\n", a_num));
                        for (j=0; j<a_num; j++) {
                                DBG(50, ("--Elem[%d]--\n", j));
                                a_rec = *((char**)(rec+md[i].offset));
                                if (JU_dbg_printstruct(a_mmd, a_rec+(a_mmd->struct_size*j))) {
                                        goto err;
                                }
                        }
                        break;
		case M_SUBSTRCT:
                        if (JU_clsname2mmd(md[i].arryclsname, &a_mmd)) {
                                LOG_ERR(("Unknown substruct class %s\n", md[i].arryclsname));
                                DBG(50, ("Unknown substruct class %s\n", md[i].arryclsname));
                                goto err;
                        }
			DBG(50, ("--Substruct[%s]--\n", md[i].arryclsname));
			a_rec = rec+md[i].offset;
			if (JU_dbg_printstruct(a_mmd, a_rec)) {
				goto err;
			}
                        break;
                default:
                        LOG_ERR(("Unknown Type(%d)\n", md[i].type));
                        break;
                }
                DBG(50, ("\n"));
        }
        DBG(50, ("--------------\n"));
        return 0;
err:
        return -1;
}
