BEGIN {
	instr = 0;
	findex = 0;
	sindex = 0;
	spstr = "";
	spstrIn = "";
	spstrEnd = "";
	needDBimport = 0;
}

/\/\*J.*J\*\// {
	a=$0;
	gsub(/\/\*J/,"", a);
	gsub(/J\*\//,"", a);
	spstr = spstr a "\n";
	next;
}

/\/\*K.*K\*\// {
	a=$0;
	gsub(/\/\*K/,"", a);
	gsub(/K\*\//,"", a);
	spstrIn = spstrIn a "\n";
	next;
}

/\/\*L.*L\*\// {
	a=$0;
	gsub(/\/\*L/,"", a);
	gsub(/L\*\//,"", a);
	spstrEnd = spstrEnd a "\n";
	next;
}

/^[\t ]*$/ {
	next;
}

/^[\t ]*\#if/ {
	next;
}

/^[\t ]*\#end/ {
	next;
}

/^[\t ]*\#else/ {
	next;
}
/^[\t ]*\#include/ {
	next;
}

/typedef[\t ]*struct.*\{/ {
	instr = 1;
	next;
}

/[\t ]*\#[\t ]*define[\t ]+[A-Za-z_][A-Za-z0-9_]*[\t ]+[A-Za-z\-0-9][A-Za-z_\.\-0-9]*/ {
	if (length($3) <= 0)
		next;
	sname[sindex] = $2;
	sval[sindex] = $3;
	a = $0;
	gsub(/[\t ]*\#[\t ]*define[\t ]+[A-Za-z_][A-Za-z0-9_]*[\t ]+[A-Za-z\-0-9][A-Za-z_\.\-0-9]*/, "", a);
	scom[sindex] = a;
	sindex++;
	next;
}

/[\t ]*\#[\t ]*define[\t ]+[A-Za-z_][A-Za-z0-9_]*[\t ]+\".*\"*/ {
	if (length($3) <= 0)
		next;
	sname[sindex] = $2;
	a = $0;
	sub(/\".*\"/, "[[&]]", a);
	sub(/^.*\[\[/, "", a);
	sub(/\]\].*$/, "", a);
	sval[sindex] = a;
	a = $0;
	sub(/\".*\"/, "[[&]]", a);
	sub(/^.*\]\]/, "", a);
	scom[sindex] = a;
	sindex++;
	next;
}

/char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { # String
	if (instr==0)
		next;
	if ($0 ~ /char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[[\t ]*1[\t ]*\][\t ]*;/) {
	    # char hoge[1] is char-array(not string)
	    gsub(/char/, "public byte", $0);
	    gsub(/\[.*\][\t ]*;/, ";", $0);
	    print $0;
	    field[findex] = $0;
	    findex++;
	    next;
	}
	gsub(/char/, "public String", $0);
	gsub(/\[.*\][\t ]*;/, ";\t", $0);
	field[findex] = $0;
	findex++;

	next;
}

/short[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { # short Array
	if (instr==0)
		next;
	gsub(/short/, "public &", $0);
	gsub(/\[.*\][\t ]*;/, "[];", $0);
	field[findex] = $0;
	findex++;

	next;
}

/int[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { # int array
	if (instr==0) {
		next;
	}
	gsub(/int/, "public &", $0);
	gsub(/\[.*\][\t ]*;/, "[];", $0);
	field[findex] = $0;
	findex++;

	next;
}

/long[\t ]+long[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { # long long array
	if (instr==0)
		next;
	gsub(/long[\t ]+long/, "public long\t", $0);
	gsub(/\[.*\][\t ]*;/, "[];", $0);
	field[findex] = $0;
	findex++;

	next;
}

/char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # byte
	if (instr==0)
		next;
	gsub(/char/, "public byte", $0);
	
	field[findex] = $0;
	findex++;

	next;
}

/short[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # short
	if (instr==0)
		next;
	gsub(/short/, "public &", $0);
	
	field[findex] = $0;
	findex++;

	next;
}

/int[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # int
	if (instr==0)
		next;
	gsub(/int/, "public &", $0);
	
	field[findex] = $0;
	findex++;

	next;
}
/long[\t ]+long[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { #long long
	if (instr==0)
		next;
	gsub(/long[\t ]+long/, "public long\t", $0);
	
	field[findex] = $0;
	findex++;

	next;
}

/[A-Za-z_][A-Za-z0-9_]_t[\t ]+\*[A-Za-z_][A-Za-z0-9_][\t ]*/ { # structure array
	gsub(/_t[\t ]+\*/, " ");
	gsub(/;/, "[];");
	field[findex] = "\tpublic" firstaA($0);
	findex++;

	if( $1 ~ /sm_M[A-Za-z0-9_]/ || $1 ~ /sm_D[A-Za-z0-9_]/ ){
		needDBimport++;
	}

	next;
}

/[A-Za-z_][A-Za-z0-9_]_t[\t ]+[A-Za-z_][A-Za-z0-9_][\t ]*/ { # substructure
	gsub(/_t[\t ]+/, " ");
	field[findex] = "\tpublic" firstaA($0);
	findex++;

	if( $1 ~ /sm_M[A-Za-z0-9_]/ || $1 ~ /sm_D[A-Za-z0-9_]/ ){
		needDBimport++;
	}

	next;
}

/^[\t ]*\}[\t ]*[a-zA-Z_][a-zA-Z0-9_]*_t[\t ]*;/ { # .java output
	s = match($0, /[a-zA-Z_][a-zA-Z0-9_]*_t/);
	classname = topaA(substr($0, RSTART, RLENGTH-2));
	fname = classname ".java";
	rtypename = traA(classname);
	"cd ../..;basename `/bin/pwd` " | getline pkg1;
	"cd ..;basename `/bin/pwd` " | getline pkg2;
	pkgname = pkg1 "." pkg2;
	req = 0;
	rsp = 0;
	if (classname ~ /Req$/) {
	    req = 1;
	} else if (classname ~ /Rsp$/) {
	    rsp = 1;
	}
	print fname;
	print_header(fname, classname);
	printf("package jp.co.suri.lifesim;\n") >> fname;
	printf("%s", spstr) >> fname;
	spstr="";
        printf("import java.io.Serializable;\n") >> fname;

	## OTK modified
	#"/usr/ccs/bin/make echosrc" | getline needimport;
	#if( needimport != "" ){
	#    printf("import jp.co.suri.lifesim.client.%s.*;\n", pkgname) >> fname;
	#}

	## OTK modified 2
	#if( needDBimport ){
	#    printf("import jp.co.suri.lifesim.client.common.db.*;\n") >> fname;
	#}

	printf("public class %s ", classname) >> fname;
	if (req) {
	    printf("extends Request {\n") >> fname;
	} else if (rsp) {
	    printf("extends Response {\n") >> fname;
	} else {
	    printf("implements Serializable, Cloneable {\n") >> fname;
	}
	
	printf("\tpublic %s(){}\n", classname) >> fname;
	
	if (req) {
	    printf("\tprivate int     type = Request.TYPE_%s;\n", rtypename) >> fname;
	    printf("\tpublic  int     type() { return(type); }\n") >> fname;
	} else if (rsp) {
	    printf("\tprivate int     type = Response.TYPE_%s;\n", rtypename) >> fname;
	    printf("\tpublic  int     type() { return(type); }\n") >> fname;
	    printf("\tpublic  boolean\trsp_ok() { return(rsp_ok!=0); }\n") >> fname;
	    printf("\tpublic  String\terrmsg() { return errmsg; }\n") >> fname;
	} else {
		printf("\tpublic Object clone() throws CloneNotSupportedException {\n") >> fname;
		printf("\t\t/* Only Shallow Copy */\n") >> fname;
		printf("\t\treturn super.clone();\n") >> fname;
		printf("\t}\n") >> fname;
	}

	printf("%s", spstrIn) >> fname;
	spstrIn = "";
	for (i=0; i<sindex; i++) {
		if (substr(sval[i], 1, 1) == "\"") {
			valtype = "String";
		} else {
			valtype = "int";
		}
		printf("\tpublic static final %s %s = %s;\t%s\n", valtype, sname[i], sval[i], scom[i]) >> fname;
		if (length(scomcom[i]) > 0) {
		    printf("%s", scomcom[i]) >> fname;
		}
	}
	for (i=0; i<findex; i++) {
		printf("%s\n", field[i]) >> fname;
		if (length(fcom[i]) > 0) {
		    printf("%s", fcom[i]) >> fname;
		}
	}
	
	printf("}\n") >> fname;
	printf("%s", spstrEnd) >> fname;
	spstrEnd = "";
	for (i=0; i<sindex; i++) {
	    delete sname[i];
	    delete sval[i];
	    delete scom[i];
	    delete scomcom[i];
	}
	for (i=0; i<findex; i++) {
	    delete field[i];
	    delete fcom[i];
	}
	findex=0;
	sindex = 0;
	instr = 0;
	needDBimport = 0;
	next;
}

/\/\*.*\*\// {
    if (instr > 0 && findex > 0) {
	fcom[findex-1] = fcom[findex-1] $0 "\n";
    } else if (sindex > 1) {
	scomcom[sindex-1] = scomcom[sindex-1] "\t" $0 "\n";
    }
    next;
}

{
	print "UNKNOWN", $0;
}


END {

}


function traA(str,   i, a, s, t, u, pre) {
    # convert "AbcDefGhi" to "ABC_DEF_GHI"
    s = "";
    a["a"]="A";
    a["b"]="B";
    a["c"]="C";
    a["d"]="D";
    a["e"]="E";
    a["f"]="F";
    a["g"]="G";
    a["h"]="H";
    a["i"]="I";
    a["j"]="J";
    a["k"]="K";
    a["l"]="L";
    a["m"]="M";
    a["n"]="N";
    a["o"]="O";
    a["p"]="P";
    a["q"]="Q";
    a["r"]="R";
    a["s"]="S";
    a["t"]="T";
    a["u"]="U";
    a["v"]="V";
    a["w"]="W";
    a["x"]="X";
    a["y"]="Y";
    a["z"]="Z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	u = "";
	if (pre == 1) {
	    u = "_";
	}
	if (length(a[t])>0) {
		s = s a[t];
		pre = 1;
	} else {
		s = s u t;
	}
    }
    return s;
}

function topaA(str,   i, a, s, t, u, pre) {
    # convert "abcDefGhi" to "AbcDefGhi"
    s = "";
    a["a"]="A";
    a["b"]="B";
    a["c"]="C";
    a["d"]="D";
    a["e"]="E";
    a["f"]="F";
    a["g"]="G";
    a["h"]="H";
    a["i"]="I";
    a["j"]="J";
    a["k"]="K";
    a["l"]="L";
    a["m"]="M";
    a["n"]="N";
    a["o"]="O";
    a["p"]="P";
    a["q"]="Q";
    a["r"]="R";
    a["s"]="S";
    a["t"]="T";
    a["u"]="U";
    a["v"]="V";
    a["w"]="W";
    a["x"]="X";
    a["y"]="Y";
    a["z"]="Z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	if (length(a[t])>0 && i==1) {
	    s = s a[t];
	} else {
	    s = s t;
	}
    }
    return s;
}

function firstaA(str,   i, a, s, t, u, pre) {
    # convert "abcDefGhi" to "AbcDefGhi"
    s = "";
    a["a"]="A";
    a["b"]="B";
    a["c"]="C";
    a["d"]="D";
    a["e"]="E";
    a["f"]="F";
    a["g"]="G";
    a["h"]="H";
    a["i"]="I";
    a["j"]="J";
    a["k"]="K";
    a["l"]="L";
    a["m"]="M";
    a["n"]="N";
    a["o"]="O";
    a["p"]="P";
    a["q"]="Q";
    a["r"]="R";
    a["s"]="S";
    a["t"]="T";
    a["u"]="U";
    a["v"]="V";
    a["w"]="W";
    a["x"]="X";
    a["y"]="Y";
    a["z"]="Z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	if (pre == 0 && length(a[t])>0) {
	    s = s a[t];
	    pre = 1;
	} else {
	    s = s t;
	}
	if (pre == 0 && t != " " && t != "\t") {
	    pre = 1;
	}
    }
    return s;
}

function print_header(fname, classname) {
    printf("\057\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\012\040\052\012\040\052\040\040\040\040\040\300\270\314\277\245\267\245\337\245\345\245\354\241\274\245\277\012\040\052\012\040\052\040\040\040\040\040\040\040\040\040\112\141\166\141\040\103\154\141\163\163\040\050\045\163\051\012\040\052\012\040\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\052\057\012\n", classname) > fname;
}
