BEGIN {
	instr = 0;
	findex = 0;
	sindex = 0;
}

/^[\t ]*$/ {
	next;
}

/^[\t ]*\#[\t ]*if/ {
	next;
}

/^[\t ]*\#[\t ]*end/ {
	next;
}

/^[\t ]*\#[\t ]*else/ {
	next;
}

/^[\t ]*\#[\t ]*include/ {
	next;
}

/^[\t ]*\#[\t ]*define/ {
	next;
}

/typedef[\t ]*struct.*\{/ {
	instr = 1;
	next;
}

/char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { #/*  */
	if (instr==0)
		next;
	if ($0 ~ /char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[[\t ]*1[\t ]*\][\t ]*;/) {
	    # char hoge[1] is char-array(not string)
	    gsub(/\[.*\][\t ]*;/, "", $0);
	    gsub(/\/\*/, "", $2);
	    field[findex] = $2;
	    mtype[findex] = "M_BYTE";
	    findex++;
	    next;
	}
	gsub(/\[.*\][\t ]*;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_STR";
	findex++;

	next;
}

/short[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { #/* short z */
	if (instr==0)
		next;
	gsub(/\[.*\][\t ]*;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_SARRY";
	findex++;

	next;
}

/int[\t ]+[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { #/* int z */
	if (instr==0)
		next;
	gsub(/\[.*\][\t ]*;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_IARRY";
	findex++;

	next;
}

/long[\t ]+long[\t ]*[a-zA-Z_][a-zA-Z0-9_]*\[.*\][\t ]*;.*/ { #/* long longz */
	if (instr==0)
		next;
	gsub(/\[.*\][\t ]*;/, "", $0);
	gsub(/\/\*/, "", $3);
	field[findex] = $3;
	mtype[findex] = "M_LARRY";
	findex++;

	next;
}

/char[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # byte
	if (instr==0)
		next;
	
	gsub(/;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_BYTE";
	findex++;

	next;
}

/short[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # short
	if (instr==0)
		next;
	gsub(/;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_SHRT";
	findex++;

	next;
}

/int[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { # int
	if (instr==0)
		next;
	gsub(/;/, "", $0);
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_INT";
	findex++;

	next;
}
/long[\t ]+long[\t ]+[a-zA-Z_][a-zA-Z0-9_]*[\t ]*;/ { #long long
	if (instr==0)
		next;
	gsub(/;/, "", $0);
	gsub(/\/\*/, "", $3);
	field[findex] = $3;
	mtype[findex] = "M_LONG";
	findex++;

	next;
}

/[A-Za-z_][A-Za-z0-9_]_t[\t ].*\*[A-Za-z_][A-Za-z0-9_][\t ]*/ { # \̔z
	gsub(/_t[\t ]+\*/, " ");
	gsub(/;/, "");
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_ARRY";
	cname[findex] = topaA($1);
	findex++;

	next;
}

/[A-Za-z_][A-Za-z0-9_]_t[\t ].*[A-Za-z_][A-Za-z0-9_][\t ]*/ { # Tu\
	gsub(/_t[\t ]+/, " ");
	gsub(/;/, "");
	gsub(/\/\*/, "", $2);
	field[findex] = $2;
	mtype[findex] = "M_SUBSTRCT";
	cname[findex] = topaA($1);
	findex++;

	next;
}

/^[\t ]*\}[\t ]*[a-zA-Z_][a-zA-Z0-9_]*_t[\t ]*;/ { # mdatao
	s = match($0, /[a-zA-Z_][a-zA-Z0-9_]*_t/);
	typename = substr($0, RSTART, RLENGTH);
	clname = substr($0, RSTART, RLENGTH-2);
	classname = topaA(clname);
	rtypename = traA(classname);
	blname = tobl(clname);
	scmd = sprintf("basename %s", FILENAME);
	scmd | getline myfilename;
	"cd ../..;basename `/bin/pwd` " | getline pkg1;
	"cd ..;basename `/bin/pwd` " | getline pkg2;
	mypkgname = pkg1 "/" pkg2;
	fname = "m_" pkg2 "_" clname ".c";
	mfname = "mm_" pkg2 "_" clname ".c";
	printf("/* generated by struct2mdata, don't touch! */\n") > fname;    
	# printf("#include\t\"%s\"\n", myfilename) > fname;
	printf("M_DATA_t M_%s_%s[] = {\n", pkg2, clname) > fname;
	printf("/*struct:%s, class:%s */\n", typename, classname) >> fname;
	for (i=0; i<findex; i++) {
		if (mtype[i] ~ /M_SUBSTRCT/) {
                        printf("\tM_DSS(%s, %s, M_SUBSTRCT, \"jp/co/suri/lifesim/%s\"),\n",
			       typename, field[i], cname[i]) >> fname;
		} else if (mtype[i] ~ /M_ARRY/) {
			nstr = "???PleaseIns-RecNO-field name ???";
			if (i > 0) {
				nstr = field[i-1];
			}
			## OTK modified
                        printf("\tM_DA(%s, %s, M_ARRY, \"%s\", \"jp/co/suri/lifesim/%s\"),\n",
                               typename, field[i], nstr, cname[i]) >> fname;
		} else if (mtype[i] ~ /M_.*ARRY/) {
			printf("\tM_DB(%s, %s, %s),\n",
			       typename, field[i], mtype[i]) >> fname;
		} else {
			printf("\tM_D(%s, %s, %s),\n",
			       typename, field[i], mtype[i]) >> fname;
		}
	}
	printf("};\n") >> fname;
	repclassname = classname;
	pkgname = "test";
	req = 1;
	rsp = 0;
	if (gsub(/Req$/, "Rsp", repclassname) == 0) {
	    repclassname = classname "Res_???";
	    req = 0;
	    #pkgname="client/" mypkgname;
            pkgname="test";
	}
	if (classname ~ /Rsp$/) {
	    rsp = 1;
	    pkgname = "test";
	}
	printf("/* generated by struct2mdata, don't touch! */\n") > mfname;    
	printf("\t/* MM_DATA_t (struct:%s, class:%s) */\n", typename, classname) >> mfname;
	if (req && 0==1) {
	    printf("\tMM_DB(%s, \"jp/co/suri/lifesim/%s\", M_%s_%s, AOC_blg_%s, \"jp/co/suri/lifesim/response/%s\"),\n",
		   typename, classname, pkg2, clname, clname, repclassname) >> mfname;
	} else {
	    printf("\tMM_D(%s, \"jp/co/suri/lifesim/%s\", M_%s_%s),\n",
		   typename, classname, pkg2, clname) >> mfname;
	}
	if (req) {
		blfname = uc3(blname) ".c.tmp";
		printf("jobject\n") > blfname;
		printf("%s(\n", blname) >> blfname;
		printf("\tJNIEnv\t*env,\t\t/* I : JNIEnv pointer\t\t*/\n") >> blfname;
		printf("\tjobject\treqobj,\t\t/* I : Request Object\t\t*/\n") >> blfname;
		printf("\tchar\t*reqclassname,\t/* I : Request Class Name\t*/\n") >> blfname;
		printf("\tchar\t*rspclassname,\t/* I : Response Class Name\t*/\n") >> blfname;
		printf("\tint\t*syserr\t/* O : Return Error Value\t*/\n") >> blfname;
		printf("\t)\n{\n}\n") >> blfname;

		printf("#define\tJNI_REQ_TYPE_%s ?\n", rtypename) > "MM_" clname ".memo";
		printf("\t{ JNI_REQ_TYPE_%s,\n\t  /* public final static int TYPE_%s=? *//* Request */\n\t  %s,\n",
		       rtypename, rtypename, blname) >> "MM_" clname ".memo";

		fulpkg = sprintf("jp/co/suri/lifesim/%s", classname);
		fulrsppkg = fulpkg;
		gsub(/Req$/, "Rsp", fulrsppkg);
		gsub(/\/request\//, "/response/", fulrsppkg);
		printf("\t  \"%s\",\n\t  \"%s\"\n\t},\n", fulpkg, fulrsppkg) >>"MM_" clname ".memo" ;
	}
	if (rsp) {
		printf("public final static int TYPE_%s=? /* Response */\n",
		       rtypename) > "Mm_" clname ".memo";
	}
	for (i=0; i<findex; i++) {
	    delete field[i];
	    delete mtype[i];
	    delete cname[i];
	}
	findex=0;
	sindex = 0;
	instr = 0;
	next;
}

function tobl(str,   pre, post) {
	pre = substr(str, 1, 4);
	post = substr(str, 5, length(str)-4);
	return pre "bl_" post;
}

function uc3(str,   i, a, s, t, u, pre) {
    # convert "abcDefGhi" to "AbcDefGhi"
    s = "";
    b["A"]="a";
    b["B"]="b";
    b["C"]="c";
    b["D"]="d";
    b["E"]="e";
    b["F"]="f";
    b["G"]="g";
    b["H"]="h";
    b["I"]="i";
    b["J"]="j";
    b["K"]="k";
    b["L"]="l";
    b["M"]="m";
    b["N"]="n";
    b["O"]="o";
    b["P"]="p";
    b["Q"]="q";
    b["R"]="r";
    b["S"]="s";
    b["T"]="t";
    b["U"]="u";
    b["V"]="v";
    b["W"]="w";
    b["X"]="x";
    b["Y"]="y";
    b["Z"]="z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	if (length(b[t])>0 && i<=3) {
	    s = s b[t];
	} else {
	    s = s t;
	}
    }
    return s;
}

function topaA(str,   i, a, s, t, u, pre) {
    # convert "abcDefGhi" to "AbcDefGhi"
    s = "";
    a["a"]="A";
    a["b"]="B";
    a["c"]="C";
    a["d"]="D";
    a["e"]="E";
    a["f"]="F";
    a["g"]="G";
    a["h"]="H";
    a["i"]="I";
    a["j"]="J";
    a["k"]="K";
    a["l"]="L";
    a["m"]="M";
    a["n"]="N";
    a["o"]="O";
    a["p"]="P";
    a["q"]="Q";
    a["r"]="R";
    a["s"]="S";
    a["t"]="T";
    a["u"]="U";
    a["v"]="V";
    a["w"]="W";
    a["x"]="X";
    a["y"]="Y";
    a["z"]="Z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	if (length(a[t])>0 && i==1) {
	    s = s a[t];
	} else {
	    s = s t;
	}
    }
    return s;
}

function traA(str,   i, a, s, t, u, pre) {
    # convert "AbcDefGhi" to "ABC_DEF_GHI"
    s = "";
    a["a"]="A";
    a["b"]="B";
    a["c"]="C";
    a["d"]="D";
    a["e"]="E";
    a["f"]="F";
    a["g"]="G";
    a["h"]="H";
    a["i"]="I";
    a["j"]="J";
    a["k"]="K";
    a["l"]="L";
    a["m"]="M";
    a["n"]="N";
    a["o"]="O";
    a["p"]="P";
    a["q"]="Q";
    a["r"]="R";
    a["s"]="S";
    a["t"]="T";
    a["u"]="U";
    a["v"]="V";
    a["w"]="W";
    a["x"]="X";
    a["y"]="Y";
    a["z"]="Z";
    pre = 0;
    for (i=1; i<=length(str); i++) {
	t = substr(str, i, 1);
	u = "";
	if (pre == 1) {
	    u = "_";
	}
	if (length(a[t])>0) {
	    s = s a[t];
	    pre = 1;
	} else {
	    s = s u t;
	}
    }
    return s;
}


{
	print "UNKNOWN", $0;
}


END {

}
