#include	<stdio.h>
#include	<stdlib.h>

#include	"logUtil.h"

#include	"nr_mutil.h"

#define NR_END	1
#define FREE_ARG	char *

/*****************************************************************************
 * ؿ̾
 *	nr_add_matrix:  A(m,n) + B(m,n) = C(m,n) ׻롣
 * ǽ
 *	¤η׻
 *
 *	
 *	1: ¤׻롣
 *  
 *	double **A;	I: 黻ޥȥå 
 *	double **B;	I: 黻ޥȥå 
 *	double **C;	O: ̥ޥȥå 
 *	long m;	I: Կ
 *	long n;	I: 
 * ؿ
 *****************************************************************************/
void nr_add_matrix(double **A, double **B, double **C, long m, long n)
{
	long i, j;

	for(i=1; i<=m; i++) {
		for(j=1; j<=n; j++) {
			C[i][j] = A[i][j] + B[i][j];
		}
	}
}

/*****************************************************************************
 * ؿ̾
 *	nr_sub_matrix:  A(m,n) - B(m,n) = C(m,n) ׻롣
 * ǽ
 *	κη׻
 *
 *	
 *	1: κ׻롣
 *  
 *	double **A;	I: 黻ޥȥå 
 *	double **B;	I: 黻ޥȥå 
 *	double **C;	O: ̥ޥȥå 
 *	long m;	I: Կ
 *	long n;	I: 
 * ؿ
 *****************************************************************************/
void nr_sub_matrix(double **A, double **B, double **C, long m, long n)
{
	long i, j;

	for(i=1; i<=m; i++) {
		for(j=1; j<=n; j++) {
			C[i][j] = A[i][j] - B[i][j];
		}
	}
}

/*****************************************************************************
 * ؿ̾
 *	nr_mult_matrix:  A(l,m)B(m,n) = C(l,n) ׻롣
 * ǽ
 *	Ѥη׻
 *
 *	
 *	1: Ѥ׻롣
 * 
 *	double **A;	I: 黻ޥȥå 
 *	double **B;	I: 黻ޥȥå 
 *	double **C;	O: ̥ޥȥå 
 *	long l;	I: AιԿCιԿ
 *	long m;	I: ABιԿ
 *	long n;	I: BC
 * ؿ
 *****************************************************************************/
void nr_mult_matrix(double **A, double **B, double **C, long l, long m, long n)
{
	long i, j, k;

	for(i=1; i<=l; i++) {
		for(j=1; j<=n; j++) {
			C[i][j] = 0.0;
			for(k=1; k<=m; k++) {
				C[i][j] += A[i][k]*B[k][j];
			}
		}
	}
}

/*****************************************************************************
 * ؿ̾
 *	nr_alloc_matrix:  m[nrl..nrh][ncl..nch]ΰݤ롣
 * ǽ
 *	 m[nrl..nrh][ncl..nch]ΰݤ롣
 *
 *	
 *	1:  m[nrl..nrh][ncl..nch]ΰݤ롣
 * 
 *	long nrl;	I: Գֹ
 *	long nrh;	I: Խλֹ
 *	long ncl;	I: Գֹ
 *	long nch;	I: Խλֹ
 * ؿ
 *	!=NULL:	
 *	==NULL:	۾
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
double **nr_alloc_matrix(long nrl, long nrh, long ncl, long nch)
{
	long	i;
	long	nrow = nrh - nrl + 1;
	long	ncol = nch - ncl + 1;
	double	**m;


	/* allocate pointers to rows */
	m = (double **) malloc((size_t) ((nrow + NR_END) * sizeof(double *)));
	if( m == NULL ){
		goto err;
	}

	m += NR_END;
	m -= nrl;

	/* allocate rows and set pointers to them */
	m[nrl] = (double *) malloc((size_t) ((nrow * ncol + NR_END) * sizeof(double)));
	if( m[nrl] == NULL ){
		goto err;
	}

	m[nrl] += NR_END;
	m[nrl] -= ncl;

	for( i = nrl + 1 ; i <= nrh ; i++ ){
		m[i] = m[i - 1] + ncol;
	}

	return m;
err:
	log_sys("ERROR: nr_alloc_matrix()\n");
	return NULL;
}

/*****************************************************************************
 * ؿ̾
 *	nr_free_matrix:  m[nrl..nrh][ncl..nch]롣
 * ǽ
 *	 m[nrl..nrh][ncl..nch]롣
 *
 *	
 *	1:  m[nrl..nrh][ncl..nch]롣
 * 
 *	double **m;	I: ؤΥݥ
 *	long nrl;	I: Գֹ
 *	long nrh;	I: Խλֹ
 *	long ncl;	I: Գֹ
 *	long nch;	I: Խλֹ
 * ؿ
 *	̵
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
void nr_free_matrix(double **m, long nrl, long nrh, long ncl, long nch)
{
	free((FREE_ARG) (m[nrl] + ncl - NR_END));
	free((FREE_ARG) (m + nrl - NR_END));
}

/*****************************************************************************
 * ؿ̾
 *	nr_alloc_vector: ٥ȥ v[nl..nh]ΰݤ롣
 * ǽ
 *	٥ȥ v[nl..nh]ΰݤ롣
 *
 *	
 *	1: ٥ȥ v[nl..nh]ΰݤ롣
 * 
 *	long nl;	I: ֹ
 *	long nh;	I: λֹ
 * ؿ
 *	!=NULL:	
 *	==NULL:	۾
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
double *nr_alloc_vector(long nl, long nh)
{
	double	*v;

	v = (double *) malloc((size_t) ((nh - nl + 1 + NR_END) * sizeof(double)));
	if( v == NULL ){
		log_sys("ERROR: nr_alloc_vector()\n");
		return NULL;
	}

	return v - nl + NR_END;
}

/*****************************************************************************
 * ؿ̾
 *	nr_free_vector: ٥ȥ v[nl..nh]ΰ롣
 * ǽ
 *	٥ȥ v[nl..nh]ΰ롣
 *
 *	
 *	1: ٥ȥ v[nl..nh]ΰ롣
 * 
 *	double *v;	I: ٥ȥؤΥݥ
 *	long nl;	I: ֹ
 *	long nh;	I: λֹ
 * ؿ
 *	̵
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
void nr_free_vector(double *v, long nl, long nh)
{
	free((FREE_ARG) (v + nl - NR_END));
}

/*****************************************************************************
 * ؿ̾
 *	nr_alloc_ivector: ٥ȥ v[nl..nh]ΰݤ롣
 * ǽ
 *	٥ȥ v[nl..nh]ΰݤ롣
 *
 *	
 *	1: ٥ȥ v[nl..nh]ΰݤ롣
 * 
 *	long nl;	I: ֹ
 *	long nh;	I: λֹ
 * ؿ
 *	!=NULL:	
 *	==NULL:	۾
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
int *nr_alloc_ivector(long nl, long nh)
{
	int	*v;

	v = (int *) malloc((size_t) ((nh - nl + 1 + NR_END) * sizeof(int)));
	if( v == NULL ){
		log_sys("ERROR: nr_alloc_ivector()\n");
		return NULL;
	}

	return v - nl + NR_END;
}

/*****************************************************************************
 * ؿ̾
 *	nr_free_ivector: ٥ȥ v[nl..nh]ΰ롣
 * ǽ
 *	٥ȥ v[nl..nh]ΰ롣
 *
 *	
 *	1: ٥ȥ v[nl..nh]ΰ롣
 * 
 *	int *v;	I: ٥ȥؤΥݥ
 *	long nl;	I: ֹ
 *	long nh;	I: λֹ
 * ؿ
 *	̵
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
void nr_free_ivector(int *v, long nl, long nh)
{
	free((FREE_ARG) (v + nl - NR_END));
}

/*****************************************************************************
 * ؿ̾
 *	nr_copy_origin0to1: Υǥåθ01Ѥ롣
 * ǽ
 *	Υǥåθ01Ѥ롣
 *
 *	
 *	1: Υǥåθ01Ѥ롣
 * 
 *	double *src;	I: 0ꥸؤΥݥ
 *	double **trg;	I: 1ꥸؤΥݥ
 *	int row;	I: Կ
 *	int col;	I: 
 * ؿ
 *	̵
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
void nr_copy_origin0to1(double *src, double **trg, int row, int col)
{
	int	i, j;
	int	si, sj;

	for( i = 1 ; i <= row ; i++ ){
		si = (i - 1) * col;
		for( j = 1 ; j <= col ; j++ ){
			sj = j - 1;
			trg[i][j] = src[si + sj];
		}
	}
}

/*****************************************************************************
 * ؿ̾
 *	nr_copy_origin1to0: Υǥåθ10Ѥ롣
 * ǽ
 *	Υǥåθ10Ѥ롣
 *
 *	
 *	1: Υǥåθ10Ѥ롣
 * 
 *	double **src;	I: 1ꥸؤΥݥ
 *	double *trg;	I: 0ꥸؤΥݥ
 *	int row;	I: Կ
 *	int col;	I: 
 * ؿ
 *	̵
 * 
 *	lu.cpp/svd.cpp 
 *****************************************************************************/
void nr_copy_origin1to0(double **src, double *trg, int row, int col)
{
	int	i, j;
	int	si, sj;
	int	ti;

	for( i = 0 ; i < row ; i++ ){
		si = i + 1;
		ti = i * col;
		for( j = 0 ; j < col ; j++ ){
			sj = j + 1;
			trg[ti + j] = src[si][sj];
		}
	}
}

/*****************************************************************************
 * ؿ̾
 *	nr_dump_matrix: ν񤭽Ф(ǥХå)
 * ǽ
 *	ν񤭽Ф
 *
 *	
 *	1: 񤭽Ф
 *  
 *	char *name;	I: ޥȥå̾ 
 *	double **A;	I: ޥȥå 
 *	long m;	I: Կ
 *	long n;	I: 
 * ؿ
 *****************************************************************************/
void nr_dump_matrix(char *name, double **A, long m, long n)
{
	long i, j;

	printf("\n#  %s(%ld, %ld)\n", name, m, n);
	for(i=1; i<=m; i++) {
		printf("#  ");
		for(j=1; j<=n; j++) printf("%12.3e", A[i][j]);
		printf("\n");
	}
}

