#include	<stdio.h>
#include	<math.h>

#include	"logUtil.h"

#include	"nr_svd.h"
#include	"nr_mutil.h"

static double	sqrarg;
#define	SQR(a)	((sqrarg=(a)) == 0.0 ? 0.0 : sqrarg*sqrarg)
#define SIGN(a,b)	((b) >= 0.0 ? fabs(a) : -fabs(a))
static double	maxarg1, maxarg2;
#define FMAX(a,b)	(maxarg1=(a),maxarg2=(b),(maxarg1) > (maxarg2) ? (maxarg1) : (maxarg2))
static int	iminarg1, iminarg2;
#define IMIN(a,b)	(iminarg1=(a),iminarg2=(b),(iminarg1) < (iminarg2) ? (iminarg1) : (iminarg2))

static double pythag(double a, double b);



/*
 *  a[1..m][1..n] ðʬ A = U*W*VT 롼
 * 	U  a ˾񤭤롣
 * ðͤгѹ W ϥ٥ȥ w[1..n] 롣
 *  V ž VT ǤϤʤˤϡv[1..n][1..n] 롣
 * m >= n ǤʤФʤʤ
 * ⤷ m < n ʤ顢餫 a β˥ФιԤä
 * m = nˤˤƤ餳ƤӽФ
 */
int nr_svdcmp(double **a, int m, int n, double w[], double **v)
{
	int	flag, i, its, j, jj, k, l, nm;
	double	anorm, c, f, g, h, s, scale, x, y, z, *rv1;

	rv1 = NULL;
	rv1 = nr_alloc_vector(1, n);
	if( rv1 == NULL ){
		goto err;
	}

	g = scale = anorm = 0.0;
	/*
	 * Householder ˡ2гѤηľ
	 */
	for( i = 1 ; i <= n ; i++ ){
		l = i + 1;
		rv1[i] = scale * g;
		g = s = scale = 0.0;
		if( i <= m ){
			for( k = i ; k <= m ; k++ ){
				scale += fabs(a[k][i]);
			}
			if( scale ){
				for( k = i ; k <= m ; k++ ){
					a[k][i] /= scale;
					s += a[k][i] * a[k][i];
				}
				f = a[i][i];
				g = -SIGN(sqrt(s), f);
				h = f * g - s;
				a[i][i] = f - g;
				for( j = l ; j <= n ; j++ ){
					for( s = 0.0, k = i ; k <= m ; k++ ){
						s += a[k][i] * a[k][j];
					}
					f = s / h;
					for( k = i ; k <= m ; k++ ){
						a[k][j] += f * a[k][i];
					}
				}
				for( k = i ; k <= m ; k++ ){
					a[k][i] *= scale;
				}
			}
		}
		w[i] = scale * g;
		g = s = scale = 0.0;
		if( i <= m && i != n ){
			for( k = l ; k <= n ; k++ ){
				scale += fabs(a[i][k]);
			}
			if( scale ){
				for( k = l ; k <= n ; k++ ){
					a[i][k] /= scale;
					s += a[i][k] * a[i][k];
				}
				f = a[i][l];
				g = -SIGN(sqrt(s), f);
				h = f * g - s;
				a[i][l] = f - g;
				for( k = l ; k <= n ; k++ ){
					rv1[k] = a[i][k] / h;
				}
				for( j = l ; j <= m ; j++ ){
					for( s = 0.0, k = l ; k <= n ; k++ ){
						s += a[j][k] * a[i][k];
					}
					for( k = l ; k <= n ; k++ ){
						a[j][k] += s * rv1[k];
					}
				}
				for( k = l ; k <= n ; k++ ){
					a[i][k] *= scale;
				}
			}
		}
		anorm = FMAX(anorm, (fabs(w[i]) + fabs(rv1[i])));
	}

	for( i = n ; i >= 1 ; i-- ){	/* ¦Ѵ߻ */
		if( i < n ){
			if( g ){
				for( j = l ; j <= n ; j++ ){
					/* 
					 * ե򤱤뤿2ٳ䤹롣
					 */
					v[j][i] = (a[i][j] / a[i][l]) / g;
				}
				for( j = l ; j <= n ; j++ ){
					for( s = 0.0, k = l ; k <= n ; k++ ){
						s += a[i][k] * v[k][j];
					}
					for( k = l ; k <= n ; k++ ){
						v[k][j] += s * v[k][i];
					}
				}
			}
			for( j = l ; j <= n ; j++ ){
				v[i][j] = v[j][i] = 0.0;
			}
		}
		v[i][i] = 1.0;
		g = rv1[i];
		l = i;
	}

	for( i = IMIN(m, n) ; i >= 1 ; i-- ){	/* ¦Ѵ */
		l = i + 1;
		g = w[i];
		for( j = l ; j <= n ; j++ ){
			a[i][j] = 0.0;
		}
		if( g ){
			g = 1.0 / g;
			for( j = l ; j <= n ; j++ ){
				for( s = 0.0, k = l ; k <= m ; k++ ){
					s += a[k][i] * a[k][j];
				}
				f = (s / a[i][i]) * g;
				for( k = i ; k <= m ; k++ ){
					a[k][j] += f * a[k][i];
				}
			}
			for( j = i ; j <= m ; j++ ){
				a[j][i] *= g;
			}
		}else{
			for( j = i ; j <= m ; j++ ){
				a[j][i] = 0.0;
			}
		}
		++a[i][i];
	}

	/*
	 * 2гѹгѲ
	 * ðͤˤĤƤΥ롼פȿ׻Υ롼ס
	 */
	for( k = n ; k >= 1 ; k-- ){
		for( its = 1 ; its <= 30 ; its++ ){
			flag = 1;
			/*
			 * ʬΥå
			 * rv1[1] Ͼ˥
			 */
			for( l = k ; l >= 1 ; l--){
				nm = l - 1;
				if( (double)(fabs(rv1[l]) + anorm) == anorm ){
					flag = 0;
					break;
				}
				if( (double)(fabs(w[nm]) + anorm) == anorm ){
					break;
				}
			}
			if( flag ){ /* l > 1 ΤȤ rv1[l] õ */
				c = 0.0;
				s = 1.0;
				for( i = l ; i <= k ; i++ ){
					f = s * rv1[i];
					rv1[i] = c * rv1[i];
					if( (double)(fabs(f) + anorm) == anorm ){
						break;
					}
					g = w[i];
					h = pythag(f, g);
					w[i] = h;
					h = 1.0 / h;
					c = g * h;
					s = - f * h;
					for( j = 1 ; j <= m ; j++ ){
						y = a[j][nm];
						z = a[j][i];
						a[j][nm] = y * c + z * s;
						a[j][i] = z * c - y * s;
					}
				}
			}

			z = w[k];
			if( l == k ){		/* « */
				if( z < 0.0 ){	/* ðͤˤ롣 */
					w[k] = -z;
					for( j = 1 ; j <= n ; j++){
						v[j][k] = -v[j][k];
					}
				}
				break;
			}

			if( its == 30 ){	/* 30Ǥ« */
				goto err;
			}

			/*
			 * ǲ22ξ󤫤Υեȡ
			 */
			x = w[l];
			nm = k - 1;
			y = w[nm];
			g = rv1[nm];
			h = rv1[k];
			f = ((y - z) * (y + z) + (g - h) * (g + h)) / (2.0 * h * y);
			g = pythag(f, 1.0);
			f = ((x - z) * (x + z) + h * ((y / (f + SIGN(g, f))) - h)) / x;
			c = s = 1.0;

			/*
			 * QRѴ
			 */
			for( j = l ; j <= nm ; j++ ){
				i = j + 1;
				g = rv1[i];
				y = w[i];
				h = s * g;
				g = c * g;
				z = pythag(f, h);
				rv1[j] = z;
				c = f / z;
				s = h / z;
				f = x * c + g * s;
				g = g * c - x * s;
				h = y * s;
				y *= c;
				for( jj = 1 ; jj <= n ; jj++ ){
					x = v[jj][j];
					z = v[jj][i];
					v[jj][j] = x * c + z * s;
					v[jj][i] = z * c - x * s;
				}
				z = pythag(f, h);
				w[j] = z;
				/* z = 0 ʤвžǤա */
				if( z ){
					z = 1.0 / z;
					c = f * z;
					s = h * z;
				}
				f = c * g + s * y;
				x = c * y - s * g;
				for( jj = 1 ; jj <= m ; jj++ ){
					y = a[jj][j];
					z = a[jj][i];
					a[jj][j] = y * c + z * s;
					a[jj][i] = z * c - y * s;
				}
			}
			rv1[l] = 0.0;
			rv1[k] = f;
			w[k] = x;
		}
	}

	nr_free_vector(rv1, 1, n);
	return 0;
err:
	if( rv1 )	nr_free_vector(rv1, 1, n);
	log_sys("ERROR: nr_svdcmp()\n");
	return -1;
}

/*
 * (a^2 + b^2)^(1/2) ׻롣
 * ե䥪Сե򤷤ʤ
 */
static double pythag(double a, double b)
{
	double	abs_a, abs_b;
	abs_a = fabs(a);
	abs_b = fabs(b);
	if( abs_a > abs_b ){
		return abs_a * sqrt(1.0 + SQR(abs_b/abs_a));
	}else{
		return ((abs_b == 0.0)? 0.0 : abs_b * sqrt(1.0 + SQR(abs_a/abs_b)));
	}
}

/*
 * A*x = b 򤤤ƥ٥ȥ롣
 * A Ϥ餫ᡢsvdcmp()ǡu[1..m][1..n], w[1..n], v[1..n][1..n]
 * ðʬ򤷤Ƥm, n ϡ줾 AιԿǤ롣
 * ʤ顢m, n
 * b[1..m] ϢΩαաϡˡx[1..n]ϲ٥ȥʽϡˤǤ롣
 * Ϥϡ˲ʤΤǡb ؤƲ٤ƤӽФ롣
 */
int nr_svbksb(double **u, double w[], double **v, int m, int n, double b[], double x[])
{
	int	jj, j, i;
	double	s, *tmp;

	tmp = NULL;
	tmp = nr_alloc_vector(1, n);
	if( tmp == NULL ){
		goto err;
	}

	for( j = 1 ; j <= n ; j++ ){	/* UTb ׻ */
		s = 0.0;
		if( w[j] ){
		/* w[j] ǤʤȤǤʤ̤ˤʤ롣 */
			for( i = 1 ; i <= m ; i++ ){
				s += u[i][j] * b[i];
			}
			s /= w[j];
		}
		tmp[j] = s;
	}

	for( j = 1 ; j <= n ; j++ ){	/*  Vݤ롣 */
		s = 0.0;
		for( jj = 1 ; jj <= n ; jj++ ){
			s += v[j][jj] * tmp[jj];
		}
		x[j] = s;
	}

	nr_free_vector(tmp, 1, n);
	return 0;
err:
	if( tmp )	nr_free_vector(tmp, 1, n);
	log_sys("ERROR: nr_svbksb()\n");
	return -1;
}
