#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "mt_rand.h"
#include "utl_rand.h"
#include "logUtil.h"

/*-----
 * SetRandSeedؿ
 * 	Υɤ򥻥åȤ
 * 	̵͡
 * 	Υ(I)
 */
void SetRandSeed(unsigned long seed)
{
#ifdef DBG
	DBGW(10, ("SetRandSeed enter.\n"));
#endif /* DBG */

	init_genrand(seed);

#ifdef DBG
	DBGW(10, ("SetRandSeed exit\n"));
#endif /* DBG */
}

/*-----
 * SetSeedByTimeؿ
 * 	狼Υɤ򥻥åȤ
 */
void SetSeedByTime()
{
	time_t	t;

#ifdef DBG
	DBGW(10, ("SetSeedByTime enter.\n"));
#endif /* DBG */

	if((t = time(&t)) == -1){
		log_sys(" ## Warning. Fail to initialize a random seed.\n");
	} else {
		SetRandSeed(t);
	}

#ifdef DBG
	DBGW(10, ("SetSeedByTime exit\n"));
#endif /* DBG */
}
	

/*-----
 * GenIntRandؿ
 * 	minʾ塤max̤ȯ
 *	͡ʾϰϤ
 *	Ǿ͡
 */
int GenIntRand(int min, int max)
{
	unsigned int	region_width;	/* ȯϰϤ */
	unsigned int	int_rand;	/* 0ʾ */
	int		rv;		/* return value */

#ifdef DBG
	DBGW(10, ("GenIntRand enter.\n"));
#endif /* DBG */
	
	int_rand = genrand_int32();
	region_width = max - min;
	rv = (int)(int_rand % region_width) + min;

#ifdef DBG
	DBGW(10, ("GenIntRand exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

/*-----
 * GenIntRandMax()ؿ
 * 	[0, 0xffffffff]ΰȯ
 */
int GenIntRandMax()
{
	int rv;

#ifdef DBG
	DBGW(10, ("GenIntRandMax enter.\n"));
#endif /* DBG */

	rv = genrand_int32();

#ifdef DBG
	DBGW(10, ("GenIntRandMax exit(%d)\n", rv));
#endif /* DBG */

	return rv;
}

	
/*-----
 * GenUniformRandؿ
 * 	[min, max]ΰȯ
 * 	͡ʾϰϤΰ
 * 	Ǿ͡
 */
double GenUniformRand(double min, double max)
{
	double	rv;
	double	region_width;

#ifdef DBG
	DBGW(10, ("GenUniformRand enter.\n"));
#endif /* DBG */

	region_width = max - min;
	rv = (genrand_real1() * region_width + min);

#ifdef DBG
	DBGW(10, ("GenUniformRand exit(%f)\n", rv));
#endif /* DBG */

	return rv;
}

/*-----
 * GenStandardNormalRandؿ
 * 	Box-Mullerˡˤɸȯ
 * 	)Numeical Recipes in C(ܸ)
 * 	   p217 gasdevؿ򻲹ͤ˺
 * 	͡ɸ
 * 	̵
 */
double GenStandardNormalRand()
{
	static int	iset = 0;
	static double	gset;
	double	fac, rsq, v1, v2;
	double	rv;

#ifdef DBG
	DBGW(10, ("GenStandardNormalRand enter.\n"));
#endif /* DBG */
	
	if (iset == 0) {
		do {
			v1 = 2.0 * genrand_real3() - 1.0;
			v2 = 2.0 * genrand_real3() - 1.0;
			rsq = v1*v1 + v2*v2;
		} while (rsq >= 1.0 || rsq == 0.0);
		fac = sqrt(-2.0*log(rsq)/rsq);

		gset = v1 * fac;
		iset = 1;
		rv = v2 * fac;
	} else {
		iset = 0;
		rv = gset;
	}

#ifdef DBG
	DBGW(10, ("GenStandardNormalRand exit(%f)\n", rv));
#endif /* DBG */

	return rv;
}
	
/*-----
 * GenNormalRandؿ
 * 	ʿm, ʬvȯ
 *	͡嵭ξߤ
 *	ʿѡʬ
 */
double GenNormalRand(double mean, double var)
{
	double rv;

#ifdef DBG
	DBGW(10, ("GenNormalRand enter.\n"));
#endif /* DBG */

	rv = (mean + sqrt(var) * GenStandardNormalRand());

#ifdef DBG
	DBGW(10, ("GenNormalRand exit(%f)\n", rv));
#endif /* DBG */

	return rv;
}
