/* *****************************************************************************
 * ΥեmainؿޤǤ롣
 * 
 *  main
 *    +-my_init					ץβϡϥեΥץ
 *    +-get_GHnum				ѿѿο	
 *    +-Set_data				ϥǡɹ
 *    +-read_STD_results		η̤ɹ
 *    +-allocate_base_matrixes	ܤȤʤޥȥå٥ȥΰ
 *    +-get_GHdata				V+V-dV/dX ͤμ
 *    +-calc_eigenvalues		ͭͤ׻Fluxȶ˽񤭽Ф
 *    |   +-GetEigenvalues			إå٥륰QRˡˤͭͤη׻
 *    +-write_S_param			S-system ѥѥ᡼եν񤭽Ф
 *    +-std_analysis			ٲϥᥤ
 *    |   +-sens_kinetic			kinetic order Ф Metabolite δ
 *    |   +-sens_kinetic_flux		kinetic order Ф Flux δ
 *    +-free_base_matrixes		ܤȤʤޥȥå٥ȥΰ賫
 *    +-my_final				ΰγեΥ
 *
 *	ٰϤԤȶˡS-systemѤParameterե롣
 *
 *	ϥե
 *	result_STD	η̥ե롣
 *	param		᤿Υѥ᡼ե롣
 *
 *	ϥե
 *	output		ٰϤη̡
 *	s_param		S-systemѤΥѥ᡼ե롣
 *
 * ˡ
 *	Ssystem -Iinput_file -Rresults_STD_file -Ooutput_file -Ss_param_file [-d]
 *
 *	ǺΤϥᥤؿޤ饤֥ǡ¹ԥ⥸塼Ȥ뤿ˤ
 *	chechdae ǺGHؿ󥯤ɬפ롣
 *
 */

#define _HAVE_MAIN_ROUTINE_

#include "s_analysis.h"

/* եstaticؿΥץȥ */
static int my_init(int argc, char *argv[], char *fname[], FILE **fp_out, int *f_useSTD);
static int allocate_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
		    	double **v_plus, double **v_minus, int n_var, int n_const);
static void free_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			   	double **v_plus, double **v_minus, int n_var, int n_const);
static int read_STD_results(double *y, int n_var, char **fname, FILE *fp_out);
static int calc_eigenvalues(double **Gd, double **Hd, double *v_plus, double *y,
			   	int n_var, FILE *fp_out);
static int write_S_param(char **fname, double **Gd, double **Gi,
			   	double **Hd, double **Hi, double *v_plus, double *v_minus,
			   	double *y, int n_var, int n_const);
static int std_analysis(FILE *fp_out, double **Gd, double **Gi, double **Hd, double **Hi,
			   	double *y, int n_var, int n_const);
static void sens_kinetic(FILE *fp_out, double **GHd, double **GHi, double **Ad_inv,
			   	double *y, int n_var, int n_const, int f_isG);
static void sens_kinetic_flux(FILE *fp_out, double **GHd, double **GHi, double **Ad_inv,
			   	double *y, int n_var, int n_const, int f_isG);
static void my_final(FILE *fp_out, char **fname);
static char *getCurrentTimeStr();

static double g_val=1.0;


/*------------------ main --------------------------------------
 *
 *
 */
int main(int argc, char *argv[])
{
	int i, j, f_useSTD=false;
    char *fname[FILE_NUM];
	double t_start, t_end, h;
	double dt_save, y_tmp[MAX_VAR_NUM];
	int n_var, n_const;
	double *y=NULL, *v_plus=NULL, *v_minus=NULL;
	double **Gd=NULL, **Gi=NULL, **Hd=NULL, **Hi=NULL;
	FILE *fp_out=NULL;

	/* ץβϡϥեΥץ */
	if (my_init(argc, argv, fname, &fp_out, &f_useSTD) < 0) goto err;
	
	/*
	 *	checkdaeǺ桼ؿƤӽФ
	 *	ѿοȸѿο֤Ƥ
	 */
	get_GHnum(&n_var, &n_const);
	
	/*
	 *	᤿ϥե뤫ѥ᡼ɤ߹ࡣ
	 *	ߥ졼ȶ̤ʤΤ y 䥳ȥǡɤ߹ब
	 *	Ǥϰ̵̣
	 */
	if (Set_data(y_tmp, &t_start, &t_end, &h, &dt_save, fname) < 0) goto err;

	if (n_var != Param.n_var || n_const != Param.n_val[1]) {
		log_sys("#  The user function file used for compile and the input file ");
		log_sys("#  used for calculation of STD values are not matched.\n");
		log_sys("#  Number of variables : %d vs %d.\n", n_var, Param.n_var);
		log_sys("#  Number of constant variables : %d vs %d.\n", n_const, Param.n_val[1]);
		goto err;
	}

	y = nr_alloc_vector(1, n_var);
	if (y == NULL) goto err;
	
	if (f_useSTD) {
		/*
	 	*	η̥եɤ߹ y ͤ롣
	 	*	ĤǤˡy Ͱη׻ϥǡ˴ؤʬ򤽤Τޤޤη
	 	*	ϥե˽񤭽Ф
	 	*/
		if (read_STD_results(y, n_var, fname, fp_out) < 0) goto err;
	} else {
		for (i=1; i<=n_var; i++) y[i] = y_tmp[i];
		fprintf(fp_out, "# !!! Useing initial values as variable(y) data.\n");
		log_sys("# !!! Useing initial values as variable(y) data.\n");
	}

	/* ܤȤʤޥȥå٥ȥΰ */
	if (allocate_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus,
						   				n_var, n_const)) goto err;

	for(i=1; i<=n_var; i++ ){
		for( j=1; j<=n_var; j++ ) Gd[i][j] = Hd[i][j] = 0.0;
		for( j=1; j<=n_const; j++ ) Gi[i][j] = Hi[i][j] = 0.0;
	}

	/*
	 *	checkdaeǺ桼ؿƤӽФ
	 *	᤿Υѥ᡼ե뤫ɤ߹ѥ᡼
	 *	Ϥǵ᤿ y ͤȤˡGH¤(ڤӤθ)
	 *	׻֤
	 */
	get_GHdata(Gd, Gi, Hd, Hi, v_plus, v_minus, y, &Param);

	/*
	 *	ͭͤ׻ѿ͡Flux ȶ˽Ϥ롣
	 */
	//if (calc_eigenvalues(Gd, Hd, v_plus, y, n_var, fp_out)) goto err;
	
	/*
	 *	S-system Υߥ졼ѤΥѥ᡼ե롣
	 *	ŪGdHd׻֤
	 */
	if (write_S_param(fname, Gd, Gi, Hd, Hi, v_plus, v_minus, y, n_var, n_const)) goto err;
		
	/*
	 *	ٲϤԤη̤Ϥ롣
	 */
	//if (std_analysis(fp_out, Gd, Gi, Hd, Hi, y, n_var, n_const)) goto err;

	/* ܤȤʤޥȥå٥ȥΰ賫 */
	free_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus, n_var, n_const);

	my_final(fp_out, fname);
	return 0;

err:
	fprintf(fp_out, "\n$$ ABORT!!\n");
	log_sys("\n## ABORT!!\n");

	/* ܤȤʤޥȥå٥ȥΰ賫 */
	free_base_matrixes(&Gd, &Gi, &Hd, &Hi, &v_plus, &v_minus, n_var, n_const);

	my_final(fp_out, fname);
	return -1;
}

/*---------------- calc_eigenvalues ------------------------------------------
 *	ͭͤ׻ѿ͡Flux ȶ˽Ϥ롣
 */
static int
calc_eigenvalues(double **Gd, double **Hd, double *v_plus, double *y,
			   	int n_var, FILE *fp_out)
{
	int i, j;
	double **Sd=NULL, *real=NULL, *imaginary=NULL;

	Sd = nr_alloc_matrix(1, n_var, 1, n_var);
	if (Sd == NULL) goto err;
	real = nr_alloc_vector(1, n_var);
	if (real == NULL) goto err;
	imaginary = nr_alloc_vector(1, n_var);
	if (imaginary == NULL) goto err;

	for(i=1; i<=n_var; i++ ){
		for( j=1; j<=n_var; j++ ) Sd[i][j] = Gd[i][j] - Hd[i][j];
	}

#ifdef DBG
	nr_dump_matrix("Gd", Gd, n_var, n_var);
	nr_dump_matrix("Hd", Hd, n_var, n_var);
	nr_dump_matrix("Sd", Sd, n_var, n_var);
#endif


	/* إå٥륰QRˡˤͭͤ */
	GetEigenvalues(Sd, real, imaginary, n_var);

	fprintf(fp_out, "\n$ Fluxes $\n");
	fprintf(fp_out, "index,    y value ,      Flux\n");
	for(i=1; i<=n_var; i++) {
		fprintf(fp_out, "%5d,%12.3e,%12.3e, #%s\n",
				i, y[i]/GeneConc, v_plus[i], getVarTag(i));
	}

	fprintf(fp_out, "\n$ Eigenvalues $\n");
	fprintf(fp_out, "No.  ,       Real ,   Imaginary\n");
	for(i=1; i<=n_var; i++) {
		fprintf(fp_out, "%5d,%12.3e,%12.3e\n",
				i, real[i], imaginary[i]);
	}

	if (Sd) nr_free_matrix(Sd, 1, n_var, 1, n_var);
	if (real) nr_free_vector(real, 1, n_var);
	if (imaginary) nr_free_vector(imaginary, 1, n_var);

	return 0;

err:;
	log_sys("## Error in calc_eigenvalues.\n");
	if (Sd) nr_free_matrix(Sd, 1, n_var, 1, n_var);
	if (real) nr_free_vector(real, 1, n_var);
	if (imaginary) nr_free_vector(imaginary, 1, n_var);
	return -1;
}

/*---------------------- read_STD_results -------------------------------------
 * Ϥη̤ɹ
 */
static int
read_STD_results(double *y, int n_var, char **fname, FILE *fp_out)
{
	int i, cnt;
	FILE *fp_in;
	double val;
	char *str_tmp=NULL, tline[MAX_LINE];

	if((fp_in = fopen(fname[FILE_STD], "r")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_STD]);
		goto err;
	}

	fprintf(fp_out, "##### %s #####\n\n", getCurrentTimeStr());
	fprintf(fp_out, "# Logarithmic Gains and Sensitivities.\n\n");
	fprintf(fp_out, "# The following data is the things when calculating STD.\n");

	cnt = 0;
	while(fgets(tline, sizeof tline, fp_in)) {
		if (strncmp(tline, "Solver", 6) == 0) {
			str_tmp = strstr(tline, ":");
			sscanf(str_tmp, ":%d", &i);
			if (i != SOLVER_NO_STD) {
				log_sys("#  This results file is not a STD one. Solver No. %d\n", i);
				goto err;
			}
		}
		if (strncmp(tline, "G-Value", 7) == 0) {	/* G_value add '030729 by Satoh */
			log_sys("== %s\n", tline);
			strsep(&str_tmp, ":");
			g_val = atof(strsep(&str_tmp, ":"));
		}
		if (strncmp(tline, "Param S", 7) == 0) {
			str_tmp = strstr(tline, ":");
			sscanf(str_tmp, ":%d", &i);
			if (i == 1) {
				log_sys("#  This results file performs a parameter survey.\n");
				goto err;
			}
		}
		if (strncmp(tline, "$$", 2) == 0) {
			cnt++;
			if (strstr(tline, "Results") || cnt == 1) break;
			log_sys("#  There is no normal data in this result file.\n");
			goto err;
		}
		fprintf(fp_out, "%s", tline);
	}

	while(fgets(tline, sizeof tline, fp_in)) {
		if (strncmp(tline, "$$", 2) == 0) break;
		if (strncmp(tline, "index", 5) == 0) continue;
		if (strlen(tline) < 5) continue;
		sscanf(tline, "%d,%lf", &i, &val);
		if (i < 1 || i > n_var) {
			log_sys("#  Invalid index. : index=%d, number of variables is %d.\n",
						   	i, n_var);
			goto err;
		}
		y[i] = val*g_val;	/* G_value add '030729 by Satoh */
	}

	fprintf(fp_out, "# Below this line is as a result of sensitivity analysis etc.\n");
	
	return 0;

err:
	log_sys("## Error in read_STD_results.\n");
	return -1;
}

/*---------------------- write_S_param -------------------------------------
 * ѥ᡼եν񤭽Ф
 */
static int
write_S_param(char **fname, double **Gd, double **Gi, double **Hd, double **Hi,
			   	double *v_plus, double *v_minus, double *y, int n_var, int n_const)
{
	int i, j, cnt_G, cnt_H;
	FILE *fp_out;
	double *alpha=NULL, *beta=NULL;
	double *c_var = Param.val[1];

	if((fp_out = fopen(fname[FILE_SPARAM], "w")) == NULL){
		log_sys("#  Cannot open %s\n", fname[FILE_SPARAM]);
		goto err;
	}

	fprintf(fp_out,"##### Model ################\n");
	fprintf(fp_out,"N_VAR   ;%4d; # num of variables(all)\n", n_var);
	fprintf(fp_out,"N_ALGEBR;%4d; # num of variables(all)\n", 0);

	/* ͤν񤭽Ф */
	fprintf(fp_out,"\n#Y_START ; index; initial_value; tag #comment\n");
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"Y_START ;%4d;%12.4e; %s\t#\n", i, y[i]/g_val, getVarTag(i));
		/* G_value add '030729 by Satoh */
	}

	alpha = nr_alloc_vector(1, n_var);
	if (alpha == NULL) goto err_alloc;
	beta = nr_alloc_vector(1, n_var);
	if (beta == NULL) goto err_alloc;
	for (i=1; i<=n_var; i++) {
		alpha[i] = 1.0;
		beta[i]  = 1.0;
	}

	/* G, H, alpha, beta η׻ */
	for (i=1; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			Gd[i][j] = Gd[i][j]*y[j]/v_plus[i];
			Hd[i][j] = Hd[i][j]*y[j]/v_minus[i];
			alpha[i] *= pow(y[j], Gd[i][j]);
			beta [i] *= pow(y[j], Hd[i][j]);
		}
		for (j=1; j<=n_const; j++) {
			Gi[i][j] = Gi[i][j]*c_var[j]/v_plus[i];
			Hi[i][j] = Hi[i][j]*c_var[j]/v_minus[i];
			alpha[i] *= pow(c_var[j], Gi[i][j]);
			beta [i] *= pow(c_var[j], Hi[i][j]);
		}
		alpha[i] = v_plus[i]/alpha[i];
		beta[i]  = v_minus[i]/beta[i];
	}


	/* ѥ᡼ν񤭽Ф */
	fprintf(fp_out,"\n#PARAM;name;index;val;val_start;num_survey;D/R/S;change-val;GA_min;GA_max;tag #comment\n");
	for (i=1; i<=n_const; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; %s\t#\n",
					   	CONSTANT_PLAYER, i, c_var[i]/g_val, getParamTag(1, i));
	}
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; alpha_%d\t#\n",
					   	"kplus", i, alpha[i], i);
	}
	for (i=1; i<=n_var; i++) {
		fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; beta_%d\t#\n",
					   	"kminus", i, beta[i], i);
	}
	for (i=1, cnt_G=0; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			if (Gd[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; gd_%d_%d\t#\n",
					   	"g", ++cnt_G, Gd[i][j], i, j);
			}
		}
		for (j=1; j<=n_const; j++) {
			if (Gi[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; gi_%d_%d\t#\n",
					   	"g", ++cnt_G, Gi[i][j], i, j);
			}
		}
	}
	for (i=1, cnt_H=0; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) {
			if (Hd[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; hd_%d_%d\t#\n",
					   	"h", ++cnt_H, Hd[i][j], i, j);
			}
		}
		for (j=1; j<=n_const; j++) {
			if (Hi[i][j] != 0) {
				fprintf(fp_out,"PARAM   ;%-14s;%4d;%12.4e;;0;D;;;; hi_%d_%d\t#\n",
					   	"h", ++cnt_H, Hi[i][j], i, j);
			}
		}
	}

	fprintf(fp_out,"\n#T_EVENT ; name; index; time; value; #comment\n\n");

	fprintf(fp_out,"\n######## Don't edit the following lines. ######\n");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", CONSTANT_PLAYER);
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "kplus");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "kminus");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "g");
	fprintf(fp_out,"PARAM_NAME ;%-15s #\n", "h");

	fclose(fp_out); fp_out = NULL;

	nr_free_vector(alpha, 1, n_var);
	nr_free_vector(beta, 1, n_var);

	return 0;

err_alloc:
	log_sys("#  Cannot allocate memory.\n");

err:
	if (alpha) nr_free_vector(alpha, 1, n_var);
	if (beta) nr_free_vector(beta, 1, n_var);
	if (fp_out != NULL) fclose(fp_out);

	log_sys("## Error in write_S_param.\n");
	return -1;
}

/*---------------------- std_analysis -------------------------------------
 *	֤ˤƼϤȤν
 */
static int
std_analysis(FILE *fp_out, double **Gd, double **Gi, double **Hd, double **Hi,
			   	double *y, int n_var, int n_const)
{
	int i, j, k;
	int *index=NULL;
	double **Ad=NULL, **Ad_inv=NULL, **Ai=NULL;
	double **Ad1Ai=NULL, **GdAd1Ai=NULL;
	double *col=NULL;
	double d, val;

	Ad = nr_alloc_matrix(1, n_var, 1, n_var);
	if (Ad == NULL) goto err_alloc;
	Ad_inv = nr_alloc_matrix(1, n_var, 1, n_var);
	if (Ad_inv == NULL) goto err_alloc;
	Ai = nr_alloc_matrix(1, n_var, 1, n_const);
	if (Ai == NULL) goto err_alloc;
	Ad1Ai = nr_alloc_matrix(1, n_var, 1, n_const);
	if (Ad1Ai == NULL) goto err_alloc;
	GdAd1Ai = nr_alloc_matrix(1, n_var, 1, n_const);
	if (GdAd1Ai == NULL) goto err_alloc;
	col = nr_alloc_vector(1, n_var);
	if (col == NULL) goto err_alloc;
	index = nr_alloc_ivector(1, n_var);
	if (index == NULL) goto err_alloc;

	nr_sub_matrix(Gd, Hd, Ad, n_var, n_var);
	nr_sub_matrix(Gi, Hi, Ai, n_var, n_const);

	if (nr_ludcmp(Ad, n_var, index, &d) < 0) goto err;
	
	/* չAd_inv η׻ */
	for (i=1; i<=n_var; i++) {
		for (j=1; j<=n_var; j++) col[j] = 0.0;
		col[i] = 1.0;
		nr_lubksb(Ad, n_var, index, col);
		for (j=1; j<=n_var; j++) Ad_inv[j][i] = col[j];
	}

	nr_mult_matrix(Ad_inv, Ai, Ad1Ai, n_var, n_var, n_const);
	nr_mult_matrix(Gd, Ad1Ai, GdAd1Ai, n_var, n_var, n_const);

	/* ѿФ봶 */
	fprintf(fp_out,"\n$ Logarythmic Gains of Metabolites $\n");
	fprintf(fp_out,"%-19s", "param/var");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     y[%3d]", i); 
	fprintf(fp_out,"\n");
	for (j=1; j<=n_const; j++) {
		fprintf(fp_out,"%14s[%3d]", CONSTANT_PLAYER, j);
		for (i=1; i<=n_var; i++) fprintf(fp_out, ",%11.3e", -Ad1Ai[i][j]); 
		fprintf(fp_out,"\n");
	}
	
	fprintf(fp_out,"\n$ Sensitivities of Metabolites with respect to rate constants $\n");
	fprintf(fp_out,"%-19s", "param/var");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     y[%3d]", i); 
	fprintf(fp_out,"\n");
	for (j=1; j<=n_var; j++) {
		fprintf(fp_out,"%14s[%3d]", "alpha", j);
		for (i=1; i<=n_var; i++) fprintf(fp_out, ",%11.3e", -Ad_inv[i][j]); 
		fprintf(fp_out,"\n");
	}
	
	fprintf(fp_out,"\n$ Sensitivities of Metabolites with respect to kinetic orders $\n");
	fprintf(fp_out,"%-19s", "param/var");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     y[%3d]", i); 
	fprintf(fp_out,"\n");
	/* G ˴ؤ׻Ƚ񤭽Ф */
	sens_kinetic(fp_out, Gd, Gi, Ad_inv, y, n_var, n_const, true);
	/* H ˴ؤ׻Ƚ񤭽Ф */
	sens_kinetic(fp_out, Hd, Hi, Ad_inv, y, n_var, n_const, false);
	
	/* եåФ봶 */
	fprintf(fp_out,"\n$ Logarythmic Gains of Fluxes $\n");
	fprintf(fp_out,"%-19s", "param/flux");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     v[%3d]", i); 
	fprintf(fp_out,"\n");
	for (j=1; j<=n_const; j++) {
		fprintf(fp_out,"%14s[%3d]", CONSTANT_PLAYER, j);
		for (i=1; i<=n_var; i++) fprintf(fp_out, ",%11.3e", Gi[i][j]-GdAd1Ai[i][j]); 
		fprintf(fp_out,"\n");
	}
	
	fprintf(fp_out,"\n$ Sensitivities of Fluxes with respect to rate constants $\n");
	fprintf(fp_out,"%-19s", "param/var");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     v[%3d]", i); 
	fprintf(fp_out,"\n");
	for (j=1; j<=n_var; j++) {
		fprintf(fp_out,"%14s[%3d]", "alpha", j);
		for (i=1; i<=n_var; i++) {
			if (i == j) {
				val = 1.0;
			} else {
				val = 0.0;
			}
			for (k=1; k<=n_var; k++) val += Gd[i][k]*(-Ad_inv[k][j]);
			fprintf(fp_out, ",%11.3e", val); 
		}
		fprintf(fp_out,"\n");
	}
	
	fprintf(fp_out,"\n$ Sensitivities of Fluxes with respect to kinetic orders $\n");
	fprintf(fp_out,"%-19s", "param/var");
	for (i=1; i<=n_var; i++) fprintf(fp_out,",     v[%3d]", i); 
	fprintf(fp_out,"\n");
	/* G ˴ؤ׻Ƚ񤭽Ф */
	sens_kinetic_flux(fp_out, Gd, Gi, Ad_inv, y, n_var, n_const, true);
	/* H ˴ؤ׻Ƚ񤭽Ф */
	sens_kinetic_flux(fp_out, Hd, Hi, Ad_inv, y, n_var, n_const, false);

#ifdef DBG
	nr_dump_matrix("Gd", Gd, n_var, n_var);
	nr_dump_matrix("Hd", Hd, n_var, n_var);
	nr_dump_matrix("Gi", Gi, n_var, n_const);
	nr_dump_matrix("Hi", Hi, n_var, n_const);
	nr_dump_matrix("Ad_inv", Ad_inv, n_var, n_var);
#endif

	nr_free_vector(col, 1, n_var);
	nr_free_ivector(index, 1, n_var);
	nr_free_matrix(Ad, 1, n_var, 1, n_var);
	nr_free_matrix(Ad_inv, 1, n_var, 1, n_var);
	nr_free_matrix(Ai, 1, n_var, 1, n_const);
	nr_free_matrix(Ad1Ai, 1, n_var, 1, n_const);
	nr_free_matrix(GdAd1Ai, 1, n_var, 1, n_const);

	return 0;

err_alloc:
	log_sys("#  Cannot allocate memory.\n");

err:
	if (col) nr_free_vector(col, 1, n_var);
	if (index) nr_free_ivector(index, 1, n_var);
	if (Ad) nr_free_matrix(Ad, 1, n_var, 1, n_var);
	if (Ad_inv) nr_free_matrix(Ad_inv, 1, n_var, 1, n_var);
	if (Ai) nr_free_matrix(Ai, 1, n_var, 1, n_const);
	if (Ad1Ai) nr_free_matrix(Ad1Ai, 1, n_var, 1, n_const);
	if (GdAd1Ai) nr_free_matrix(GdAd1Ai, 1, n_var, 1, n_const);
	
	log_sys("## Error in std_analysis.\n");
	return -1;
}

/*---------------------- sens_kinetic -------------------------------------
 *	kinetic oder ФMetaboliteδ٤η׻Ƚ񤭽Ф
 */
static void
sens_kinetic(FILE *fp_out, double **GHd, double **GHi, double **Ad_inv,
			   	double *y, int n_var, int n_const, int f_isG)
{
	int i, j, k, cnt;
	double *c_var = Param.val[1], my_sign;
	char label[MAX_LINE];

	if (f_isG) {
		sprintf(label, "%s", "g");
		my_sign = -1.0;
	} else {
		sprintf(label, "%s", "h");
		my_sign = 1.0;
	}

	for (j=1, cnt=0; j<=n_var; j++) {
		for (k=1; k<=n_var; k++) {
			if (GHd[j][k] == 0.0) continue;
			fprintf(fp_out,"%14s[%3d]", label, ++cnt);
			for (i=1; i<=n_var; i++) {
				fprintf(fp_out, ",%11.3e", my_sign*GHd[j][k]*Ad_inv[i][j]*log(y[k])); 
			}
			fprintf(fp_out,"\n");
		}
		for (k=1; k<=n_const; k++) {
			if (GHi[j][k] == 0.0) continue;
			fprintf(fp_out,"%14s[%3d]", label, ++cnt);
			for (i=1; i<=n_var; i++) {
				fprintf(fp_out, ",%11.3e", my_sign*GHi[j][k]*Ad_inv[i][j]*log(c_var[k])); 
			}
			fprintf(fp_out,"\n");
		}
	}
}

/*---------------------- sens_kinetic_flux -------------------------------------
 *	kinetic oder ФFluxδ٤η׻Ƚ񤭽Ф
 */
static void
sens_kinetic_flux(FILE *fp_out, double **GHd, double **GHi, double **Ad_inv,
			   	double *y, int n_var, int n_const, int f_isG)
{
	int i, j, k, m, cnt;
	double *c_var = Param.val[1], val, my_sign;
	char label[MAX_LINE];

	if (f_isG) {
		sprintf(label, "%s", "g");
		my_sign = -1.0;
	} else {
		sprintf(label, "%s", "h");
		my_sign = 1.0;
	}

	for (j=1, cnt=0; j<=n_var; j++) {
		for (k=1; k<=n_var; k++) {
			if (GHd[j][k] == 0.0) continue;
			fprintf(fp_out,"%14s[%3d]", label, ++cnt);
			for (i=1; i<=n_var; i++) {
				if (i == j) {
					val = GHd[j][k]*log(y[k]);
				} else {
					val = 0.0;
				}
				for (m=1; m<=n_var; m++) {
					val += GHd[i][m]*my_sign*GHd[j][k]*Ad_inv[m][j]*log(y[k]);
				}
				fprintf(fp_out, ",%11.3e", val); 
			}
			fprintf(fp_out,"\n");
		}
		for (k=1; k<=n_const; k++) {
			if (GHi[j][k] == 0.0) continue;
			fprintf(fp_out,"%14s[%3d]", label, ++cnt);
			for (i=1; i<=n_var; i++) {
				if (i == j) {
					val = GHi[j][k]*log(c_var[k]);
				} else {
					val = 0.0;
				}
				for (m=1; m<=n_var; m++) {
					val += GHd[i][m]*my_sign*GHi[j][k]*Ad_inv[m][j]*log(c_var[k]);
#if 0
					if (f_isG == false) {
							printf("%d, %d, %d, %d, %e\n", i, j, k, m, val);
					}
#endif
				}
				fprintf(fp_out, ",%11.3e", val); 
			}
			fprintf(fp_out,"\n");
		}
	}
}

/*---------------- my_init------------------------------------------
 *
 * ץβϡϥեΥץ
 *
 * I:argc, argv
 * O:y, t_start, t_end, h, dt_save
 *
 */
static int
my_init(int argc, char *argv[], char *fname[], FILE **fp_out, int *f_useSTD)
{
	int i, fcount = 0;
	
#ifdef DBG
	if(log_dbginit(argc, argv)) {
		printf("Cannot open dbgLog file!!");
		goto	err;
	}
#endif

	if(log_sysinit(argc, argv)) {
		printf("Cannot open sysLog file!!");
		goto	err;
	}


#ifdef DBG
	DBGW(10, ("===> my_init enter\n"));
#endif

	// ץβ -Iϥե̾-Oϥե̾[-dǥХå٥]
	for (i = 1; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'I':
				fcount++;
				fname[FILE_IN] = strdup(&argv[i][2]);
				break;
			case 'R':
				fcount++;
				*f_useSTD = true;
				fname[FILE_STD] = strdup(&argv[i][2]);
				break;
			case 'O':
				fcount++;
				fname[FILE_SENS] = strdup(&argv[i][2]);
				break;
			case 'S':
				fcount++;
				fname[FILE_SPARAM] = strdup(&argv[i][2]);
				break;
			case 'd':
				break;
			default:
				log_sys("#  Invalid argument !!\n");
				log_sys("#  Usage : Module -IFile_input [-RFile_STD] -OFile_out -SFile_Sparam\n");
				goto	err;
			}
		}
	}
	if (*f_useSTD == false) fname[FILE_STD] = strdup("DUMMY");
	if (fcount < FILE_NUM-1 || fcount > FILE_NUM) {
		log_sys("#  This program needs %d(or %d) input files. But now it has %d file(s).\n",
					   FILE_NUM, FILE_NUM-1, fcount);
		log_sys("#  Usage : Module -IFile_input [-RFile_STD] -OFile_out -SFile_Sparam\n");
		goto err;
	}

	/* ϥե򥪡ץ󤹤 */
	if((*fp_out = fopen(fname[FILE_SENS], "w")) == NULL){
			log_sys("#  outputfile[%s] open err!!\n", fname[FILE_OUT]);
			goto	err;
	}
	
	return 0;

err:;
	log_sys("## Error in my_init.\n");
	exit(-1);
}

/*---------------------- my_final -------------------------------------
 *	λ
 */
static void my_final(FILE *fp_out, char **fname)
{
	int i;
		
	/*
	 * ѥ᡼γǼΰγ
	 */
	freeParamTag();

	/*
	 * ե̾γǼΰγ
	 */
	for (i=0; i<FILE_NUM; i++) free((void *) fname[i]);

	/*
	 * ϥեĤ
	 */
	if( fp_out ){
		fclose(fp_out); fp_out = NULL;
	}

	/*
	 * λ
	 */
	log_sysfinalize();
	log_dbgfinalize();
}

/*---------------------- allocate_base_matrixes -------------------------------------
 *	ܥޥȥåΰ
 */
static int
allocate_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			    	double **v_plus, double **v_minus, int n_var, int n_const)
{
	*v_plus = nr_alloc_vector(1, n_var);
	if (*v_plus == NULL) goto err_alloc;
	*v_minus = nr_alloc_vector(1, n_var);
	if (*v_minus == NULL) goto err_alloc;
	*Gd = nr_alloc_matrix(1, n_var, 1, n_var);
	if (*Gd == NULL) goto err_alloc;
	*Gi = nr_alloc_matrix(1, n_var, 1, n_const);
	if (*Gi == NULL) goto err_alloc;
	*Hd = nr_alloc_matrix(1, n_var, 1, n_var);
	if (*Hd == NULL) goto err_alloc;
	*Hi = nr_alloc_matrix(1, n_var, 1, n_const);
	if (*Hi == NULL) goto err_alloc;

	return 0;

err_alloc:
	log_sys("## Error in allocate_base_matrixes.\n");
	return -1;
}

/*---------------------- free_base_matrixes -------------------------------------
 *	ܥޥȥåΰ賫
 */
static void
free_base_matrixes(double ***Gd, double ***Gi, double ***Hd, double ***Hi,
			    	double **v_plus, double **v_minus, int n_var, int n_const)
{
	if (*v_plus) nr_free_vector(*v_plus, 1, n_var);
	if (*v_minus) nr_free_vector(*v_minus, 1, n_var);
	if (*Gd) nr_free_matrix(*Gd, 1, n_var, 1, n_var);
	if (*Gi) nr_free_matrix(*Gi, 1, n_var, 1, n_const);
	if (*Hd) nr_free_matrix(*Hd, 1, n_var, 1, n_var);
	if (*Hi) nr_free_matrix(*Hi, 1, n_var, 1, n_const);
}
/*----------------getCurrentTimeStr------------------------------------------
 *
 * ॹʸ
 *
 *	I:ʤ
 *	O:ʤ
 *	꥿͡߻ʸ
 *
 */
static char *getCurrentTimeStr()
{
	long	t;
	static char buf[32];

	(void)time(&t);
	(void)strcpy(buf, ctime(&t));
	buf[strlen(buf) - 1] = '\0';
	return buf;
}

#undef _HAVE_MAIN_ROUTINE_
