//  ΥեRunge-KuttaˡˤˤʬȤȤ˴Ϣ
// ؿƤ롣
// ʲοޤϤΥե줿ؿδ֤δطˤĤƼΤǤ롣
//  ΥեƤΤ SolveDiffEqNormalRungeKuttanormalRungeKutta
// SolveDiffEqAdaptiveRungeKuttaadaptiveRungeKuttaStepcash_karpRungeKutta Ǥ롣
//
// SolveDiffEqNormalRungeKutta 	2ʬΥˡ̾Runge-Kuttaˡǲ򤯡
//   + CheckNRparam 			ѥ᡼ѲϢΩŪ˲򤭤ʤ
//   + SolveAlgebraicEq 		ϢΩ򤯡
//   + usr_differentialEq 		桼ؿ
//   + normalRungeKutta 		̾Runge-KuttaС
//       + usr_differentialEq 	
//          
//      
// SolveDiffEqAdaptiveRungeKutta2ʬΥˡưRunge-Kuttaˡǲ򤯡
//   + CheckNRparam 			
//   + SolveAlgebraicEq 		
//   + usr_differentialEq 		
//   + adaptiveRungeKuttaStep 	ưRunge-KuttaС
//       + cash_karpRungeKutta Cash-Karpˤ뼫ưRunge-KuttaС
//           + usr_differentialEq 

#include "life.h"

// ®ΤϥեstaticȤ롣
static double dym[MAX_VAR_NUM], dyt[MAX_VAR_NUM], yt[MAX_VAR_NUM];
static double /* a2=0.2,a3=0.3,a4=0.6,a5=1.0,a6=0.875, */ b21=0.2,
	b31=3.0/40.0,b32=9.0/40.0,b41=0.3,b42 = -0.9,b43=1.2,
	b51 = -11.0/54.0, b52=2.5,b53 = -70.0/27.0,b54=35.0/27.0,
	b61=1631.0/55296.0,b62=175.0/512.0,b63=575.0/13824.0,
	b64=44275.0/110592.0,b65=253.0/4096.0,c1=37.0/378.0,
	c3=250.0/621.0,c4=125.0/594.0,c6=512.0/1771.0,
	dc5 = -277.0/14336.0,
	dc1=37.0/378.0-2825.0/27648.0,dc3=250.0/621.0-18575.0/48384.0,
	dc4=125.0/594.0-13525.0/55296.0,dc6=512.0/1771.0-0.25;
static double ak2[MAX_VAR_NUM], ak3[MAX_VAR_NUM], ak4[MAX_VAR_NUM];
static double ak5[MAX_VAR_NUM], ak6[MAX_VAR_NUM], ytemp[MAX_VAR_NUM];
static double yerr[MAX_VAR_NUM],y_tmp[MAX_VAR_NUM];
static double dydt[MAX_VAR_NUM], y_scale[MAX_VAR_NUM];

// եstaticؿΥץȥ
static void normalRungeKutta(double y[], double dydt[], int n, double t, double h);
static int adaptiveRungeKuttaStep(double y[], double dydx[], int n, double *x, double *h, double yscal[]);
static void cash_karpRungeKutta(double y[], double dydx[], int n, double x, double h,
			   	double yout[], double yerr[]);

//----------------SolveDiffEqNormalRungeKutta------------------------------------------
// 	2ʬΥˡ(Runge-Kutta̾)ϢΩʬ򤯡
//
//	I:nvar, y, y_pre, t, h
//	O:y, y_pre, t
//	꥿͡(0)(-1)
//
int SolveDiffEqNormalRungeKutta(int nvar, double y[], double y_pre[],
			   	double *t, double *h, int f_event)
{
	int i;
	//static double dydt[MAX_VAR_NUM];

	if (Param.n_varNR) {	// 2ʬΥξ
		// ѥ᡼ѹƤŪͤѤϢΩľ
		if (f_event) {
			if (CheckNRparam(y_pre)) return -1;
			// βȿǤ '2002.11.20
			for (i=1; i <= Param.n_varNR; i++) y[i] = y_pre[i];
		}

		// ϢΩ굡Ū˲򤭡򤱤ʤˤäƲľ
		if (SolveAlgebraicEq(y, y_pre)) return -1;
	}

	/* usr_differentialEq(*t,y,dydt,GeneConc,&Param); */	// 桼ؿ
	usr_fvec(dydt,y,GeneConc,&Param);	// 桼ؿ

	normalRungeKutta(y, dydt, nvar, *t, *h);	// ̾RungeKutta1ƥåפ¹
			
	*t += *h;	// ʤ롣

	return 0;
}

//----------------normalRungeKutta------------------------------------------
// 	̾Runge-Kuttaʬ򤯡
//
//	I:y, dydt, n, t, h
//	O:y
//	꥿͡ʤ
//
static void normalRungeKutta(double y[], double dydt[], int n, double t, double h)
{
	double th,hh,h6;
	//static double dym[MAX_VAR_NUM], dyt[MAX_VAR_NUM], yt[MAX_VAR_NUM];
	int i;

	hh=h*0.5;
	h6=h/6.0;
	th=t+hh;
	/* for (i=1;i<=n;i++) */
	for (i=1;i<=Param.n_varNR;i++) 
		yt[i]=y[i];
	for (i=1+Param.n_varNR;i<=n;i++) 
		yt[i]=y[i]+hh*dydt[i];

	/* usr_differentialEq(th,yt,dyt,GeneConc,&Param); */
	usr_fvec(dyt,yt,GeneConc,&Param);
	/* for (i=1;i<=n;i++) */
	for (i=1+Param.n_varNR;i<=n;i++) 
		yt[i]=y[i]+hh*dyt[i];
	/* usr_differentialEq(th,yt,dym,GeneConc,&Param); */
	usr_fvec(dym,yt,GeneConc,&Param);
	/* for (i=1;i<=n;i++) {} */
	for (i=1+Param.n_varNR;i<=n;i++) {
		yt[i]=y[i]+h*dym[i];
		dym[i] += dyt[i];
	}
	/* usr_differentialEq(t+h,yt,dyt,GeneConc,&Param); */
	usr_fvec(dyt,yt,GeneConc,&Param);
	/* for (i=1;i<=n;i++) */
	for (i=1+Param.n_varNR;i<=n;i++) 
		y[i]=y[i]+h6*(dydt[i]+dyt[i]+2.0*dym[i]);
}

//----------------SolveDiffEqAdaptiveRungeKutta------------------------------------------
// 	2ʬΥˡ(Runge-Kuttaư)ϢΩʬ򤯡
//
//	I:nvar, y, y_pre, t, h, t_end
//	O:y, y_pre, t, h
//	꥿͡(0)(-1)
//
int SolveDiffEqAdaptiveRungeKutta(int nvar, double y[], double y_pre[],
			   	double *t, double *h, double t_end, int f_event)
{
	int i;
	//static double dydt[MAX_VAR_NUM], y_scale[MAX_VAR_NUM];

	if (Param.n_varNR) {	// 2ʬΥξ
		// ѥ᡼ѹƤŪͤѤϢΩľ
		if (f_event) {
			if (CheckNRparam(y_pre)) return -1;
			// βȿǤ '2002.11.20
			for (i=1; i <= Param.n_varNR; i++) y[i] = y_pre[i];
		}

		// ϢΩ굡Ū˲򤭡򤱤ʤˤäƲľ
		if (SolveAlgebraicEq(y, y_pre)) return -1;
	}

	/* usr_differentialEq(*t,y,dydt,GeneConc,&Param); */  // 桼ؿ
	usr_fvec(dydt,y,GeneConc,&Param);  // 桼ؿ

	// ٴƻѥη׻
	for (i=1+Param.n_varNR; i<=nvar; i++) y_scale[i]=fabs(y[i])+fabs(dydt[i]*(*h))+TINY;

	// Ǹλ֥ƥåפλֹĴ
	if((*t)+(*h) > t_end) (*h) = t_end - (*t);

	// ŬRungeKutta1ƥåפ¹
	if (adaptiveRungeKuttaStep(y, dydt, nvar, t, h, y_scale)) return -1;

	if((*h) < TINY) {	// ޤ˾ʤäƤޤäǤڤ
		log_sys("## Step size is too small. h=%10.3E\n", *h);
		return -1;
	}
			
	return 0;
}

#define SAFETY 0.9
#define PGROW -0.2
#define PSHRNK -0.25
#define ERRCON 1.89e-4

//----------------adaptiveRungeKuttaStep------------------------------------------
// 	ưRunge-Kuttaʬ򤯡
//
//	I:y, dydt, n, t, h, yscal
//	O:y, t, h
//	꥿͡(0)(-1)
//
static int adaptiveRungeKuttaStep(double y[], double dydx[], int n, double *t, double *h, double yscal[])
{
	int i;
	double eps = Rk_eps;
	double errmax;
	double tmp, htmp;
	int	forced_positive;
	//static double yerr[MAX_VAR_NUM],ytemp[MAX_VAR_NUM];temp->_tmp

	for (;;) {
		cash_karpRungeKutta(y,dydx,n,*t,*h,y_tmp,yerr);

		errmax=0.0;
		forced_positive = 0;
		for (i=1+Param.n_varNR;i<=n;i++) {
			tmp = fabs(yerr[i]/yscal[i]);
			errmax = (errmax > tmp) ? errmax : tmp;
			if( y_tmp[i] < 0.0 )	forced_positive = 1;
		}
		errmax /= eps;
#ifdef DBG
		DBGW(1,("t=%10.3E, h=%10.3E, errmax=%10.3E\n", *t, *h, errmax));
#endif
		if (!forced_positive && errmax <= 1.0) {
			break;
		}

		tmp = 0.1 * (*h);	/* ƥå10˽̾ */
		if( forced_positive ){
			*h = tmp;
		}else{
			htmp = SAFETY * (*h) * pow(errmax,PSHRNK);
			/* ƥå10ʲˤʤ */
			*h = (htmp > tmp)? htmp : tmp;
		}

		if (*t + *h == *t) {
			log_sys("## Step size underflow in adaptiveRungeKuttaStep.\n");
			return -1;
		}
	}

	*t += *h;
	if (errmax > ERRCON)	*h *= SAFETY * pow(errmax,PGROW);
	else			*h *= 5.0;
	for (i=1;i<=n;i++)	y[i]=y_tmp[i];

	return 0;
}
#undef SAFETY
#undef PGROW
#undef PSHRNK
#undef ERRCON

//----------------cash_karpRungeKutta------------------------------------------
// 	ưRunge-Kuttaʬ򤯡
//
//	I:y, dydt, n, t, h
//	O:yout, yerr
//	꥿͡ʤ
//
static void cash_karpRungeKutta(double y[], double dydx[], int n, double t, double h,
			   	double yout[], double yerr[])
{
	int i;
	//static double a2=0.2,a3=0.3,a4=0.6,a5=1.0,a6=0.875,b21=0.2,
		//b31=3.0/40.0,b32=9.0/40.0,b41=0.3,b42 = -0.9,b43=1.2,
		//b51 = -11.0/54.0, b52=2.5,b53 = -70.0/27.0,b54=35.0/27.0,
		//b61=1631.0/55296.0,b62=175.0/512.0,b63=575.0/13824.0,
		//b64=44275.0/110592.0,b65=253.0/4096.0,c1=37.0/378.0,
		//c3=250.0/621.0,c4=125.0/594.0,c6=512.0/1771.0,
		//dc5 = -277.0/14336.0;
	//double dc1=c1-2825.0/27648.0,dc3=c3-18575.0/48384.0,
		//dc4=c4-13525.0/55296.0,dc6=c6-0.25;
	//static double ak2[MAX_VAR_NUM], ak3[MAX_VAR_NUM], ak4[MAX_VAR_NUM];
	//static double ak5[MAX_VAR_NUM], ak6[MAX_VAR_NUM], ytemp[MAX_VAR_NUM];

	for (i=1;i<=Param.n_varNR;i++) 
		ytemp[i]=y[i];
	for (i=1+Param.n_varNR;i<=n;i++) 
		ytemp[i]=y[i]+b21*h*dydx[i];
	usr_fvec(ak2,ytemp,GeneConc,&Param);

	for (i=1+Param.n_varNR;i<=n;i++) 
		ytemp[i]=y[i]+h*(b31*dydx[i]+b32*ak2[i]);
	usr_fvec(ak3,ytemp,GeneConc,&Param);

	for (i=1+Param.n_varNR;i<=n;i++) 
		ytemp[i]=y[i]+h*(b41*dydx[i]+b42*ak2[i]+b43*ak3[i]);
	usr_fvec(ak4,ytemp,GeneConc,&Param);

	for (i=1+Param.n_varNR;i<=n;i++) 
		ytemp[i]=y[i]+h*(b51*dydx[i]+b52*ak2[i]+b53*ak3[i]+b54*ak4[i]);
	usr_fvec(ak5,ytemp,GeneConc,&Param);

	for (i=1+Param.n_varNR;i<=n;i++) 
		ytemp[i]=y[i]+h*(b61*dydx[i]+b62*ak2[i]+b63*ak3[i]+b64*ak4[i]+b65*ak5[i]);
	usr_fvec(ak6,ytemp,GeneConc,&Param);

	for (i=1;i<=Param.n_varNR;i++) 
		yout[i]=y[i];
	for (i=1+Param.n_varNR;i<=n;i++) 
		yout[i]=y[i]+h*(c1*dydx[i]+c3*ak3[i]+c4*ak4[i]+c6*ak6[i]);
	for (i=1+Param.n_varNR;i<=n;i++) 
		yerr[i]=h*(dc1*dydx[i]+dc3*ak3[i]+dc4*ak4[i]+dc5*ak5[i]+dc6*ak6[i]);
}
