/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         GMA / MM ˤ Reaction Ѵ
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * Flux ɲä롣
 */
void AddFluxToEquation (Equation_t *eq, FluxEq_t *fluxEq, double stoichiometry) {
	int			i, index;
	Term_t			*t;
	Coefficient_t		*c;

#ifdef DEBUG_G
	fprintf (stdout, "AddFluxToEquation: start.\n");
	fflush (stdout);
#endif
	t = (Term_t*) calloc (1, sizeof(Term_t));
	c = &(t->coefficient);
	c->coefficient = stoichiometry;
	c->powerCoefficient = 1.0;
	c->paramType = PARAM_TYPE_NONE;
	Enqueue ((Queue_t**)&(t->fluxEq), (Queue_t*)fluxEq);
	AddTermToEquation (eq, t);
#ifdef DEBUG_G
	fprintf (stdout, "AddFluxToEquation: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux  Reactants, Products ɲä롣
 */
static void addFluxToEquations (TempInfo_t *tempInfo, FluxEq_t *fluxEq, CReaction_t *reaction) {
	int			i, index;
	CListOfPlayers_t	*lor, *lop;
	int			lor_n, lop_n;
	Equation_t		*eq;
	double stoichiometry; /* add '030703 by Satoh */

#ifdef DEBUG_G
	fprintf (stdout, "addFluxToEquations: start.\n");
	fflush (stdout);
#endif
	ReadMemberOfReaction (reaction, 
			      &lor, &lor_n, &lop, &lop_n,
			      NULL, NULL, NULL, NULL,
			      NULL);

	/* Reactants ɲ */
	for (i = 0; i < lor_n; i++) {
		index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, lor->specieReference[i].specieID);
		stoichiometry = lor->specieReference[i].stoichiometry;
		eq = &(tempInfo->equations[index]);
		AddFluxToEquation (eq, fluxEq, -stoichiometry); /* -1.0 -> -stoichiometry */
	}

	/* Products ɲ */
	for (i = 0; i < lop_n; i++) {
		index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, lop->specieReference[i].specieID);
		stoichiometry = lop->specieReference[i].stoichiometry;
		eq = &(tempInfo->equations[index]);
		AddFluxToEquation (eq, fluxEq, stoichiometry); /* +1.0 -> stoichiometry */
	}
#ifdef DEBUG_G
	fprintf (stdout, "addFluxToEquations: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux αդ listOfReactants 񤭽Ф
 */
static void writeFluxRightPartReactants (TempInfo_t *tempInfo, char **buff, CListOfPlayers_t *lor, int lor_n, CListOfPlayers_t *lom, int lom_n, int convType) {
	int			i, index;
	CSpecieReference_t	*sr;
	Player_t		*v;
	char			*buff2, *playerStr;
	Parameter_t		*param;

#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPartReactants: start.\n");
	fflush (stdout);
#endif
	/* ListOfReactants ν񤭽Ф */
	for (i = 0; i < lor_n; i++) {
		/* Reactant μ */
		sr = &(lor->specieReference[i]);
		index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, sr->specieID);
		v = &(tempInfo->variables[index]);

		/* ѥ᡼κ */
		param = MakeParam (tempInfo, paramTypeOfConvType_GMA_player[convType], lom, lor, v, NULL);

		/* Reactant νʸκ */
		WritePlayer (&playerStr, v, "");

		/* Хåեʣ */
		buff2 = strdup (*buff);

		/* Ѵ˱Ƥǽ */
		switch (convType) {
		case CONVTYPE_GMA:
			/* GMA ξ */
			snprintf (*buff, BUFFSIZE, "%s*%s^%s[%d]", buff2, playerStr, paramTypeStr[param->type], param->index);
			break;
		case CONVTYPE_MM:
			/* MM ξ */
			/* зĤƽ */
			if (sr->stoichiometry == 1.0) {
				snprintf (*buff, BUFFSIZE, "%s*%s/(%s[%d]+%s)", buff2, playerStr, paramTypeStr[param->type], param->index, playerStr);
			} else {
				snprintf (*buff, BUFFSIZE, "%s*%s^%g/(%s[%d]^%g+%s^%g)", buff2, playerStr, sr->stoichiometry, paramTypeStr[param->type], param->index, sr->stoichiometry, playerStr, sr->stoichiometry);
			}
			break;
		}
		free (buff2);
		free (playerStr);
	}
#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPartReactants: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux αդ Modifier 񤭽Ф
 */
static void writeFluxRightPartModifier (TempInfo_t *tempInfo, char **buff, CListOfPlayers_t *lom, int lom_n, CListOfPlayers_t *lor, int lor_n, int convType) {
	int			i, index;
	CSpecieReference_t	*sr;
	Player_t		*v, *vt;
	char			*buff2, *playerStr = NULL, *modifierStr;
	Parameter_t		*param;

#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPartModifier: start.\n");
	fflush (stdout);
#endif
	/* ХåեʣäƤ */
	buff2 = strdup (*buff);

	/* Modifier μ */
	sr = &(lom->specieReference[0]);
	index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, sr->specieID);
	v = &(tempInfo->variables[index]);

	/* isTotal  true ʤй̼ޤ total ̤񤭽Ф
	   false ʤ Modifier 򤽤Τޤ޽񤭽Ф */
	if (v->isTotal) {
		/* totalEnzymeEq  NULL Ǥʤй̼
		   NULL ʤ total ̤񤭽Ф */
		if (v->totalEnzymeEq) {
			/* Ϥ˹̼򥻥å */
			modifierStr = v->totalEnzymeEq->leftPart;
			v->totalEnzymeEq->inUse = true;
		} else {
			/* Ϥ total ̤򥻥å */
			vt = &(tempInfo->variables_total[index]);
			WritePlayer (&playerStr, vt, "T");
			modifierStr = playerStr;
		}
	} else {
		/* Ϥ Modifier 򥻥å */
		WritePlayer (&playerStr, v, "");
		modifierStr = playerStr;
	}

	/* ǥåȤϤ񤭽Ф */
	snprintf (*buff, BUFFSIZE, "%s*%s", buff2, modifierStr);
	free (buff2);
	free (playerStr);

	/* GMA ʤХѥ᡼ƽ񤭽Ф */
	if (convType == CONVTYPE_GMA) {
		param = MakeParam (tempInfo, paramTypeOfConvType_GMA_player[CONVTYPE_GMA], lom, lor, v, NULL);
		buff2 = strdup (*buff);
		snprintf (*buff, BUFFSIZE, "%s^%s[%d]", buff2, paramTypeStr[param->type], param->index);
		free (buff2);
	}
#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPartModifier: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux αդ񤭽Ф
 */
static void writeFluxRightPart (TempInfo_t *tempInfo, char **rightPart, CReaction_t *reaction, int convType) {
	CListOfPlayers_t	*lor, *lom;
	int			lor_n, lom_n;
	char			*buff;
	Parameter_t		*param;

#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPart: start.\n");
	fflush (stdout);
#endif
	/*  */
	ReadMemberOfReaction (reaction, 
			      &lor, &lor_n, NULL, NULL,
			      &lom, &lom_n, NULL, NULL,
			      NULL);

	/* Хåե alloc */
	buff = (char*) calloc (1, BUFFSIZE);

	/* ѥ᡼ (kxg|Q) κȽ񤭽Ф */
	param = MakeParam (tempInfo, paramTypeOfConvType_GMA_eq[convType], lom, lor, NULL, NULL);
	snprintf (buff, BUFFSIZE, "%s[%d]", paramTypeStr[param->type], param->index);
	
	/* Modifier ν񤭽Ф */
	if (lom)
		writeFluxRightPartModifier (tempInfo, &buff, lom, lom_n, lor, lor_n, convType);

	/* Reactants ν񤭽Ф */
	writeFluxRightPartReactants (tempInfo, &buff, lor, lor_n, lom, lom_n, convType);

	/* Хåե rightPart ˥ԡ */
	*rightPart = strdup (buff);
	free (buff);
#ifdef DEBUG_G
	fprintf (stdout, "writeFluxRightPart: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux κդ listOfPlayers 񤭽Ф
 */
static void writeFluxLeftPartPlayers (TempInfo_t *tempInfo, char **buff, CListOfPlayers_t *lop, int lop_n) {
	int			i, index;
	CSpecieReference_t	*sr;
	Player_t		*v;
	char			*buff2;

#ifdef DEBUG_G
	fprintf (stdout, "writeFluxLeftPartPlayers: start.\n");
	fflush (stdout);
#endif
	/* Player ν񤭽Ф */
	for (i = 0; i < lop_n; i++) {
		sr = &(lop->specieReference[i]);
		index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, sr->specieID);
		v = &(tempInfo->variables[index]);
		buff2 = strdup (*buff);
		snprintf (*buff, BUFFSIZE, "%s_%s.%s", buff2, v->name, v->compartment_suffix);
		free (buff2);
	}
#ifdef DEBUG_G
	fprintf (stdout, "writeFluxLeftPartPlayers: end.\n");
	fflush (stdout);
#endif
}

/**
 * Flux κդ񤭽Ф
 */
static void writeFluxLeftPart (TempInfo_t *tempInfo, char **leftPart, CReaction_t *reaction) {
	CListOfPlayers_t	*lor, *lop, *lom;
	int			lor_n, lop_n, lom_n;
	char			*buff, *buff2;

#ifdef DEBUG_G
	fprintf (stdout, "writeFluxLeftPart: start.\n");
	fflush (stdout);
#endif
	/*  */
	ReadMemberOfReaction (reaction, 
			      &lor, &lor_n, &lop, &lop_n,
			      &lom, &lom_n, NULL, NULL,
			      NULL);

	/* Хåե alloc  "flux" ν񤭽Ф */
	buff = (char*) calloc (1, BUFFSIZE);
	snprintf (buff, BUFFSIZE, "flux");

	/* Modifier, Reactants ν񤭽Ф */
	writeFluxLeftPartPlayers (tempInfo, &buff, lom, lom_n);
	writeFluxLeftPartPlayers (tempInfo, &buff, lor, lor_n);

	/* "_to" ν񤭽Ф */
	buff2 = strdup (buff);
	snprintf (buff, BUFFSIZE, "%s_to", buff2);
	free (buff2);

	/* Products ν񤭽Ф */
	writeFluxLeftPartPlayers (tempInfo, &buff, lop, lop_n);

	/* Хåե leftPart ˥ԡ */
	*leftPart = strdup (buff);
	free (buff);
#ifdef DEBUG_G
	fprintf (stdout, "writeFluxLeftPart: end.\n");
	fflush (stdout);
#endif
}

/**
 * Reaction Ѵ
 *
 * FluxEq  alloc 롣
 * Flux κդ񤭽Ф
 * Flux αդ񤭽Ф
 * Reactants  Products  Flux ιɲä롣
 */
static FluxEq_t* convertReaction_GMA (TempInfo_t *tempInfo, CReaction_t *reaction, int convType) {
	TemporaryEqs_t		*tempEqs;
	FluxEq_t		*fluxEq;

#ifdef DEBUG_G
	fprintf (stdout, "convertReaction_GMA: start.\n");
	fflush (stdout);
#endif
	/* Ѵɬפʤнλ */
	if (reaction->isConvertible == PARSEDAE_FALSE)
		return NULL;

	/*  */
	tempEqs = &(tempInfo->temporaryEqs);

	/* FluxEq  alloc */
	fluxEq = (FluxEq_t*) calloc (1, sizeof(FluxEq_t));

	/* դ񤭽Ф */
	writeFluxLeftPart (tempInfo, &(fluxEq->leftPart), reaction);

	/* դ񤭽Ф */
	writeFluxRightPart (tempInfo, &(fluxEq->rightPart), reaction, convType);

	/* Flux  temporaryEqs Ͽ */
	Enqueue ((Queue_t**)&(tempEqs->fluxEqs), (Queue_t*)fluxEq);

	/* Reactants, Products  Flux ɲä */
	addFluxToEquations (tempInfo, fluxEq, reaction);

	return fluxEq;
#ifdef DEBUG_G
	fprintf (stdout, "convertReaction_GMA: end.\n");
	fflush (stdout);
#endif
}

/**
 * ʬ Flux Ĥ롣
 *
 * ʬ򤹤ʪ Reactant Ȥ Reaction 
 * ̾ Reaction ѴƱͤѴ롣
 */
void MakeFluxEq_decomp (TempInfo_t *tempInfo, Player_t *v, int convType) {
	FluxEq_t		*fluxEq;
	CReaction_t		*r;
	CListOfPlayers_t	*lor;
	CSpecieReference_t	*sr;

#ifdef DEBUG_G
	fprintf (stdout, "MakeFluxEq_decomp: start.\n");
	fflush (stdout);
#endif
	/* Reaction κ */
	r = (CReaction_t*) calloc (1, sizeof(CReaction_t));
	r->listOfReactants = (CListOfPlayers_t[]) calloc (1, sizeof(CListOfPlayers_t));
	lor = &(r->listOfReactants[0]);
	lor->numberOfPlayers = 1;
	lor->specieReference = (CSpecieReference_t[]) calloc (1, sizeof(CSpecieReference_t));
	sr = &(lor->specieReference[0]);
	sr->specieID = v->specieID;
	sr->stoichiometry = 1.0;

	/* Reaction Ѵ */
	fluxEq = convertReaction_GMA (tempInfo, r, convType);

	free (lor->specieReference);
	free (r->listOfReactants);
	free (r);

#ifdef DEBUG_G
	fprintf (stdout, "MakeFluxEq_decomp: end.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * ꤷ variable  specieID ʪޤफĴ٤롣
 *
 * variable ʣΤǤʤФʤˤޤߤ褦ʤ 0.0 ֤
 * ʣΤʤйǤĴ١ID  specieID ȰפΤ
 * С stoichiometry ֤
 * פʤΤʣ ( 2 İʾιǤޤ) 
 * ƵŪĴ٤롣
 */
static double checkPlayerInComplex (TempInfo_t *tempInfo, Player_t *variable, int specieID) {
	int			i, index;
	double			ret, result;
	CSpecieReference_t	*sr;
	Player_t		*v;

#ifdef DEBUG_G
	fprintf (stdout, "checkPlayerInComplex: start.\n");
	fflush (stdout);
#endif
	ret = 0.0;

	/* ʪιǤĴ٤ */
	for (i = 0; i < variable->numberOfElements; i++) {
		sr = &(variable->specieReference[i]);
		/* ιǤ specieID ΤΤȰפ
		   ʤĿƤʪѿ̤̤Ǥʤ
		    stoichiometry ֤ */
		if (sr->specieID == specieID &&
		    variable->variableType != VARIABLE_TYPE_UNKNOWN) {
			ret = sr->stoichiometry;
			break;
		}
		/* פʤäΤ specieID  variable 򸡺 */
		index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, sr->specieID);
		v = &(tempInfo->variables[index]);
		/* variable  2 İʾιǤĤʤкƵŪĴ٤ */
		if (v->numberOfElements >= 2) {
			/* ǤǸĤ true ֤äƤƤ true ֤ */
			if (result = checkPlayerInComplex (tempInfo, v, specieID)) {
				ret = result * sr->stoichiometry;
				break;
			}
		}
		
	}

#ifdef DEBUG_G
	fprintf (stdout, "checkPlayerInComplex: end.\n");
	fflush (stdout);
#endif
	return ret;
}

/**
 * ̼κᥤ
 */
static void createTotalEnzymeEq_main (TempInfo_t *tempInfo, int index) {
	int			i;
	TemporaryEqs_t		*tempEqs;
	TotalEnzymeEq_t		*te;
	Player_t		*v, *v2;
	char			*buff, *buff2, *playerStr;
	double			result;

#ifdef DEBUG_G
	fprintf (stdout, "createTotalEnzymeEq_main: start.\n");
	fflush (stdout);
#endif
	/*  */
	tempEqs = &(tempInfo->temporaryEqs);
	v = &(tempInfo->variables[index]);

	/* TotalEnzymeEq  alloc  */
	te = (TotalEnzymeEq_t*) calloc (1, sizeof(TotalEnzymeEq_t));

	/* ̼Ͻ֤Ǥ̤ */
	te->inUse = false;

	/* Хåե alloc Ⱥդν񤭽Ф */
	buff = (char*) calloc (1, BUFFSIZE);
	snprintf (buff, BUFFSIZE, "T_%s.%s", v->name, v->compartment_suffix);
	te->leftPart = strdup (buff);
	free (buff);

	/* դν񤭽Ф */
	/* Хåե alloc Ȥʪν񤭽Ф */
	buff = (char*) calloc (1, BUFFSIZE);
	WritePlayer (&playerStr, v, "");
	snprintf (buff, BUFFSIZE, "%s", playerStr);
	free (playerStr);

	/* ʪޤʣΤõƼ˽ */
	for (i = 0; i < tempInfo->numberOfSpecies; i++) {
		v2 = &(tempInfo->variables[i]);
		if (result = checkPlayerInComplex (tempInfo, v2, v->specieID)) {
			buff2 = strdup (buff);
			WritePlayer (&playerStr, v2, "");
			if (result == 1.0) {
				snprintf (buff, BUFFSIZE, "%s + %s", buff2, playerStr);
			} else {
				snprintf (buff, BUFFSIZE, "%s + %g*%s", buff2, result, playerStr);
			}
			free (playerStr);
			free (buff2);
		}
	}

	/* Хåե̼αդʸ򥳥ԡ̼ʪϿ */
	te->rightPart = strdup (buff);
	v->totalEnzymeEq = te;

	/* ̼ temporaryEqs Ͽ */
	Enqueue ((Queue_t**)&(tempEqs->totalEnzymeEqs), (Queue_t*)te);

	free (buff);

#ifdef DEBUG_G
	fprintf (stdout, "createTotalEnzymeEq_main: end.\n");
	fflush (stdout);
#endif
	return;
}

/**
 * ʪåȹ̼κ
 *
 * ʪˤĤƹ̼ɬפ뤫ɤȽꤷ
 * ɬפʤй̼κᥤؿ˽ꤲ롣
 */
static int createTotalEnzymeEq (TempInfo_t *tempInfo) {
	int			i;
	Player_t		*v, *vt;

#ifdef DEBUG_G
	fprintf (stdout, "createTotalEnzymeEq: start.\n");
	fflush (stdout);
#endif

	/* variables ʪҤȤĤĽ */
	for (i = 0; i < tempInfo->numberOfSpecies; i++) {
		v = &(tempInfo->variables[i]);

		/* GMA/MM  Reactant/Product ȤƴͿ  GMA μ */
		/* å */
		if (v->isRP_GMA) {

#if 0
/* 2003.04.15: */
/* METABOLICؤѿϡGENEؤѿˤʤ뤳ȤϤޤפ */
/* ̤ϻȤʤỦƤ */
			switch (v->variableType) {
			case VARIABLE_TYPE_UNKNOWN:
				break;
			case VARIABLE_TYPE_CONST:
				if (v->totalAmount == SPECIEATTRIBUTE_TOTALAMOUNT_CONSTANT &&
				    v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_OFF) {
					break;
				}
			default:
				log_sys ("CMA/TPP ѿȤƻȤ줿ʪ GMA/MM ѿȤƻȤȤϤǤޤ. (specieID = %d)\n", v->specieID);
				goto err;
			}
#endif /* 0 */

			if (v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_ON) {
				log_sys ("createTotalEnzymeEq: '%s.%s(specieID=%d)' must not be a reactant or product of 'GMA/MM', because its massBalance is 'ON'.\n", v->name, v->compartment_suffix, v->specieID);
				goto err;
			}
			if (checkSpecieClass_GMA[v->specieClass] == PARSEDAE_NG) {
				log_sys ("createTotalEnzymeEq: '%s.%s(specieID=%d)' must not be a reactant or product of 'GMA/MM', because its specieClass is %s.\n", v->name, v->compartment_suffix, v->specieID, specieClassStr[v->specieClass]);
				goto err;
			}
		}

		/* variableType  DIFF_GMA  CMA/TPP ̤ */
		if (v->variableType == VARIABLE_TYPE_DIFF_GMA) {
			/* Reactant/Product ȤƻȤ줿 */
			if (! v->isRP_GMA) {
				/* GMA/MM Ǥ̤ʤΤ CONST */
				v->variableType == VARIABLE_TYPE_CONST;
				NumberConstantPlayer (tempInfo, v);
			}
			/* ɤˤ CMA/TPP ̤ʤΤ̼ */
			continue;
		}

		/* isTotal  true ΤΤʤ̼ */
		if (! v->isTotal)
			continue;

		/* Gene-Protein ؤѴ CMA Ǥʤ
		   massBalance  on ʤй̼ʤ */
		if (tempInfo->convType_GeneProtein != CONVTYPE_CMA &&
		    v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_ON)
			continue;

		/* ̼ɬפʤΤǺ */
		createTotalEnzymeEq_main (tempInfo, i);
	}

#ifdef DEBUG_G
	fprintf (stdout, "createTotalEnzymeEq: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * ʪѴå
 */
static int checkPlayer_GMA (TempInfo_t *tempInfo, CSpecieReference_t *specieReference, int playerType) {
	int			index;
	Player_t		*v;

#ifdef DEBUG_G
	fprintf (stdout, "checkPlayer_GMA: start.\n");
	fflush (stdout);
#endif

	index = SearchPlayerBySpecieID (tempInfo->variables, tempInfo->numberOfSpecies, specieReference->specieID);
	v = &(tempInfo->variables[index]);

	/* Reactant ޤ Product ȤƴͿʤե饰ΩƤ */
	if (playerType == PLAYER_TYPE_REACTANT ||
	    playerType == PLAYER_TYPE_PRODUCT)
		v->isRP_GMA = true;

	/* Modifier ȤƴͿʤ isTotal å */
	/* true ʤ v->isTotal  true ˤfalse ʤФʤˤ⤷ʤ */
	if (playerType == PLAYER_TYPE_MODIFIER)
		if (specieReference->isTotal == PARSEDAE_TRUE)
			v->isTotal = true;

	/* ʪ̤̤  CMA ̤  ޤ GMA ѿ */
	if (v->variableType == VARIABLE_TYPE_UNKNOWN) {
		if (v->totalAmount == SPECIEATTRIBUTE_TOTALAMOUNT_CONSTANT &&
		    v->massBalance == SPECIEATTRIBUTE_MASSBALANCE_OFF) {
			/* totalAmount:on  massBalance:off ʤ */
			v->variableType = VARIABLE_TYPE_CONST;
			NumberConstantPlayer (tempInfo, v);
			/*  decomposition:off ǤʤХ顼 */
			if (v->decomposition == SPECIEATTRIBUTE_DECOMPOSITION_ON) {
				log_sys ("checkPlayer_GMA: constant variable '%s.%s(specieID=%d)' is must be decomposition:off.\n", v->name, v->compartment_suffix, v->specieID);
				goto err;
			}
		} else {
			/* ξʤ GMA ѿ */
			v->variableType = VARIABLE_TYPE_DIFF_GMA;
		}
	}

	/* ʪ̤ ALGE_COMPLEX ʤХ顼 */
	if (v->variableType == VARIABLE_TYPE_ALGE_COMPLEX) {
		log_sys ("checkPlayer_GMA: '%s.%s(specieID=%d)' must not be a player of 'GMA/MM', because its a complex of 'CMA/TPP'.\n", v->name, v->compartment_suffix, specieReference->specieID);
		goto err;
	}

#ifdef DEBUG_G
	fprintf (stdout, "checkPlayer_GMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * Reaction Ѵå
 *
 * ʪ Reactant ޤ Product ȤƴͿ뤫ɤå
 * ʪ Modifier ȤƴͿ isTotal Ͽ
 * 줿ʪѿ̤򥻥åȤ
 */
static int checkReaction_GMA (TempInfo_t *tempInfo, CReaction_t *reaction) {
	int			i, index;
	CListOfPlayers_t	*lor, *lop, *lom;
	int			lor_n, lop_n, lom_n;
	int			reactionType;

#ifdef DEBUG_G
	fprintf (stdout, "checkReaction_GMA: start.\n");
	fflush (stdout);
#endif

	/*  */
	ReadMemberOfReaction (reaction, 
			      &lor, &lor_n, &lop, &lop_n,
			      &lom, &lom_n, NULL, NULL,
			      &reactionType);

	/* reactionType Υå */
	if (checkReactionType_GMA[reactionType] == PARSEDAE_NG) {
		log_sys ("checkReaction_GMA: invalid reactionType for GMA/MM conversion.(reactionID=%d,reactionType=%s)\n", reaction->reactionID, reactionTypeStr[reactionType]);
		goto err;
	}

	/* reactants Υå */
	if (lor) {
		for (i = 0; i < lor_n; i++) {
			if (checkPlayer_GMA (tempInfo, &(lor->specieReference[i]), PLAYER_TYPE_REACTANT)) {
				log_sys ("checkReaction_GMA: The error detected with checking reactant.(reactionID=%d)\n", reaction->reactionID);
				goto err;
			}
		}
	} else {
		/* reactants ɬ¸ߤʤФʤʤ  ʤХ顼 */
		log_sys ("checkReaction_GMA: lack of reactants.(reactionID=%d)\n", reaction->reactionID);
		goto err;
	}

	/* products Υå */
	if (lop) {
		for (i = 0; i < lop_n; i++) {
			if (checkPlayer_GMA (tempInfo, &(lop->specieReference[i]), PLAYER_TYPE_PRODUCT)) {
				log_sys ("checkReaction_GMA: The error detected with checking product.(reactionID=%d)\n", reaction->reactionID);
				goto err;
			}
		}
	}
	/* modifiers Υå */
	if (lom) {
		for (i =0; i < lom_n; i++) {
			if (checkPlayer_GMA (tempInfo, &(lom->specieReference[i]), PLAYER_TYPE_MODIFIER)) {
				log_sys ("checkReaction_GMA: The error detected with checking modifier.(reactionID=%d)\n", reaction->reactionID);
				goto err;
			}
		}
	}

#ifdef DEBUG_G
	fprintf (stdout, "checkReaction_GMA: end.\n");
	fflush (stdout);
#endif
	return 0;
  err:
	return -1;
}

/**
 * GMA/MM ˤѴ - ᥤ (listOfReactions Ÿ)
 *
 * listOfReactions  layer ѴꤷGMA/MM ʤ
 * listOfReactions  reaction ҤȤĤ classifyReaction_GMA Ϥ
 * CMA/TPP ʤФʤˤ⤷ʤ
 */
int ReadReactions_GMA (TempInfo_t *tempInfo, CModel_t *model) {
	int 			i, j;
	CListOfReactions_t	*listOfReactions;
	int 			layer;
	int 			convType;

#ifdef DEBUG_G
	fprintf (stdout, "ReadReactions_GMA: start.\n");
	fflush (stdout);
#endif

	for (i = 0; i < model->listOfReactions_n; i++) {
		listOfReactions = &(model->listOfReactions[i]);

		/* layer Ѵꤹ */
		layer = listOfReactions->layer;
		switch (layer) {
		case LISTOFREACTIONS_LAYER_GENE:
		case LISTOFREACTIONS_LAYER_PROTEIN:
			convType = tempInfo->convType_GeneProtein;
			break;
		case LISTOFREACTIONS_LAYER_METABOLIC:
			convType = tempInfo->convType_Metabolic;
			break;
		}

		switch (convType) {
		case CONVTYPE_GMA:
		case CONVTYPE_MM:
			/* Ѵå */
			for (j = 0; j < listOfReactions->numberOfReactions; j++) {
				if (checkReaction_GMA (tempInfo, &(listOfReactions->reaction[j]))) {
					log_sys ("checkReactions_GMA: failed.\n");
					goto err;
				}
			}

			/* variables[] Υåȹ̼κ */
			if (createTotalEnzymeEq (tempInfo)) {
				log_sys ("createTotalEnzymeEq: failed.\n");
				goto err;
			}

			/* Ѵ */
			for (j = 0; j < listOfReactions->numberOfReactions; j++) {
				convertReaction_GMA (tempInfo, &(listOfReactions->reaction[j]), convType);
			}
		}
	}

	/* ˥ǥåդ */
	NumberConstantPlayers (tempInfo);

#ifdef DEBUG_G
	fprintf (stdout, "ReadReactions_GMA: end.\n");
	fflush (stdout);
#endif

	return 0;
  err:
	return -1;
}
