/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         XML եɤ߹
 *
 ***********************************************************************/

#include "parsedae.h"

/**
 * SpecieReference Ѵ
 */
static void convertSpecieReference (CSpecieReference_t *specieReference, JSpecieReference_t *jspecieReference) {
	/* specieID */
	specieReference->specieID = jspecieReference->specieID;
	/* name */
	memcpy (specieReference->name, jspecieReference->name, sizeof(specieReference->name));
	/* compartment */
	specieReference->compartment = jspecieReference->compartment;
	/* stoichiometry */
	sscanf (jspecieReference->stoichiometry, "%lE", &(specieReference->stoichiometry));
}

/**
 * ModifierComplex Ѵ
 */
static void convertModifierComplex (CListOfPlayers_t *listOfPlayers, JModifierComplex_t *jmodifierComplex) {
	/* numberOfModifiers */
	listOfPlayers->numberOfPlayers = 1;
	/* modifierComplex */
	listOfPlayers->specieReference = (CSpecieReference_t[]) calloc (1, sizeof(CSpecieReference_t));
	convertSpecieReference(&(listOfPlayers->specieReference[0]), &(jmodifierComplex->specieReference));
}

/**
 * ModifierSpecieReference Ѵ
 */
static void convertModifierSpecieReference (CSpecieReference_t *specieReference, JModifierSpecieReference_t *jmodifierSpecieReference) {
	/* specieID */
	specieReference->specieID = jmodifierSpecieReference->specieID;
	/* name */
	memcpy (specieReference->name, jmodifierSpecieReference->name, sizeof(specieReference->name));
	/* compartment */
	specieReference->compartment = jmodifierSpecieReference->compartment;
	/* stoichiometry */
	sscanf (jmodifierSpecieReference->stoichiometry, "%lE", &(specieReference->stoichiometry));
	/* modifierType */
	specieReference->modifierType = jmodifierSpecieReference->modifierType;
	/* isTotal */
	specieReference->isTotal = jmodifierSpecieReference->isTotal;
}

/**
 * ListOfModifiers Ѵ
 */
static void convertListOfModifiers (CListOfPlayers_t *listOfPlayers, JListOfModifiers_t *jlistOfModifiers) {
	int i;

	/* numberOfModifiers */
	listOfPlayers->numberOfPlayers = jlistOfModifiers->numberOfModifiers;
	/* modifier */
	listOfPlayers->specieReference = (CSpecieReference_t[]) calloc (listOfPlayers->numberOfPlayers, sizeof(CSpecieReference_t));
	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		convertModifierSpecieReference(&(listOfPlayers->specieReference[i]), &(jlistOfModifiers->modifierSpecieReference[i]));
	}
}

/**
 * ListOfProducts Ѵ
 */
static void convertListOfProducts (CListOfPlayers_t *listOfPlayers, JListOfProducts_t *jlistOfProducts) {
	int i;

	/* numberOfProducts */
	listOfPlayers->numberOfPlayers = jlistOfProducts->numberOfProducts;
	/* product */
	listOfPlayers->specieReference = (CSpecieReference_t[]) calloc (listOfPlayers->numberOfPlayers, sizeof(CSpecieReference_t));
	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		convertSpecieReference(&(listOfPlayers->specieReference[i]), &(jlistOfProducts->specieReference[i]));
	}
}

/**
 * ListOfReactants Ѵ
 */
static void convertListOfReactants (CListOfPlayers_t *listOfPlayers, JListOfReactants_t *jlistOfReactants) {
	int i;

	/* numberOfReactants */
	listOfPlayers->numberOfPlayers = jlistOfReactants->numberOfReactants;
	/* reactant */
	listOfPlayers->specieReference = (CSpecieReference_t[]) calloc (listOfPlayers->numberOfPlayers, sizeof(CSpecieReference_t));
	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		convertSpecieReference(&(listOfPlayers->specieReference[i]), &(jlistOfReactants->specieReference[i]));
	}
}

/**
 * Reaction Ѵ
 */
static void convertReaction (CReaction_t *reaction, JReaction_t *jreaction) {
	int i;

	/* reactionID */
	reaction->reactionID = jreaction->reactionID;
	/* groupID */
	reaction->groupID = jreaction->groupID;
	/* reactionType */
	reaction->reactionType = jreaction->reactionType;
	/* isConvertible */
	reaction->isConvertible = jreaction->isConvertible;
	/* modifierReactionEquation */
	reaction->modifierReactionEquation = strdup (jreaction->modifierReactionEquation);

	/* listOfReactants_n */
	reaction->listOfReactants_n = jreaction->listOfReactants_n;
	/* listOfReactants */
	if (reaction->listOfReactants_n > 0) {
		reaction->listOfReactants = (CListOfPlayers_t[]) calloc (reaction->listOfReactants_n, sizeof(CListOfPlayers_t));
	} else {
		reaction->listOfReactants = NULL;
	}
	for (i = 0; i < reaction->listOfReactants_n; i++)
		convertListOfReactants(&(reaction->listOfReactants[i]), &(jreaction->listOfReactants[i]));

	/* listOfProducts_n */
	reaction->listOfProducts_n = jreaction->listOfProducts_n;
	/* listOfProducts */
	if (reaction->listOfProducts_n > 0) {
		reaction->listOfProducts = (CListOfPlayers_t[]) calloc (reaction->listOfProducts_n, sizeof(CListOfPlayers_t));
	} else {
		reaction->listOfProducts = NULL;
	}
	for (i = 0; i < reaction->listOfProducts_n; i++)
		convertListOfProducts(&(reaction->listOfProducts[i]), &(jreaction->listOfProducts[i]));

	/* listOfModifiers_n */
	reaction->listOfModifiers_n = jreaction->listOfModifiers_n;
	/* listOfModifiers */
	if (reaction->listOfModifiers_n > 0) {
		reaction->listOfModifiers = (CListOfPlayers_t[]) calloc (reaction->listOfModifiers_n, sizeof(CListOfPlayers_t));
	} else {
		reaction->listOfModifiers = NULL;
	}
	for (i = 0; i < reaction->listOfModifiers_n; i++)
		convertListOfModifiers(&(reaction->listOfModifiers[i]), &(jreaction->listOfModifiers[i]));

	/* modifierComplex_n */
	reaction->modifierComplex_n = jreaction->modifierComplex_n;
	/* modifierComplex */
	if (reaction->modifierComplex_n > 0) {
		reaction->modifierComplex = (CListOfPlayers_t[]) calloc (reaction->modifierComplex_n, sizeof(CListOfPlayers_t));
	} else {
		reaction->modifierComplex = NULL;
	}
	for (i = 0; i < reaction->modifierComplex_n; i++)
		convertModifierComplex(&(reaction->modifierComplex[i]), &(jreaction->modifierComplex[i]));
}


/**
 * դĤ Player ΥꥹȤҤȤĤˤޤȤ롣
 */
void mergePlayers (CListOfPlayers_t *merger, CListOfPlayers_t *mergee) {
	int			i, index;
	int			newPlayers_n;
	CSpecieReference_t	*newPlayers;

	newPlayers_n = merger->numberOfPlayers + mergee->numberOfPlayers;
	newPlayers = (CSpecieReference_t[]) calloc (newPlayers_n, sizeof(CSpecieReference_t));

	index = 0;

	for (i = 0; i < merger->numberOfPlayers; i++, index++) {
		memcpy (&(newPlayers[index]), &(merger->specieReference[i]), sizeof(CSpecieReference_t));
	}
	for (i = 0; i < mergee->numberOfPlayers; i++, index++) {
		memcpy (&(newPlayers[index]), &(mergee->specieReference[i]), sizeof(CSpecieReference_t));
	}

	free (merger->specieReference);

	merger->numberOfPlayers = newPlayers_n;
	merger->specieReference = newPlayers;
}

/**
 * groupID Ʊ reactionType  transcription ΤΤޤȤ
 */
static void assembleReactions (CListOfReactions_t *listOfReactions) {
	int			i, j, index;
	int			numberOfReactions;
	int			groupID;
	CReaction_t		*reaction;
	CReaction_t		*target;
	CListOfReactions_t	*newReactions;
	char			*buff;

#ifdef DEBUG_IX
	printf ("assembleReactions start.\n");
#endif
	buff = (char*) calloc (1, BUFFSIZE);

	newReactions = (CListOfReactions_t*) calloc (1, sizeof(CListOfReactions_t));
	numberOfReactions = listOfReactions->numberOfReactions;

	/* reactionType  transcription ΤΤФˤޤȤ뤳Ȥ
	   Ǥ reaction õƤޤȤᡢޤȤ줿¦ reactionType 
	   NONE ꤹ롣
	   Ʊ reactionType  NONE ǤʤΤοƤ */
	for (i = 0; i < numberOfReactions; i++) {
		reaction = &(listOfReactions->reaction[i]);
		switch (reaction->reactionType) {
		case REACTION_REACTIONTYPE_TRANSCRIPTION:
			groupID = reaction->groupID;
			for (j = i+1; j < numberOfReactions; j++) {
				target = &(listOfReactions->reaction[j]);
				if (target->reactionType == REACTION_REACTIONTYPE_TRANSCRIPTION &&
				    target->groupID == groupID) {
					target->reactionType = REACTION_REACTIONTYPE_NONE;
					mergePlayers (reaction->listOfModifiers, target->listOfModifiers);
					snprintf (buff, BUFFSIZE, "%s</br>\n            %s", reaction->modifierReactionEquation, target->modifierReactionEquation);
					free (reaction->modifierReactionEquation);
					reaction->modifierReactionEquation = strdup (buff);
				}
			}
			break;
		case REACTION_REACTIONTYPE_NONE:
			/* reactionType == NONE ʤ newReactions_n++ ʤ */
			continue;
		default:
			break;
		}
		(newReactions->numberOfReactions)++;
	}

	newReactions->reaction = (CReaction_t*) calloc (newReactions->numberOfReactions, sizeof(CReaction_t));
	index = 0;

	/* reactionType  NONE ǤʤΤ newReactions ˥ԡ롣*/
	for (i = 0; i < numberOfReactions; i++) {
		reaction = &(listOfReactions->reaction[i]);
		if (reaction->reactionType != REACTION_REACTIONTYPE_NONE) {
			memcpy (&(newReactions->reaction[index]), reaction, sizeof(CReaction_t));
			index++;
		}
	}
	free (listOfReactions->reaction);

	/* newReactions Ȥ listOfReactions ˥ԡ֤ */
	listOfReactions->reaction = newReactions->reaction;
	listOfReactions->numberOfReactions = newReactions->numberOfReactions;
	free (newReactions);

	free (buff);

#ifdef DEBUG_IX
	printf ("assembleReactions end.\n");
#endif
	return;
}

/**
 * ListOfReactions Ѵ
 */
static void convertListOfReactions (CListOfReactions_t *listOfReactions, JListOfReactions_t *jlistOfReactions) {
	int i;

#ifdef DEBUG_IX
	printf ("convertListOfReactions start.\n");
#endif
	/* layer */
	listOfReactions->layer = jlistOfReactions->layer;
	/* numberOfReactions */
	listOfReactions->numberOfReactions = jlistOfReactions->numberOfReactions;
	/* reaction */
	listOfReactions->reaction = (CReaction_t[]) calloc (listOfReactions->numberOfReactions, sizeof(CReaction_t));
	for (i = 0; i < listOfReactions->numberOfReactions; i++) {
		convertReaction(&(listOfReactions->reaction[i]), &(jlistOfReactions->reaction[i]));
	}

	/* groupID Ʊ reactionType  transcription ΤΤޤȤ */
	assembleReactions (listOfReactions);

#ifdef DEBUG_IX
	printf ("convertListOfReactions end.\n");
#endif
}

/**
 * ListOfElements Ѵ
 */
static void convertListOfElements (CListOfPlayers_t *listOfPlayers, JListOfElements_t *jlistOfElements) {
	int i;

	/* numberOfElements */
	listOfPlayers->numberOfPlayers = jlistOfElements->numberOfElements;
	/* element */
	listOfPlayers->specieReference = (CSpecieReference_t[]) calloc (listOfPlayers->numberOfPlayers, sizeof(CSpecieReference_t));
	for (i = 0; i < listOfPlayers->numberOfPlayers; i++) {
		convertSpecieReference(&(listOfPlayers->specieReference[i]), &(jlistOfElements->specieReference[i]));
	}
}

/**
 * SpecieAttribute Ѵ
 */
static void convertSpecieAttribute (CSpecieAttribute_t *specieAttribute, JSpecieAttribute_t *jspecieAttribute) {
	/* specieClass */
	specieAttribute->specieClass = jspecieAttribute->specieClass;
	/* massBalance */
	specieAttribute->massBalance = jspecieAttribute->massBalance;
	/* totalAmount */
	specieAttribute->totalAmount = jspecieAttribute->totalAmount;
	/* decomposition */
	specieAttribute->decomposition = jspecieAttribute->decomposition;
	/* initialAmount_isValid */
	specieAttribute->initialAmount_isValid = jspecieAttribute->initialAmount_isValid;
	/* initialAmount */
	sscanf (jspecieAttribute->initialAmount, "%lE", &(specieAttribute->initialAmount));
}

/**
 * Specie Ѵ
 */
static void convertSpecie (CSpecie_t *specie, JSpecie_t *jspecie) {
	int i;

	/* specieID */
	specie->specieID = jspecie->specieID;
	/* name */
	memcpy (specie->name, jspecie->name, sizeof(specie->name));
	/* compartment */
	specie->compartment = jspecie->compartment;
	/* specieAttribute */
	convertSpecieAttribute(&(specie->specieAttribute), &(jspecie->specieAttribute));
	/* listOfElements_n */
	specie->listOfElements_n = jspecie->listOfElements_n;
	/* listOfElements */
	if (specie->listOfElements_n > 0) {
		specie->listOfElements = (CListOfPlayers_t[]) calloc (specie->listOfElements_n, sizeof(CListOfPlayers_t));
	} else {
		specie->listOfElements = NULL;
	}
	for (i = 0; i < specie->listOfElements_n; i++) {
		convertListOfElements (&(specie->listOfElements[i]), &(jspecie->listOfElements[i]));
	}
}

/**
 * ListOfSpecies Ѵ
 */
static void convertListOfSpecies (CListOfSpecies_t *listOfSpecies, JListOfSpecies_t *jlistOfSpecies) {
	int i;

	/* numberOfSpecies */
	listOfSpecies->numberOfSpecies = jlistOfSpecies->numberOfSpecies;
	/* specie */
	listOfSpecies->specie = (CSpecie_t[]) calloc (listOfSpecies->numberOfSpecies, sizeof(CSpecie_t));
	for (i = 0; i < listOfSpecies->numberOfSpecies; i++) {
		convertSpecie (&(listOfSpecies->specie[i]), &(jlistOfSpecies->specie[i]));
	}
}

/**
 * Compartment Ѵ
 */
static void convertCompartment (CCompartment_t *compartment, JCompartment_t *jcompartment) {
	/* compartmentID */
	compartment->compartmentID = jcompartment->compartmentID;
	/* name */
	memcpy (compartment->name, jcompartment->name, sizeof(compartment->name));
	/* suffix */
	sprintf (compartment->suffix, "%.3s", compartment->name);
	/* volume */
	sscanf (jcompartment->volume, "%lE", &(compartment->volume));
}

/**
 * ListOfCompartments Ѵ
 */
static void convertListOfCompartments (CListOfCompartments_t *listOfCompartments, JListOfCompartments_t *jlistOfCompartments) {
	int i;

	/* numberOfCompartments */
	listOfCompartments->numberOfCompartments = jlistOfCompartments->numberOfCompartments;
	/* compartment */
	listOfCompartments->compartment = (CCompartment_t[]) calloc (listOfCompartments->numberOfCompartments, sizeof(CCompartment_t));
	for (i = 0; i < listOfCompartments->numberOfCompartments; i++) {
		convertCompartment(&(listOfCompartments->compartment[i]), &(jlistOfCompartments->compartment[i]));
	}
}

/**
 * Model Ѵ
 */
static void convertModel (CModel_t *model, JModel_t *jmodel) {
	int i;

#ifdef DEBUG_IX
	printf ("convertModel start.\n");
#endif

	/* name */
	memcpy (model->name, jmodel->name, sizeof(model->name));
	/* modelInfo */
	memcpy (model->modelInfo, jmodel->modelInfo, sizeof(model->modelInfo));
	/* listOfCompartments */
	convertListOfCompartments(&(model->listOfCompartments), &(jmodel->listOfCompartments));
	/* listOfSpecies */
	convertListOfSpecies(&(model->listOfSpecies), &(jmodel->listOfSpecies));
	/* listOfReactions_n */
	model->listOfReactions_n = jmodel->listOfReactions_n;
	/* listOfReactions */
	if (model->listOfReactions_n > 0) {
		model->listOfReactions = (CListOfReactions_t[]) calloc (model->listOfReactions_n, sizeof(CListOfReactions_t));
	} else {
		model->listOfReactions = NULL;
	}
	for (i = 0; i < model->listOfReactions_n; i++) {
		convertListOfReactions(&(model->listOfReactions[i]), &(jmodel->listOfReactions[i]));
	}

#ifdef DEBUG_IX
	printf ("convertModel end.\n");
#endif
}

/**
 * SANAC  XML ե뤫̿ȿǥɤ߹ࡣ
 */
int ParseXML (char *filename, CModel_t *model, OutputInfo_t *outputInfo, int filetype)
{
	jint		result;
	jmethodID	method_id;

	MM_DATA_t	*mm_data = NULL;

	JModelPack_t	*jmodelpack = NULL;

	jstring		jfilename;
	jint		jfiletype;

	jclass		jmodelpack_class;
	jobject		jmodelpack_object;
	jclass		inputXML_class;
	jobject		inputXML_object;

#ifdef DBG
	DBGW(10, ("===> parseXML enter filename[%s], filetype[%d]\n", filename, filetype));
#endif

#ifdef DEBUG_IX
	fprintf (stdout, "ParseXML: start.\n");
	fflush (stdout);
#endif

	/* JModelPack 饹 */
	jmodelpack_class = env->FindClass("jp/co/suri/lifesim/JModelPack");
	if (jmodelpack_class == 0) {
		log_sys ("Can't find JModelPack class\n");
		goto err;
	}

	/* JModelPack Υ󥹥ȥ饯Υ᥽å ID ֥Ⱥ */
	method_id = env->GetMethodID(jmodelpack_class, "<init>", "()V");
	if (method_id == 0) {
		log_sys ("Can't find JModelPack.init\n");
		goto err;
	}
	jmodelpack_object = env->NewObject(jmodelpack_class, method_id);
	if (jmodelpack_object == 0) {
		log_sys ("Can't create JModelPack()\n");
		goto err;
	}

	/* InputXML 饹 */
	inputXML_class = env->FindClass("jp/co/suri/lifesim/InputXML");
	if (inputXML_class == 0) {
		log_sys ("Can't find InputXML class\n");
		goto err;
	}

	/* InputXML Υ󥹥ȥ饯Υ᥽å ID ֥Ⱥ */
	method_id = env->GetMethodID(inputXML_class, "<init>", "()V");
	if (method_id == 0) {
		log_sys ("Can't find InputXML.init\n");
		goto err;
	}
	inputXML_object = env->NewObject(inputXML_class, method_id);
	if (inputXML_object == 0) {
		log_sys ("Can't create InputXML()\n");
		goto err;
	}

	/* InputXML  parseXML ᥽åɤΥ᥽å ID ƤӽФ */
	method_id = env->GetMethodID(inputXML_class, "parseXML", "(Ljava/lang/String;ILjp/co/suri/lifesim/JModelPack;)I");
	if (method_id == 0) {
		log_sys ("Can't find InputXML.parseXML\n");
		goto err;
	}
	jfilename = env->NewStringUTF (filename);
	jfiletype = (jint)filetype;
	result = env->CallIntMethod(inputXML_object, method_id, jfilename, jfiletype, jmodelpack_object);
	if (result != 0) {
		log_sys ("parseXML ERROR!\n");
		goto err;
	}

	/* parseXML ֤줿֥Ȥ¤ΤѴ */
	/* - 饹̾MM_DATA_t */
	if (JU_clsname2mmd("jp/co/suri/lifesim/JModelPack", &mm_data)) {
		log_sys ("no mmd[jp/co/suri/lifesim/JModelPack]\n");
		goto err;
	}

	/* ¤ΰ */
	jmodelpack = (JModelPack_t*) calloc (1, mm_data->struct_size);

	/* ֥(java) -> ¤(C) Ѵ */
	if (JU_convert_j2c(env, mm_data, jmodelpack_object, jmodelpack, '\0')) {
		log_sys ("can't convert j2c class-name \n");
		goto err;
	}

	/* ꥶȥɤ NG ʤ饨顼 */
	if (jmodelpack->result == PARSEDAE_NG) {
		log_sys (jmodelpack->errmsg);
		goto err;
	}

	/* Java Ȥ I/F ѹ¤ -> C ѹ¤Ѵ */
	convertModel (model, &(jmodelpack->model));

#ifdef DEBUG_IX
	fprintf (stdout, "ParseXML: end.\n");
	fflush (stdout);
#endif

#ifdef DBG
	DBGW(10, ("===> parseXML exit(0)\n"));
#endif
	return 0;
err:
#ifdef DBG
	DBGW(10, ("===> parseXML exit(-1)\n"));
#endif
	return -1;
}
