#include "parsedae.h"

#ifndef WIN32
  #include	<unistd.h>
#endif /* WIN32 */

JNIEnv		*env;

/**
 * ʸ󤫤Ѵꤹ롣
 *
 * (convTypeStr[]  CONVTYPE_*  HeaderInfo.h )
 *
 * @param convType Ѵꤹ
 * @return convType б CONVTYPE_* ͡
 */
static int checkConvType(char *convType) {
	int ret = 0;

	if (strncmp(convType, convTypeStr[CONVTYPE_CMA], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_CMA;
	} else if (strncmp(convType, convTypeStr[CONVTYPE_TPP_SS1], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_TPP_SS1;
	} else if (strncmp(convType, convTypeStr[CONVTYPE_TPP_SS2], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_TPP_SS2;
	} else if (strncmp(convType, convTypeStr[CONVTYPE_TPP_RAPID], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_TPP_RAPID;
	} else if (strncmp(convType, convTypeStr[CONVTYPE_GMA], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_GMA;
	} else if (strncmp(convType, convTypeStr[CONVTYPE_MM], BUFFSIZE_CONVTYPE) == 0) {
		ret = CONVTYPE_MM;
	} else {
		ret = CONVTYPE_NONE;
	}

	return ret;
}

/**
 * եʥ饤
 */
static void finalize(FILE *usage_fp, FILE *dae_fp, char *xmlFilename) {
	if (usage_fp)
		fclose (usage_fp);
	if (dae_fp)
		fclose (dae_fp);
	if (xmlFilename)
		free (xmlFilename);
}

/**
 *  convertphp εǽƸ롣
 *
 * @param xmlFilename sanac ǽ񤫤줿ϥե
 * @param model ϥե뤫ɤ߹ǡǼ sanac  Model ¤
 * @param outputInfo ѥǡݻ뤿ι¤
 * @return ｪλʤ 0 顼ʤ -1
 */
static int convertphp(FILE *fp, char *xmlFilename, CModel_t *model, OutputInfo_t *outputInfo) {

	if (ParseXML (xmlFilename, model, outputInfo, PARSEDAE_FILETYPE_SANAC) < 0) {
		log_sys ("ParseXML failed.\n");
		goto err;
	}

	ConvertPHP (fp, outputInfo, model);

	return 0;
  err:
	return -1;
}

/**
 * sanac  XML եɤ߹ߡѴ롣
 *
 * @param xmlFilename sanac ϥե롣
 * @param model ɤ߹ǡǼ sanac  Model 빽¤Ρ
 * @param outputInfo ѤΥǡǼ빽¤Ρ
 * @param usage_fp usage եΥեݥ󥿡
 * @param dae_fp DAE եΥեݥ󥿡
 * @return ｪλʤ 0 顼ʤ -1 
 */
static int parseNCE (char *xmlFilename, CModel_t *model, OutputInfo_t *outputInfo, FILE *usage_fp, FILE *dae_fp) {
	/* SANAC  XML ե뤫̿ȿǥɤ߹ࡣ*/
	if (ParseXML (xmlFilename, model, outputInfo, PARSEDAE_FILETYPE_SANAC) < 0) {
		log_sys ("ParseXML failed.\n");
		goto err;
	}

	/* Ͼơ֥ι */
	if (MakeOutputInfo (model, outputInfo, PARSEDAE_FILETYPE_SANAC) < 0) {
		log_sys ("MakeOutputInfo failed.\n");
		goto err;
	}

	/* Usage եν */
	MakeOutputFile (usage_fp, outputInfo, PARSEDAE_FILETYPE_SANAC, OUTPUT_TYPE_USAGE);

	/* DAE եν */
	MakeOutputFile (dae_fp, outputInfo, PARSEDAE_FILETYPE_SANAC, OUTPUT_TYPE_DAE);

	return 0;
  err:
	return -1;
}

/**
 * ˥饤
 */
static int initialize (int argc, char *argv[], int *processType, char **xmlFilename, HeaderInfo_t *headerInfo, FILE **usage_fp, FILE **dae_fp, FILE **convertphp_fp) {
	int		i;
	int		fout = 0;
	char		inFilename[BUFFSIZE_FILENAME];
	char		usageFilename[BUFFSIZE_FILENAME];
	char		daeFilename[BUFFSIZE_FILENAME];
	char		convertphpFilename[BUFFSIZE_FILENAME];
	struct stat	st;
	char		convType[NAME_LENGTH];

	*processType = PROCESS_TYPE_NONE;
	memset (usageFilename, 0, sizeof(usageFilename));
	memset (daeFilename,   0, sizeof(daeFilename));
	memset (convertphpFilename,   0, sizeof(convertphpFilename));
	memset (inFilename,    0, sizeof(inFilename));
	memset (convType,   0, sizeof(convType));

	for (i = 0; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case 'N':
				*processType = *processType | PROCESS_TYPE_PARSEDAE_SANAC;
				strncpy (inFilename, &argv[i][2], sizeof(inFilename));
				break;
#if 0

			case 'M':
				*processType = *processType | PROCESS_TYPE_PARSEDAE_DIRECT;
				strncpy (inFilename, &argv[i][2], sizeof(inFilename));
				break;
#endif /* 0 */
			case 'C':
				*processType = *processType | PROCESS_TYPE_CONVERTPHP;
				strcpy (inFilename, &argv[i][2]);
				break;
			case 'U':
				strncpy (usageFilename, &argv[i][2], sizeof(usageFilename));
				break;
			case 'D':
				strncpy (daeFilename, &argv[i][2], sizeof(daeFilename));
				break;
			case 'P':
				strncpy (convertphpFilename, &argv[i][2], sizeof(convertphpFilename));
				break;
			case 'g':
				strncpy (convType, &argv[i][2], sizeof(convType)-1);
				headerInfo->convType_GeneProtein = checkConvType(convType);
				break;
			case 'm':
				strncpy (convType, &argv[i][2], sizeof(convType)-1);
				headerInfo->convType_Metabolic = checkConvType(convType);
				break;
			case 'd':
				break;
			default:
				log_sys ("initialize: invarid argument !!\n");
				goto err;
			}
		}
	}

	switch (*processType) {
	case PROCESS_TYPE_PARSEDAE_SANAC:
		/* SANAC ξѴå */
		switch (convType_rough[headerInfo->convType_GeneProtein]) {
		case CONVTYPE_CMA:
			break;
		case CONVTYPE_GMA:
			log_sys ("initialize: 'GMA' and 'MM' are not allowed for Gene-Protein layer.\n");
			goto err;
			break;
		case CONVTYPE_NONE:
			switch (headerInfo->convType_Metabolic) {
			case CONVTYPE_NONE:
				log_sys ("initialize: The conversion method is not specified to both Gene-Protein and Metabolic layer.\n");
				goto err;
			}
			break;
		}
		/* եåԤ break ʤ */
	case PROCESS_TYPE_PARSEDAE_DIRECT:
		/* SANAC/DIRECT ξեå */
		if (usageFilename[0] == 0 || daeFilename[0] == 0) {
			log_sys ("initialize: invalid outputfile name!!\n");
			goto err;
		}
		if ((*usage_fp = fopen(usageFilename, "w")) == NULL) {
			log_sys ("initialize: usagefile[%s] open err!!\n", usageFilename);
			goto err;
		}
		if ((*dae_fp = fopen(daeFilename, "w")) == NULL) {
			log_sys ("initialize: daefile[%s] open err!!\n", daeFilename);
			goto err;
		}
		break;
	case PROCESS_TYPE_CONVERTPHP:
		if (convertphpFilename[0] == 0) {
			log_sys ("initialize: invalid outputfile name!!\n");
			goto err;
		}
		if ((*convertphp_fp = fopen(convertphpFilename, "w")) == NULL) {
			log_sys ("initialize: convertphpfile[%s] open err!!\n", convertphpFilename);
			goto err;
		}
		break;
	default:
		log_sys ("initialize: The processing method is not set up correctly.\n");
		goto err;
	}

	*xmlFilename = strdup (inFilename);
	if (stat (*xmlFilename, &st) < 0) {
		log_sys ("initialize: xmlfile[%s] open err!!\n", *xmlFilename);
		goto err;
	}

	return 0;
  err:
	return -1;
}

/**
 * ᥤ
 */
int main (int argc, char *argv[]) {
	char		*xmlFilename = NULL;
	int		processType = 0;
	JavaVM		*jvm;

	char		*sanac_home;
	char		*xerces_home;
	char		classpath[BUFFSIZE];
	char		libpath[BUFFSIZE];

	CModel_t	model;
	OutputInfo_t	outputInfo;

	FILE		*usage_fp = NULL;
	FILE		*dae_fp = NULL;
	FILE		*convertphp_fp = NULL;

	JavaVMInitArgs	vm_args;
	JavaVMOption	options[3];
	jint		result;

	/*  */
	memset (&model, 0, sizeof(model));
	memset (&outputInfo, 0, sizeof(outputInfo));

	/* Ķѿɤ߽Ф */
	sanac_home  = getenv ("SANAC_HOME");
	xerces_home = getenv ("XERCES_HOME");

	/* Java VM ưѥ᡼ */
	options[0].optionString = JVM_OPTION_JIT;
	sprintf (classpath, JVM_OPTION_CLASSPATH, sanac_home, xerces_home, xerces_home);
	sprintf (libpath,   JVM_OPTION_LIBPATH,   sanac_home);
	options[1].optionString = classpath;
	options[2].optionString = libpath;
	vm_args.version = JNI_VERSION_1_4;
	vm_args.options = options;
	vm_args.nOptions = 3;
	vm_args.ignoreUnrecognized = JNI_TRUE;
	JNI_GetDefaultJavaVMInitArgs (&vm_args);

	/* Java VM εư */
	if ((result = JNI_CreateJavaVM (&jvm, (void**)&env, &vm_args)) < 0) {
		log_sys ("Can't create Java VM [%d]\n", result);
		goto err;
	}


#ifdef DBG
	// open debug-log file.
	if (log_dbginit (argc, argv) < 0) {
		printf ("Cannot open dbgLog file!!");
		return -2;
	}
#endif

	// open sys-log file.
	if (log_sysinit (argc, argv) < 0) {
		printf ("Cannot open sysLog file!!");
		return -1;
	}

	// Initialize argument, file
	if (initialize (argc, argv, &processType, &xmlFilename, &(outputInfo.headerInfo), &usage_fp, &dae_fp, &convertphp_fp) < 0) {
		log_sys ("initialization failed.\n");
		goto err;
	}

	/* ̤˱ʬ */
	switch (processType) {
	case PROCESS_TYPE_PARSEDAE_SANAC:
		if (parseNCE (xmlFilename, &model, &outputInfo, usage_fp, dae_fp) < 0) {
			log_sys ("parseNCE failed.\n");
			goto err;
		}
		break;
	case PROCESS_TYPE_PARSEDAE_DIRECT:
		/*  */
		break;
	case PROCESS_TYPE_CONVERTPHP:
		if (convertphp (convertphp_fp, xmlFilename, &model, &outputInfo) < 0) {
			log_sys ("convertphp failed.\n");
			goto err;
		}
		break;
	}

	/* finalize */
	(jvm)->DestroyJavaVM();
	finalize (usage_fp, dae_fp, xmlFilename);

	log_sysfinalize ();
#ifdef DBG
	log_dbgfinalize ();
#endif
	return 0;
err:
	log_sysfinalize();
#ifdef DBG
	log_dbgfinalize();
#endif
	return -1;
}
