/***********************************************************************
 *
 *     ̿ߥ졼
 *
 *         ʬΥˡ˱
 *
 ***********************************************************************/

#include "parsedae.h"

static int moveMonomerEqs(TempInfo_t *tempInfo, int n_var);
static int makeTotalDiffEqs(TempInfo_t *tempInfo, int n_var);
static int makeTotalAlgebraicEqs(TempInfo_t *tempInfo, int n_var);
static int calcInitialVal(TempInfo_t *tempInfo, int n_var);
static int refineComplexEqs(TempInfo_t *tempInfo, int n_var);
static double haveThisMonomer(Player_t *players, int index_m, int index_c, int n_player);
static int addExpression(Equation_t *targetEq, Term_t *addExpr, double coeff);


/*-------------------- setTPP()--------------------------------------------
 * CMAǺ줿ѿ󤪤ʬ򸵤ʬΥѴ롣
 *
 * Gene-ProteinؤTPPꤵƤʤв⤷ʤMetabolicؤȤ
 * ѴȤ߹碌ˤĤƤϤȽǤƤΤȤ롣
 * 
 */
int SetTPP (TempInfo_t *tempInfo)
{
	int		my_type = tempInfo->convType_GeneProtein;
	int		n_var = tempInfo->numberOfSpecies;

	if (my_type != CONVTYPE_TPP_SS1 && my_type != CONVTYPE_TPP_SS2
				   					&& my_type != CONVTYPE_TPP_RAPID) {
		return 0;
	}

	/* 
	 * ȿ˴ͿΥޡʬTotal˰ܤ
	 */
	if (moveMonomerEqs(tempInfo, n_var)) goto err;

	/* 
	 * ȿ˴ͿΥޡTotalʬ롣
	 */
	if (makeTotalDiffEqs(tempInfo, n_var)) goto err;

	/* 
	 * ȿ˴ͿΥޡФ̹«򥻥åȤ롣
	 */
	if (makeTotalAlgebraicEqs(tempInfo, n_var)) goto err;

	/* 
	 * ȿ˴ͿΥޡTotalinitialValue׻롣
	 */
	if (calcInitialVal(tempInfo, n_var)) goto err;

	/* 
	 * TPPΥ٥˱Ʒȿ˴ͿComplexαռ򤹤롣
	 * RapidǤKbΤ٤νԤ
	 */
	if (refineComplexEqs(tempInfo, n_var)) goto err;

#if 0
	{
		int i;

		for (i=0; i<n_var; i++) {
			printf("%2d : %-30s F=%d, T=%d\n", i, tempInfo->variables[i].name,
							 tempInfo->variables[i].variableType,
							 tempInfo->variables_total[i].variableType);
		}
	}
#endif

	return 0;

err:
	log_sys("## Error!! in  SetTPP.\n");
	return -1;
}

/*-------------------- moveMonomerEqs()--------------------------------------------
 * ȿ˴ͿΥޡʬTotal˰ܤ
 *
 */
static int moveMonomerEqs(TempInfo_t *tempInfo, int n_var)
{
	int i;
	int monomer_type = VARIABLE_TYPE_ALGE_MONOMER;
	Player_t *variables = tempInfo->variables;
	Player_t *variablesT = tempInfo->variables_total;
	Equation_t *equations = tempInfo->equations;
	Equation_t *equationsT = tempInfo->equations_total;

	for (i=0; i<n_var; i++) {
		DBGW(20, ("%2d : %-20s f=%d\n", i, variables[i].name, variables[i].variableType));
		if (variables[i].variableType != monomer_type) continue;
		equationsT[i].rightPartTerms = equations[i].rightPartTerms;
		equations[i].rightPartTerms = NULL;
		variablesT[i].variableType = VARIABLE_TYPE_DIFF_CMA;
	}

	log_sys("## Pass moveMonomerEqs.\n\n");
	return 0;

err:
	log_sys("## Error!! in moveMonomerEqs.\n");
	return -1;
}

/*-------------------- makeTotalDiffEqs()--------------------------------------------
 * ȿ˴ͿΥޡTotalʬ롣
 *
 * 嵭ΥޡޤǤComplexʬstoichiometorỵ­Ǥ
 * ѿƱϷα黻ۤʤмꥹȤؤιղá
 *
 */
static int makeTotalDiffEqs(TempInfo_t *tempInfo, int n_var)
{
	int i, j, f_haveTerm;
	int complex_type = VARIABLE_TYPE_ALGE_COMPLEX;
	int monomer_type = VARIABLE_TYPE_ALGE_MONOMER;
	double coeff;
	Player_t *variables = tempInfo->variables;
	Player_t *variablesT = tempInfo->variables_total;
	Equation_t *equations = tempInfo->equations;
	Equation_t *equationsT = tempInfo->equations_total;
	Term_t *pt_target;

	for (i=0; i<n_var; i++) {
		if (variables[i].variableType != monomer_type) continue;
		DBGW(50, ("momomer:%s\n", variables[i].name));
		/* ȿ˴ͿΥޡˤĤ */
		for (j=0; j<n_var; j++) {
			if (variables[j].variableType != complex_type) continue;
			DBGW(50, ("complex:%s\n", variables[j].name));

			/* j ʣΤߤΥΥޡޤǤ뤫ɤĴ٤ */
			coeff = haveThisMonomer(variables, i, j, n_var);
			DBGW(50, ("coeff=%g\n", coeff));
			if (coeff < 0.0) goto err;
			if (coeff > 0.0) {
				/* ޤǤΤstoichiometryθ­碌 */
				if (addExpression(&equationsT[i], equations[j].rightPartTerms, coeff)) goto err;
			}
		}
	}

	/* ͭʹबĤäƤ뤫ɤΥå */
	for (i=0; i<n_var; i++) {
		if (variables[i].variableType != monomer_type) continue;
		pt_target = equationsT[i].rightPartTerms;
		f_haveTerm = PARSEDAE_FALSE;
		while (pt_target) {
			if (pt_target->coefficient.coefficient != 0.0) {
				f_haveTerm = PARSEDAE_TRUE;
				break;
			}
			pt_target = pt_target->next;
		}
		if (f_haveTerm == PARSEDAE_TRUE) {
			variablesT[i].variableType = VARIABLE_TYPE_DIFF_CMA;
			DBGW(10, ("## Total_%-30s have Terms.\n", variables[i].name));
		} else {
			variablesT[i].variableType = VARIABLE_TYPE_CONST;
			DBGW(10, ("## Total_%-30s is CONSTANT\n", variables[i].name));
		}
	}

	log_sys("## Pass makeTotalDiffEqs.\n\n");
	return 0;

err:
	log_sys("## Error!! in makeTotalDiffEqs.\n");
	return -1;
}

/*-------------------- haveThisMonomer()--------------------------------------------
 * ΥޡʣΤ˴ޤޤƤФι̤֤ޤޤƤʤХ֤
 *
 * index_mΥޡΥǥå
 * index_c嵭ΥޡޤޤƤ뤫ɤõоݤʣΤΥǥå
 *
 */
static double haveThisMonomer(Player_t *players, int index_m, int index_c, int n_player)
{
	int i, child_idx, childID;
	int n_element = players[index_c].numberOfElements;
	double val = 0.0, tmp_val;
	Player_t *target = &players[index_c];

	if (n_element == 0) {
		log_sys("## This is not a complex.\n");
		goto err;
	}

	for (i=0; i<n_element; i++) {
		childID = target->specieReference[i].specieID;
		child_idx = SearchPlayerBySpecieID(players, n_player, childID);
		if (players[child_idx].numberOfElements > 0) {
			/* ҤʣΤǤкƵŪĴ٤ */
			tmp_val = haveThisMonomer(players, index_m, child_idx, n_player);
			if (tmp_val < 0.0) goto err;
			val += tmp_val*target->specieReference[i].stoichiometry;
		}
		if (players[child_idx].specieID == players[index_m].specieID) {
			/* ҤоݥΥޡǤФstoichiometry̤­碌 */
			val += target->specieReference[i].stoichiometry;
		}
	}

	DBGW(30, ("## Pass haveThisMonomer.\n"));
	return val;

err:
	log_sys("## Error!! in haveThisMonomer.\n");
	return -1.0;
}

/*-------------------- addExpression()--------------------------------------------
 * Ĥαռ­碌롣ǸƤηݤȽǤ
 * ե饰֤
 *
 */
static int addExpression(Equation_t *targetEq, Term_t *addExpr, double coeff)
{
	int i;
	Term_t *pt_target, *pt_add, *pt_new;
	Variate_t *pv_target, *pv_add;

	pt_add = addExpr;
	while (pt_add) {
		DBGW(50, ("add   :%s\n", pt_add->variates->player->name));
		pt_target = targetEq->rightPartTerms;
		while (pt_target) {
			DBGW(50, ("target:%s\n", pt_target->variates->player->name));
			if (pt_add->coefficient.paramType == pt_target->coefficient.paramType && 
				pt_add->coefficient.paramIndex == pt_target->coefficient.paramIndex) {
				pv_target = pt_target->variates;
				pv_add = pt_add->variates;
				for (;;) {
					if (pv_add->powerCoefficient == pv_target->powerCoefficient && 
						pv_add->player->specieID == pv_target->player->specieID) {
						pv_add = pv_add->next;
						pv_target = pv_target->next;
						if (pv_add == NULL && pv_target == NULL) {
							/* ưפ coeff­Ǽadd */	
							pt_target->coefficient.coefficient += 
									pt_add->coefficient.coefficient*coeff;
							goto next_add;
						} else if (pv_add != NULL && pv_target != NULL) {
							/* ޤξȤѿ³-> ⤻variate */	
						} else {
							/* äƤޤä ΥåȤ */	
							break;
						}
					} else {
						/* 㤦 ΥåȤ */	
						break;
					}
				}
			}
			if (pt_target->next == NULL) {
				/* ǽΥåȤޤǰפΤʤпդä */	
				pt_new = (Term_t *)calloc(1, sizeof(Term_t));
				*pt_new = *pt_add;
				pt_new->coefficient.coefficient *= coeff;
				pt_new->next = NULL;
				AddTermToEquation(targetEq, pt_new);
				DBGW(50, ("add list AF addterm\n"));
				pt_target = pt_new;
			}
			pt_target = pt_target->next;
		}
next_add:
		pt_add = pt_add->next;
	}

	DBGW(30, ("## Pass addExpression.\n"));
	return 0;

err:
	log_sys("## Error!! in addExpression.\n");
	return -1;
}

/*-------------------- makeTotalAlgebraicEqs()--------------------------------------------
 * ȿ˴ͿΥޡФ̹«򥻥åȤ롣
 *
 */
static int makeTotalAlgebraicEqs(TempInfo_t *tempInfo, int n_var)
{
	int i, j;
	int monomer_type = VARIABLE_TYPE_ALGE_MONOMER;
	int complex_type = VARIABLE_TYPE_ALGE_COMPLEX;
	double coeff;
	Player_t *variables = tempInfo->variables;
	Equation_t *equations = tempInfo->equations;
	Term_t *newTerm;
	Parameter_t newParam;

	memset(&newParam, 0, sizeof(newParam));
	for (i=0; i<n_var; i++) {
		if (variables[i].variableType != monomer_type) continue;
		newTerm = MakeNewTerm(1.0, &newParam);
		AddVariateToTerm(newTerm, &variables[i], 1.0);
		equations[i].rightPartTerms = newTerm;
		for (j=0; j<n_var; j++) {
			if (variables[j].variableType != complex_type) continue;
			coeff = haveThisMonomer(variables, i, j, n_var);
			if (coeff < 0.0) goto err;
			if (coeff > 0.0) {
				newTerm = MakeNewTerm(coeff, &newParam);
				AddVariateToTerm(newTerm, &variables[j], 1.0);
				AddTermToEquation(&equations[i], newTerm);
			}
		}
	}

	log_sys("## Pass makeTotalAlgebraicEqs.\n\n");
	return 0;

err:
	log_sys("## Error!! in makeTotalAlgebraicEqs.\n");
	return -1;
}

/*-------------------- calcInitialVal()--------------------------------------------
 * ȿ˴ͿΥޡTotalinitialValue׻롣
 *
 */
static int calcInitialVal(TempInfo_t *tempInfo, int n_var)
{
	int i, j;
	int monomer_type = VARIABLE_TYPE_ALGE_MONOMER;
	int complex_type = VARIABLE_TYPE_ALGE_COMPLEX;
	Player_t *variables = tempInfo->variables;
	Player_t *variablesT = tempInfo->variables_total;
	Equation_t *equations = tempInfo->equations;
	double val, coeff;

	for (i=0; i<n_var; i++) {
		if (variables[i].variableType != monomer_type) continue;
		if (variables[i].initialAmount_isValid == PARSEDAE_FALSE) {
			variablesT[i].initialAmount_isValid = PARSEDAE_FALSE;
			continue;
		}
		val = variables[i].initialAmount;
		DBGW(20, ("# Total_Val own %s = %g\n", variables[i].name, val));
		for (j=0; j<n_var; j++) {
			if (variables[j].variableType != complex_type) continue;
			coeff = haveThisMonomer(variables, i, j, n_var);
			if (coeff < 0.0) goto err;
			if (coeff > 0.0) {
				if (variables[j].initialAmount_isValid == PARSEDAE_TRUE) {
					val += coeff*variables[j].initialAmount;
					DBGW(20, ("# Total_Val cmp %s = %g, coeff = %g\n",
								variables[j].name, variables[j].initialAmount, coeff));
				} else {
					variablesT[i].initialAmount_isValid = PARSEDAE_FALSE;
					goto no_value;
				}
			}
		}
		variablesT[i].initialAmount = val;
		variablesT[i].initialAmount_isValid = PARSEDAE_TRUE;

no_value:;
	}

	log_sys("## Pass calcInitialVal.\n\n");
	return 0;

err:
	log_sys("## Error!! in calcInitialVal.\n");
	return -1;
}

/*-------------------- refineComplexEqs()--------------------------------------------
 * TPPΥ٥˱Ʒȿ˴ͿComplexαռ򤹤롣
 * RapidǤKbΤ٤νԤ
 *
 */
static int refineComplexEqs(TempInfo_t *tempInfo, int n_var)
{
	int i, j, n_elem;
	int cnt_ka, cnt_kd, cnt_nonZero, cnt_delete;
	int del_ka_idx, del_kd_idx;
	int complex_type = VARIABLE_TYPE_ALGE_COMPLEX;
	int conv_type = tempInfo->convType_GeneProtein;
	Player_t *variables = tempInfo->variables;
	Equation_t *equations = tempInfo->equations;
	Term_t *pt_target;
	Variate_t *pv;
	double ka_power;

	DBGW(10, ("## refineComplexEqs in!!\n"));
	if (conv_type == CONVTYPE_TPP_SS1) {
		/* SteadyState1 λϲ⤷ʤ */
		return 0;
	} else if (conv_type != CONVTYPE_TPP_SS2 && conv_type != CONVTYPE_TPP_RAPID) {
		goto err;
	}

	/* kpd   kx ξõ */
	for (i=0; i<n_var; i++) {
		if (variables[i].variableType != complex_type) continue;
		cnt_ka = cnt_kd = cnt_nonZero = 0;
		DBGW(20, ("## %d, eq='%s'\n", i, variables[i].name));
		pt_target = equations[i].rightPartTerms;
		while (pt_target) {
			DBGW(20, ("## %d[%d]\n", pt_target->coefficient.paramType,
									 pt_target->coefficient.paramIndex));
			/* kpd ξõ */
			if (pt_target->coefficient.paramType == PARAM_TYPE_KPD) {
				pt_target->coefficient.coefficient = 0.0;
			}

			/* RAPIDξ kx õ */
			if (conv_type == CONVTYPE_TPP_RAPID) {
				if (pt_target->coefficient.paramType == PARAM_TYPE_KX) {
					pt_target->coefficient.coefficient = 0.0;
				}
			}

			/* RAPID Τλؿκ(ka) */
			if (pt_target->coefficient.coefficient != 0.0) {
				if (pt_target->coefficient.paramType == PARAM_TYPE_KA &&
					pt_target->coefficient.coefficient > 0.0) {
					/* RAPID Τλؿκ */
					if (conv_type == CONVTYPE_TPP_RAPID) {
						ka_power = 1.0;
						for (j=0; j<variables[i].numberOfElements; j++) {
							ka_power *= variables[i].specieReference[j].stoichiometry;
						}
						pt_target->coefficient.powerCoefficient = ka_power;
					}
				}
			}
			pt_target = pt_target->next;
		}
	}

	do {
		cnt_delete = 0;
		/* ˸ kakd Ф */
		for (i=0; i<n_var; i++) {
			if (variables[i].variableType != complex_type) continue;
			cnt_ka = cnt_kd = cnt_nonZero = 0;
			DBGW(20, ("## %d, eq='%s'\n", i, variables[i].name));
			pt_target = equations[i].rightPartTerms;
			while (pt_target) {
				DBGW(20, ("## %d[%d]\n", pt_target->coefficient.paramType,
										 pt_target->coefficient.paramIndex));
				/*  kskd Ф */
				if (pt_target->coefficient.coefficient != 0.0) {
					cnt_nonZero++;
					/*  ka Ф */
					if (pt_target->coefficient.paramType == PARAM_TYPE_KA &&
						pt_target->coefficient.coefficient > 0.0) {
						cnt_ka++;
						del_ka_idx = pt_target->coefficient.paramIndex;
					}
					/*  kd Ф */
					if (pt_target->coefficient.paramType == PARAM_TYPE_KD &&
						pt_target->coefficient.coefficient < 0.0) {
						cnt_kd++;
						del_kd_idx = pt_target->coefficient.paramIndex;
					}
				}
				pt_target = pt_target->next;
			}
	
			/* ǡγǧ */
			if (cnt_nonZero == 2 && cnt_ka == 1 && cnt_kd == 1) {
				if (del_ka_idx != del_kd_idx) {
					log_sys("#  This complex equation have 2 non-zero tarms.\n");
					log_sys("#  But + ka_index : %d, - kd_index : %d. Unknown error.\n",
								   	del_ka_idx, del_kd_idx);
					goto err;
				}
				equations[i].refineIndex = del_ka_idx;
				DBGW(20, ("## delete eq = '%s', index = %d\n", variables[i].name, del_ka_idx));
			} else if (cnt_nonZero == 2 && (cnt_ka != 1 || cnt_kd != 1)) {
				log_sys("#  This complex equation have 2 non-zero tarms.\n");
				log_sys("#  But +ka : %d, -kd : %d. Unknown error.\n", cnt_ka, cnt_kd);
				goto err;
			} else {
				equations[i].refineIndex = 0;
			}
		}
	
		DBGW(10, ("## end of delete kpd, kx\n"));
	
		/* kakd Υڥˤ뼰 */
		for (i=0; i<n_var; i++) {
			if (variables[i].variableType != complex_type) continue;
			if ((del_ka_idx = equations[i].refineIndex) < 1 ) continue;
			DBGW(10, ("i=%d, ka[%d] \n", i, del_ka_idx));
			for (j=0; j<n_var; j++) {
				cnt_ka = cnt_kd = 0;
				pt_target = equations[j].rightPartTerms;
				while (pt_target) {
					if (pt_target->coefficient.paramType == PARAM_TYPE_KA &&
						pt_target->coefficient.paramIndex == del_ka_idx &&
									pt_target->coefficient.coefficient < 0.0) {
						pt_target->coefficient.coefficient = 0.0;
						cnt_ka++;
						cnt_delete++;
						DBGW(10, ("j=%d, ka[%d] \n", j, pt_target->coefficient.paramIndex));
					}
					if (pt_target->coefficient.paramType == PARAM_TYPE_KD &&
						pt_target->coefficient.paramIndex == del_ka_idx &&
									pt_target->coefficient.coefficient > 0.0) {
						pt_target->coefficient.coefficient = 0.0;
						cnt_kd++;
						DBGW(10, ("j=%d, kd[%d] \n", j, pt_target->coefficient.paramIndex));
					}
					pt_target = pt_target->next;
				}
				if (cnt_ka == 1 && cnt_kd == 1) {
					/* ˾ä硣⤷ʤ */
					DBGW(20, ("## eq = '%s', del_idx = %d\n", variables[j].name, del_ka_idx));
				} else if (cnt_ka == 0 && cnt_kd == 0) {
					/* äΤʤä硣⤷ʤ */
				} else {
					log_sys("#  Eliminate ka : %d, kd : %d.\n", cnt_ka, cnt_kd);
					goto err;
				}
			}
		}
		DBGW(10, ("cnt_delete = %d\n", cnt_delete));
	} while (cnt_delete > 0);

	log_sys("## Pass refineComplexEqs.\n\n");
	return 0;

err:
	log_sys("## Error!! in refineComplexEqs.\n");
	return -1;
}
